---------------------------------------------------------
-             Visual Web Ripper 3.0.16
---------------------------------------------------------

Visual Web Ripper is created by Sequentum

www.sequentum.com

For support and other information about Visual Web Ripper,
Please visit:

www.visualwebripper.com


HOW TO INSTALL
---------------------------------------------------------

1. Uninstall all previous versions of Visual Web Ripper 
including trial versions.

2. Extract all files from VisualWebRipper.zip to a folder 
on your computer.

3. Run the program setup.exe.

4. If you don't have Microsoft .NET version 4 installed on 
your computer, the setup program will display the 
Microsoft .NET version 4 license agreement.

4.1. Accept the license agreement to download and install 
Microsoft .NET version 4 if it is not already installed.

5. The Visual Web Ripper installation process will begin. 
Follow the instructions displayed by the installer to 
continue installing Visual Web Ripper

BUG FIXES IN RELEASE 3.0.16
---------------------------------------------------------
- An error may occur when exporting data from a project 
that includes a Form Submit element that downloads files.

BUG FIXES IN RELEASE 3.0.15
---------------------------------------------------------
- A project does not switch proxy when retrying a URL in 
Web Browser mode.

BUG FIXES IN RELEASE 3.0.14
---------------------------------------------------------
- Error processing CAPTCHA when the CAPTCHA image is in a 
different frame than the CAPTCHA input field.

NEW IN RELEASE 3.0.13
---------------------------------------------------------
- New Content option "Clean Text" removes style and 
script content from text. This option works on a web 
element's outer HTML, so it may not result in correct 
text when JavaScript is used to manipulate the text.

NEW IN RELEASE 3.0.12
---------------------------------------------------------
- New project option "Keep connections alive" can be set 
to false to allow proxy rotation services to properly 
rotate on HTTPS requests.

BUG FIXES IN RELEASE 3.0.11
---------------------------------------------------------
- JQuery is always used to fire events when available.

BUG FIXES IN RELEASE 3.0.10
---------------------------------------------------------
- Visual Web Ripper may hang when a HTTPS call fails in 
Web crawler mode.

- Visual Web Ripper never attempts to use TLS12 when 
making a HTTPS call in Web Crawler mode.

BUG FIXES IN RELEASE 3.0.9
---------------------------------------------------------
- Some events are not fired correctly.

BUG FIXES IN RELEASE 3.0.8
---------------------------------------------------------
- When using ??post or ??headers in a URL, these special 
parameters are not removed from the URL.

BUG FIXES IN RELEASE 3.0.7
---------------------------------------------------------
- Some files are not downloaded correctly when using 
FormSubmit to download a file.

NEW IN RELEASE 3.0.6
---------------------------------------------------------
- New project option "Generate export data" can be set 
to false to prevent export data from being generated.

BUG FIXES IN RELEASE 3.0.6
---------------------------------------------------------
- Page Transformation does not work in Web Crawler mode 
when using the HTML5 parser.

NEW IN RELEASE 3.0.5
---------------------------------------------------------
- New project option "Error on Certificate Error" can be 
used in web crawler mode to abort web requests to pages 
with invalid SSL certificates.

- New project option "Error on SSL3" can be used in 
web crawler mode to abort web requests to pages that 
require an SSL3 connection.

BUG FIXES IN RELEASE 3.0.4
---------------------------------------------------------
- A file is missing from the update package which 
causes the HTML5 parser to fail when updating an existing 
copy of Visual Web Ripper.

BUG FIXES IN RELEASE 3.0.3
---------------------------------------------------------
- A file is missing from the installer package which 
causes the HTML5 parser to fail.

BUG FIXES IN RELEASE 3.0.2
---------------------------------------------------------
- Some JSON strings cannot be parsed with the 
JSON Parser.

BUG FIXES IN RELEASE 3.0.1
---------------------------------------------------------
- Some JSON strings cannot be parsed with the 
JSON Parser.

- The HTML5 parser is not correctly set as the default 
parser.

NEW IN RELEASE 3.0.0
---------------------------------------------------------
- New super fast HTML5 parser which is now the default 
parser when using Web Crawler mode. This parser is faster 
and much more reliable than the current Web Crawler 
parsers.

- New JSON parser can be used to easily extract data from 
JSON files. This parser is often used in conjunction with 
the new custom request feature.

- New XML parser can be used to easily extract data from 
XML files, such as RSS feeds.

- New custom requests. Post data and requests headers 
can now be added to a URL to generate complete custom web 
requests.

- Export data to PDF format.

- Error codes are now added to the log file when a page 
load fails in web browser mode.

- Command timeout can now be specified for MySQL database 
connections.

- Flash is now turned off by default.

- A project that is configured to run Flash, can now be 
opened with Flash disabled.


BUG FIXES IN RELEASE 2.129.15
---------------------------------------------------------
- Projects don't retry actions that fail because of 
missing required elements.

BUG FIXES IN RELEASE 2.129.14
---------------------------------------------------------
- The XML parser is unable to load XML documents.

BUG FIXES IN RELEASE 2.129.13
---------------------------------------------------------
- Back templates are sometimes waiting for the wrong wait 
elements.

BUG FIXES IN RELEASE 2.129.12
---------------------------------------------------------
- Not all cookies that should be removed are actually 
removed when configuring a project to remove cookies.

BUG FIXES IN RELEASE 2.129.11
---------------------------------------------------------
- Error processing CAPTCHA if the CAPTCHA image is 
located in a different frame than the CAPTCHA input field.

- Error processing CAPTCHA if the CAPTCHA image is an 
embedded image.

BUG FIXES IN RELEASE 2.129.10
---------------------------------------------------------
- Toolbar images are blurred.

BUG FIXES IN RELEASE 2.129.9
---------------------------------------------------------
- Setting the project option MaxEditorCaptureLength has 
no effect when using Content Transformation.

BUG FIXES IN RELEASE 2.129.8
---------------------------------------------------------
- Setting the project option MaxEditorCaptureLength has 
no effect.

BUG FIXES IN RELEASE 2.129.7
---------------------------------------------------------
- An error may occur when cleaning HTML if the HTML 
contains invalid attribute names.

BUG FIXES IN RELEASE 2.129.6
---------------------------------------------------------
- An error "The table does not match the project 
definition" may occur when it should not.

BUG FIXES IN RELEASE 2.129.5
---------------------------------------------------------
- The option "Blocked URLs" cannot be set on the project 
template.

BUG FIXES IN RELEASE 2.129.4
---------------------------------------------------------
- Some select boxes are not processed correctly.

NEW IN RELEASE 2.129.3
---------------------------------------------------------
- An in-memory SQLite database can be used when no data 
export or process restart is required.

BUG FIXES IN RELEASE 2.129.2
---------------------------------------------------------
- Work-around for a bug in Internet Explorer where mouse 
coordinates are not posted with a form when simulating a 
click on an image submit button.

BUG FIXES IN RELEASE 2.129.1
---------------------------------------------------------
- JavaScript using Console.error fails to run correctly 
in Visual Web Ripper.

NEW IN RELEASE 2.129.0
---------------------------------------------------------
- New project option "Maintain cookies" can be set to 
false used to turn off cookies in WebCrawler mode.

- New project option "Ignore error codes" can be be set 
to false to generate an error if a web server returns an 
error code in WebCrawler mode.

NEW IN RELEASE 2.128.12
---------------------------------------------------------
- A new proxy will always be used when retrying a failed 
page load.

BUG FIXES IN RELEASE 2.128.11
---------------------------------------------------------
- Error processing required elements in the first 
template.

NEW IN RELEASE 2.128.10
---------------------------------------------------------
- The method ExecuteCommandLine in ScriptUtils now has an 
optional parameter timeoutMilliseconds that specifies the 
maximum number of milliseconds a script will wait for the 
commandline program to exit. The default timeout is 
10000 milliseconds.

BUG FIXES IN RELEASE 2.128.9
---------------------------------------------------------
- Form field option text is not always extracted 
correctly.

BUG FIXES IN RELEASE 2.128.8
---------------------------------------------------------
- The Redirect Link option does not work correctly when 
redirecting to a "mailto:" address.

BUG FIXES IN RELEASE 2.128.7
---------------------------------------------------------
- Using a direct URL for a FormSubmit template causes an 
error.

BUG FIXES IN RELEASE 2.128.6
---------------------------------------------------------
- Error overriding JavaScript functions when using 
Internet Explorer 11.

BUG FIXES IN RELEASE 2.128.5
---------------------------------------------------------
- Basic Windows Authentication does not work if the 
username is blank.

BUG FIXES IN RELEASE 2.128.4
---------------------------------------------------------
- Content element names with trailing whitespaces cause 
errors when exporting to MySQL.

BUG FIXES IN RELEASE 2.128.3
---------------------------------------------------------
- Some incorrect HTML causes the XPath parser to fail.

- Unable to download some file types correctly if the 
mime type has not been set correctly.

- Random delay options have no effect in WebCrawler mode.

NEW IN RELEASE 2.128.2
---------------------------------------------------------
- All response headers are now available from the 
MyWebRequest class.

BUG FIXES IN RELEASE 2.128.1
---------------------------------------------------------
- The web crawler parser may crash when detecting 
encoding from some content. A new option has been added 
to disable detection of content encoding.

BUG FIXES IN RELEASE 2.128.0
---------------------------------------------------------
- Setting the option "Visit each page only once" on a 
pagination template in web crawler mode can cause an 
infinite look.

- The web crawler will attempt to process non-HTML pages 
when it shouldn't.

BUG FIXES IN RELEASE 2.127.3
---------------------------------------------------------
- Error retrying to resolve CAPTCHA images that are delay 
loaded.

BUG FIXES IN RELEASE 2.127.2
---------------------------------------------------------
- File downloads triggered by the web browser are not 
properly ignored.

BUG FIXES IN RELEASE 2.127.1
---------------------------------------------------------
- File downloads triggered by the web browser are not 
properly ignored.

BUG FIXES IN RELEASE 2.127.0
---------------------------------------------------------
- Some AJAX calls are made correctly and causes errors in 
rare scenarios.

BUG FIXES IN RELEASE 2.126.12
---------------------------------------------------------
- The Form Field option "Use text option" does not work 
correctly.

BUG FIXES IN RELEASE 2.126.11
---------------------------------------------------------
- Some URLs containing encoded URLs as parameters are not 
parsed correctly.

BUG FIXES IN RELEASE 2.126.10
---------------------------------------------------------
- Some cookies are not set correctly when downloading 
files, which can cause file download to fail.

BUG FIXES IN RELEASE 2.126.9
---------------------------------------------------------
- Some ActiveX security messages may be displayed while a 
project is running.

NEW IN RELEASE 2.126.8
---------------------------------------------------------
- The Run Agent screen now repositions automatically 
when the Debug option is set.

- The connection timeout for MySQL connections has been 
increased to 180 seconds.

BUG FIXES IN RELEASE 2.126.7
---------------------------------------------------------
- The Fast web crawler parser may cause the software to 
crash if malformed HTML is returned from the target 
website.

BUG FIXES IN RELEASE 2.126.6
---------------------------------------------------------
- The Run Agent GUI may crash if the internal database 
becomes unavailable.

NEW IN RELEASE 2.126.5
---------------------------------------------------------
- Content transformation can now be applied when using 
dynamic pagination.

BUG FIXES IN RELEASE 2.126.4
---------------------------------------------------------
- The template option "Move back from skipped templete" 
does not work correctly.

BUG FIXES IN RELEASE 2.126.3
---------------------------------------------------------
- Error setting the option "Keep Parent Data Rows".

NEW IN RELEASE 2.126.2
---------------------------------------------------------
- A new option "Keep Parent Data Rows" can be 
used to prevent parent data rows from being deleted when 
a duplicate check cancels a parent template.

BUG FIXES IN RELEASE 2.126.1
---------------------------------------------------------
- An error may occur in a very rare scenario where a 
project is stopped and continued after a FormField 
element was not found.

BUG FIXES IN RELEASE 2.126.0
---------------------------------------------------------
- An error occurs when using session data and then 
starting mutiple instances of a project simultaneously 
when the internal database tables don't yet exist.

- Some pagination links that are visible on a web page 
are incorrectly identified as invisible by the software. 
This problem has not been fixed, but a new option 
"Ignore hidden or disabled links" can be set to false as 
a work-around for this problem.

- Adding proxies with an incorrect format to the default 
proxy list can prevent the software from starting.

BUG FIXES IN RELEASE 2.125.3
---------------------------------------------------------
- Setting the proxy to PAC script causes an error when 
browsing a website.

NEW IN RELEASE 2.125.2
---------------------------------------------------------
- Web browser emulation mode can now be set to Internet 
Explorer 11.

BUG FIXES IN RELEASE 2.125.1
---------------------------------------------------------
- The RunProject utility does not return an error code 
when data export fails. The RunProject utility is used 
when running projects from the commmandline and when 
scheduling projects.

BUG FIXES IN RELEASE 2.125.0
---------------------------------------------------------
- Some HTML frames are not recognized correctly.

- Global script variables are deleted if an agent needs 
to restart.

NEW IN RELEASE 2.124.3
---------------------------------------------------------
- New template option "Skip on failure" marks a failure 
as success, so the action is never retried.

BUG FIXES IN RELEASE 2.124.2
---------------------------------------------------------
- The option "Failure on missing required elements" has
no effect on templates that don't navigate.

NEW IN RELEASE 2.124.1
---------------------------------------------------------
- New project option "Restart web browser on failure" 
restarts the web browser and then continues a project 
if a page load error occurs.

BUG FIXES IN RELEASE 2.124.0
---------------------------------------------------------
- The option "Download and convert document" does not 
work when the document is downloaded as a result of a 
web form submit.

- The template option "Always Export Parent Data" cannot 
be changed.

NEW IN RELEASE 2.123.3
---------------------------------------------------------
- New project option "Log timestamp format" controls the 
format of the timestamp in log files.

BUG FIXES IN RELEASE 2.123.3
---------------------------------------------------------
- Page area templates may select more than one web 
element in WebCrawler mode even when teh template is not 
marked as a list template.

BUG FIXES IN RELEASE 2.123.2
---------------------------------------------------------
- File download on form submit sometimes fail when it 
shouldn't.

NEW IN RELEASE 2.123.1
---------------------------------------------------------
- New Form Field option "Use option text" can be used to 
set the option text of select boxes instead of option 
values.

- Log entries now include seconds in the timestamp.

NEW IN RELEASE 2.123.0
---------------------------------------------------------
- Visual Web Ripper can now use 4GB of memory on 64bit 
Windows and 3GB of memory on 32bit Windows.

BUG FIXES IN RELEASE 2.123.0
---------------------------------------------------------
- The WriteDebug method in Data Input scripts does not 
write to the log file.

BUG FIXES IN RELEASE 2.122.1
---------------------------------------------------------
- Visual Web Ripper sometimes generates file names that are 
too long for extracted images and documents.

BUG FIXES IN RELEASE 2.122.0
---------------------------------------------------------
- Software activation does not work on computers using the 
Hijri calendar.

BUG FIXES IN RELEASE 2.121.9
---------------------------------------------------------
- The windowscroll and domscroll events don't always work 
correctly.

NEW IN RELEASE 2.121.8
---------------------------------------------------------
- The RunProject.exe now supports an option "view" that 
shows the web browser while extracting data.

NEW IN RELEASE 2.121.7
---------------------------------------------------------
- New option "Block page load on AJAX" blocks full pages 
loads when executing AJAX actions.

BUG FIXES IN RELEASE 2.121.6
---------------------------------------------------------
- Form field actions are sometimes executed even when the 
form field input value does not change.

NEW IN RELEASE 2.121.5
---------------------------------------------------------
- New content option "Reuse Existing Files" can be used to 
avoid downloading an image or file if the file already 
exists on disk.

BUG FIXES IN RELEASE 2.121.5
---------------------------------------------------------
- The ParentXpath value is not available in XPath 
transformation scripts when running in WebCrawler mode.

BUG FIXES IN RELEASE 2.121.4
---------------------------------------------------------
- Page load error count is not reset when retrying errors.

BUG FIXES IN RELEASE 2.121.3
---------------------------------------------------------
- Session data is not exported when running a project in 
the Visual Web Ripper editor.

- When a project is configured to verify proxies, the 
software always checks for connectivity only.

BUG FIXES IN RELEASE 2.121.2
---------------------------------------------------------
- The web crawler parser ignores "base" meta tags when 
calculating URLs.

- Lookup input values don't work correctly for FixedValue 
content elements.

NEW IN RELEASE 2.121.1
---------------------------------------------------------
- New Content option "Filename Transformation Includes File 
Extension" can be used to specify that a filename 
transformation script will add a filed file extension to 
the filename.

BUG FIXES IN RELEASE 2.121.1
---------------------------------------------------------
- Some mime types are not handled correctly when 
downloading files.

NEW IN RELEASE 2.121.0
---------------------------------------------------------
- Support for file uploads when submitting web forms.

BUG FIXES IN RELEASE 2.120.37
---------------------------------------------------------
- RepeatParent templates may cause an error with some web 
sites.

BUG FIXES IN RELEASE 2.120.36
---------------------------------------------------------
- The Export Plugin window does not resize properly when 
changing plugin.

- An error may occur in the editor when using Input 
Transformation on select box values.

BUG FIXES IN RELEASE 2.120.35
---------------------------------------------------------
- An incorrect version of a file is included in the 
installation package causing teh software to crash.

BUG FIXES IN RELEASE 2.120.34
---------------------------------------------------------
- New template option "Failure on missing required elements"
can be used to indicate a page load failure when a 
required element is not found. A template can then be 
configured to retry the page load a specified number of 
times.

BUG FIXES IN RELEASE 2.120.33
---------------------------------------------------------
- An error occurs when using the option 
SaveColumnsInParentTable.

BUG FIXES IN RELEASE 2.120.32
---------------------------------------------------------
- An error may occur when using session data and the option 
SaveColumnsInParentTable with any template.

BUG FIXES IN RELEASE 2.120.31
---------------------------------------------------------
- An incorrect web frame may be selected when two 
web frames have the same name. This can make it 
impossible to select web elements in the browser.

NEW IN RELEASE 2.120.30
---------------------------------------------------------
- New project option "Never delete data from external 
database" can be used to ensure data is never deleted 
from an external database. This option should be used 
with care, since it can easily cause data export to fail, 
or duplicate data to be inserted into the database.

BUG FIXES IN RELEASE 2.120.30
---------------------------------------------------------
- The Export Plugin screen is not resized to the size of 
the plugin.

BUG FIXES IN RELEASE 2.120.29
---------------------------------------------------------
- An error may occur when using the windowsscroll event. 
This bug was not solved properly in 2.120.28

BUG FIXES IN RELEASE 2.120.28
---------------------------------------------------------
- An error may occur when using the windowsscroll event.

BUG FIXES IN RELEASE 2.120.27
---------------------------------------------------------
- FormSubmit templates with a direct URL are not always 
processed correctly.

- Error using session data with a MySQL internal database.

BUG FIXES IN RELEASE 2.120.26
---------------------------------------------------------
- The software may sometimes crash when double clicking on 
the save toolbar button.

NEW IN RELEASE 2.120.25
---------------------------------------------------------
- The WebCrawler parser now tries to guess the correct 
encoding if no encoding is specified.

BUG FIXES IN RELEASE 2.120.24
---------------------------------------------------------
- An error may occur when a project is configured to switch 
from WebBrowser mode to WebCrawler mode.

BUG FIXES IN RELEASE 2.120.23
---------------------------------------------------------
- An error may occur after upgrading an older version of a 
data extraction project.

BUG FIXES IN RELEASE 2.120.22
---------------------------------------------------------
- Embedded images of type jpeg are not extracted correctly.

- AJAX calls are not processed correctly on some websites.

- The SafeWebBrowserCompatibillity parser does not work 
correctly on some websites.

BUG FIXES IN RELEASE 2.120.21
---------------------------------------------------------
- Unable to set the option "Clear cookies" on the advaned 
project options tab.

NEW IN RELEASE 2.120.20
---------------------------------------------------------
- New WebCrawler parser "SafeWebBrowserParser" works the 
same way as the "WebBrowserCompatibillity" parser, but 
can recover if the embedded IE parser crashes. The new 
parser is slower than all the other parsers, because it 
runs in a separate process.

NEW IN RELEASE 2.120.19
---------------------------------------------------------
- New project option "Retry count on error" specifies the 
number of times a project should retry error pages if the 
project completes with errors.

BUG FIXES IN RELEASE 2.120.18
---------------------------------------------------------
- The project option "Ignore error codes" has no effect in 
WebCrawler mode.

NEW IN RELEASE 2.120.17
---------------------------------------------------------
- When an action is set to domscroll or windowscroll any 
change in scroll position will trigger a repeated AJAX 
call even if no AJAX call has been made.

BUG FIXES IN RELEASE 2.120.17
---------------------------------------------------------
- Data is sometimes exported incorrectly if 
"Save data method" is set to AddRowsInParentTable for 
non-list templates.

- Cookies are not always set correctly in WebCrawler mode 
and may cause errors.

BUG FIXES IN RELEASE 2.120.16
---------------------------------------------------------
- The template option "Redirect method" has no effect when 
using document converters.

BUG FIXES IN RELEASE 2.120.15
---------------------------------------------------------
- Some operations don't work corrcetly when processing 
websites that use large number of cookies.

- An optional FormSubmit template may cause an error 
in WebCrawler mode.

BUG FIXES IN RELEASE 2.120.14
---------------------------------------------------------
- Some XML documents cannot be processed correctly. A new 
WebCrawler XML parser has been added to solve this 
problem.

BUG FIXES IN RELEASE 2.120.13
---------------------------------------------------------
- Error loading URLs in Web Crawler mode. This bug was 
introduced in 2.120.12.

BUG FIXES IN RELEASE 2.120.12
---------------------------------------------------------
- An error occurs in WebCrawler mode when specifying start 
URLs without protocol.

- An error occurs when using MySQL as internal database if 
the project name is exactly the maximum length allowed.


BUG FIXES IN RELEASE 2.120.11
---------------------------------------------------------
- Project statistics are reset if the project needs to 
restart to clear memory leaks.

- Error processing some rarely encountered framesets.

BUG FIXES IN RELEASE 2.120.10
---------------------------------------------------------
- An error occurs if proxy is set to Proxy List and there 
are no proxies specified.

- The software may crash when viewing internal data on the
 screen where the internal database is configured.

- An error may occur when setting a Link template to select 
a large HTML element, such as the entire HTML document.

BUG FIXES IN RELEASE 2.120.9
---------------------------------------------------------
- Wait scripts are not always processed correctly after 
loading a start URL.

NEW IN RELEASE 2.120.8
---------------------------------------------------------
- A scroll percentage can now be specified when using 
domscroll and windowscroll events.

BUG FIXES IN RELEASE 2.120.7
---------------------------------------------------------
- The project run time is not always displayed correctly.

- An error may occur when downloading files and images in 
WebBrowser mode.

BUG FIXES IN RELEASE 2.120.6
---------------------------------------------------------
- MySQL max index key length reduced to 255 to accomodate 
utf-8 encoding.

BUG FIXES IN RELEASE 2.120.5
---------------------------------------------------------
- Export plugins are called twice during data export.

BUG FIXES IN RELEASE 2.120.4
---------------------------------------------------------
- Error using DateTime conversion functions in XPath.

BUG FIXES IN RELEASE 2.120.3
---------------------------------------------------------
- Data is not written correct to the internal database 
when using multiple threads in WebCrawler mode.

NEW IN RELEASE 2.120.2
---------------------------------------------------------
- Build-in support for BypassCaptcha CAPTCHA service.

NEW IN RELEASE 2.120.1
---------------------------------------------------------
- The default export target is now Excel 2003+.

BUG FIXES IN RELEASE 2.120.1
---------------------------------------------------------
- An error sometimes occurs when exporting to Excel.

NEW IN RELEASE 2.120.0
---------------------------------------------------------
- Default internal database updated to SQLite 1.0.85.0.

BUG FIXES IN RELEASE 2.120.0
---------------------------------------------------------
- The WebBrowser agent is unable to clear memory leaks. 
To solve this problem the agent will now restart the 
entire process instead of just the web browser by default.

- The "span" xpath method is case sensitive, which it 
shoudn't be.

BUG FIXES IN RELEASE 2.119.3
---------------------------------------------------------
- Error testing email configuration if the configuration 
is saved first.

- Error running a project if it uses an empty proxy list 
that is set to verify proxy connectivity.

BUG FIXES IN RELEASE 2.119.2
---------------------------------------------------------
- The scheduler fails to send emails on project 
completion.

BUG FIXES IN RELEASE 2.119.1
---------------------------------------------------------
- The WebCrawler agent is unable to determine the correct 
character encoding on some websites where it should be 
able to do so.

The template option "Click on exact element" is now set 
to true by default.

BUG FIXES IN RELEASE 2.119.0
---------------------------------------------------------
- Email and database passwords are no longer stored as 
plain text in project files. Old passwords will remain in 
plain text until they have been saved again.

BUG FIXES IN RELEASE 2.118.6
---------------------------------------------------------
- Anchor navigation is always cancelled which interfers 
with AJAX processing on some websites.

BUG FIXES IN RELEASE 2.118.5
---------------------------------------------------------
- Condition scripts don't cancel pagination for a 
canceled template.

- Duplicate detection is not logged when running a 
project from the scheduler or command-line.

- Link transformation does not work for Direct URL 
FormSubmit templates.

BUG FIXES IN RELEASE 2.118.4
---------------------------------------------------------
- Action events with trailing white spaces don't work.

- A project file will be deleted when the project is 
saved if a user is allowed to delete files, but not 
create files.

BUG FIXES IN RELEASE 2.118.3
---------------------------------------------------------
- An error occurs if exporting last data segment only.

BUG FIXES IN RELEASE 2.118.2
---------------------------------------------------------
- Error exporting data to Excel XML and CSV in some 
situations.

BUG FIXES IN RELEASE 2.118.1
---------------------------------------------------------
- The Visual Web Ripper commandline program does not work 
correctly when the data extraction method is set to 
"Session".

NEW IN RELEASE 2.118.0
---------------------------------------------------------
- The segment field is no longer exported unless the data 
extraction method is set to "AddToExistingData".

BUG FIXES IN RELEASE 2.118.0
---------------------------------------------------------
- Numerous bug fixes related to the data extraction 
method "Session".

BUG FIXES IN RELEASE 2.117.1
---------------------------------------------------------
- The Visual Web Ripper commandline program does not work 
correctly when the data extraction method is set to 
"Session".

NEW IN RELEASE 2.117.0
---------------------------------------------------------
- New data extraction method "Session" allows multiple 
instances of the same project to run simultaneously. A 
session ID must be specified for each project instance. 
The session ID can be specified on the commandline or via 
the API.

- A test email can now be sent from the Email 
Notifications screen.

- A new template option "Repeated AJAX calls max. count" 
can be set to limit the number of AJAX calls when using 
the option "Repeated AJAX calls".

BUG FIXES IN RELEASE 2.116.10
---------------------------------------------------------
- The template option "Repeat first element" does not 
work on Pagination lists.

BUG FIXES IN RELEASE 2.116.9
---------------------------------------------------------
- Some events are not fired correctly when using IE10.

BUG FIXES IN RELEASE 2.116.8
---------------------------------------------------------
- The template option "Repeat AJAX calls" now count 
page navigations as AJAX calls. This is to avoid issues 
with websites that use page loads in hidden iframes to 
emulate AJAX calls.

BUG FIXES IN RELEASE 2.116.7
---------------------------------------------------------
- The error "The requested operation cannot be performed 
on a file with a user-mapped section open." may occur 
when exporting data to file formats.

BUG FIXES IN RELEASE 2.116.6
---------------------------------------------------------
- Unable to load a project after setting the project 
option "Clear cookies".

BUG FIXES IN RELEASE 2.116.5
---------------------------------------------------------
- Web elements with embedded images take a long time to 
display in the capture window.

BUG FIXES IN RELEASE 2.116.4
---------------------------------------------------------
- The Proxy Switch proxy options doesn't work as 
intended in WebCrawler mode.

BUG FIXES IN RELEASE 2.116.3
---------------------------------------------------------
- The Proxy Switch proxy options doesn't work correctly.

NEW IN RELEASE 2.116.2
---------------------------------------------------------
- Private Proxy Switch integrated in Visual Web Ripper.

BUG FIXES IN RELEASE 2.116.1
---------------------------------------------------------
- Error downloading a file if a link redirects to the 
file using a Refresh header.

- Visual Web Ripper does not navigate back from a 
Redirect template.

BUG FIXES IN RELEASE 2.116.0
---------------------------------------------------------
- Links and forms targeting a named window may not work 
correctly.

BUG FIXES IN RELEASE 2.115.5
---------------------------------------------------------
- The default proxy settings are not used before loading 
a project.

BUG FIXES IN RELEASE 2.115.4
---------------------------------------------------------
- Unable to select any web elements on some websites with 
a zero body width.

BUG FIXES IN RELEASE 2.115.3
---------------------------------------------------------
- Header rows for empty child tables are no longer 
included in Excel 2003/2007/2010 data exports.

BUG FIXES IN RELEASE 2.115.2
---------------------------------------------------------
- Image map selections are not marked corrcetly in the 
Web Browser.

- No browse buttons on file path selections when 
exporting to a file format.

BUG FIXES IN RELEASE 2.115.1
---------------------------------------------------------
- Selected web elements are not marked correctly on some 
websites when using Internet Explorer 10. 

BUG FIXES IN RELEASE 2.115.0
---------------------------------------------------------
- Selected web elements are not marked correctly on some 
websites when using Internet Explorer 10. 

BUG FIXES IN RELEASE 2.114.4
---------------------------------------------------------
- The "Navigate in Browser" toolbar button does not work.

NEW IN RELEASE 2.114.3
---------------------------------------------------------
- New project option "Close all dialogs" and template 
option "Close dialog buttons" can be used to 
automatically click on dialog buttons at runtime if the 
dialog is not automatically suppessed.

NEW IN RELEASE 2.114.2
---------------------------------------------------------
- New template option "Clear cookies" will clear cookies 
for the current browser URL.

- Three new static methods in the ScriptUtils class. 
ClearAllBrowserCookies, ClearBrowserCookies and 
ResetBrowserSession.

BUG FIXES IN RELEASE 2.114.1
---------------------------------------------------------
- Unhandled exception when trying to load an invalid 
plugin.

NEW IN RELEASE 2.114.0
---------------------------------------------------------
- Export plugins.

BUG FIXES IN RELEASE 2.114.0
---------------------------------------------------------
- Links redirecting to PDF files causes Visual Web Ripper 
to wait for the entire page load timeout before 
continuing.

BUG FIXES IN RELEASE 2.113.6
---------------------------------------------------------
- Some security dialogs are not suppressed. A new project 
option "Trusted website" has been added which will 
suppress some security dialogs. This option should only 
be used for trusted websites, since it may open up for 
attachs from  malicious websites.

NEW IN RELEASE 2.113.5
---------------------------------------------------------
- Projects notes are now displayed after opening a 
project.

BUG FIXES IN RELEASE 2.113.4
---------------------------------------------------------
- URLs ending with a period cannot be processed with the 
Web Crawler agent.

BUG FIXES IN RELEASE 2.113.3
---------------------------------------------------------
- An error occurs when using both the options 
"Add to existing data" and "Export last segment only".

BUG FIXES IN RELEASE 2.113.2
---------------------------------------------------------
- The content option "Check select values" has no effect 
in version 2 agents.

BUG FIXES IN RELEASE 2.113.1
---------------------------------------------------------
- TMP files generated when running version 2 web crawler 
agents. These files should only be generated when using 
version 1 agents.

NEW IN RELEASE 2.113.0
---------------------------------------------------------
- The data export option "AddRowsInParentTable" now works 
on templates containing multiple list templates.

- The default data export method can now be set in 
project options.

- A new option "AlwaysExportParentData" can be used in 
conjunction with the option "AddRowsInParentTable" to 
specify if parent data is exported when child data does 
not exist.

BUG FIXES IN RELEASE 2.112.8
---------------------------------------------------------
- Data is not automatically being de-normalized when 
saved to the Main Table.

BUG FIXES IN RELEASE 2.112.7
---------------------------------------------------------
- PageNavigation templates will keep processing links 
when a parent element makes the links invisible.

BUG FIXES IN RELEASE 2.112.6
---------------------------------------------------------
- Downloading a file on form submit does not always work.

BUG FIXES IN RELEASE 2.112.5
---------------------------------------------------------
- An error occurs when using recursive link templates 
with version 2 Agents.

- RepeatParent templates do not work correctly in some 
situations.

BUG FIXES IN RELEASE 2.112.4
---------------------------------------------------------
- Auto-submit forms don't always fire the required events 
in the editor.

BUG FIXES IN RELEASE 2.112.3
---------------------------------------------------------
- Some web pages cannot open in a new web browser when 
they should be able to.

BUG FIXES IN RELEASE 2.112.2
---------------------------------------------------------
- An error may occur when exporting data if the 
"Save data method" option is set to "MainTable".

BUG FIXES IN RELEASE 2.112.1
---------------------------------------------------------
- An error "Unable to cast object of type 'System.Int32' 
to type 'System.String'" may occur when exporting data.

BUG FIXES IN RELEASE 2.112.0
---------------------------------------------------------
- Extracted data is not always exported in the correct 
order. To fix this problem, a new column "sort_order" has 
been added to the internal export tables. This column 
is not exported to the export destination.

- Visual Web Ripper does not always wait long enough for 
IE memory leaks to clear when restarting the web browser.

BUG FIXES IN RELEASE 2.111.6
---------------------------------------------------------
- Some long loading pages are assigned an incorrect 
timeout and therefore not loaded correctly.

BUG FIXES IN RELEASE 2.111.5
---------------------------------------------------------
- The content option "Empty duplicate check" has no 
effect in version 2 agents.

BUG FIXES IN RELEASE 2.111.4
---------------------------------------------------------
- No warning is displayed when skipping all available 
form field values.

- Table headers are not denormalized when denormalizing a 
HTML table.

NEW IN RELEASE 2.111.3
---------------------------------------------------------
- URL added to WrDocumentConversionArguments.

BUG FIXES IN RELEASE 2.111.3
---------------------------------------------------------
- Some special characters cause data export to fail.

BUG FIXES IN RELEASE 2.111.2
---------------------------------------------------------
- An error "Access to the path 'Global\xxx' is denied"
may occur in some situations.

BUG FIXES IN RELEASE 2.111.1
---------------------------------------------------------
- The Element context menu does not work correctly if it 
drops over the web browser.

NEW IN RELEASE 2.111.0
---------------------------------------------------------
- Default proxies.

- Proxy verification.

BUG FIXES IN RELEASE 2.110.10
---------------------------------------------------------
- The "windowsroll" event does not always work correctly.

BUG FIXES IN RELEASE 2.110.9
---------------------------------------------------------
- The template option "Wait for URL (regex)" does not 
always work correctly.

BUG FIXES IN RELEASE 2.110.8
---------------------------------------------------------
- Some mouse events are not processed corrcetly in IE8 
document mode.

BUG FIXES IN RELEASE 2.110.7
---------------------------------------------------------
- Some mouse events are not processed corrcetly in very 
rare circumstances.

BUG FIXES IN RELEASE 2.110.6
---------------------------------------------------------
- Error downloading files from web servers with an 
invalid SSL certificate.

- "Back" templates cannot be disabled.

NEW IN RELEASE 2.110.5
---------------------------------------------------------
- New action event "windowscroll" scrolls the window of 
the selected element to the bottom right corner.

- New template option "Repeated AJAX calls" repeats an 
action as long as the action results in an AJAX call 
being made. This option can be used in combination with 
the actions "windowscroll" or "domscroll" to process 
content that is dynamically loaded when a window or a 
web element is scrolled down.

BUG FIXES IN RELEASE 2.110.5
---------------------------------------------------------
- The "Database" property is missing from the 
"WrProjectInitializeArguments" class in the API.

- Data export may fail in some rare scenarios.

BUG FIXES IN RELEASE 2.110.4
---------------------------------------------------------
- New action event "domscroll" will scroll to the bottom 
right corner of the selected element.

BUG FIXES IN RELEASE 2.110.3
---------------------------------------------------------
- Some mouse event properties are not set correctly when 
a website runs in IE8 standards mode.

BUG FIXES IN RELEASE 2.110.2
---------------------------------------------------------
- The option "Retry CAPTCHA if element exists" cannot be 
set to false.

BUG FIXES IN RELEASE 2.110.1
---------------------------------------------------------
- An error occurs when the software is configured to 
download files to disk and a file does not exist.

- Content transformation on PageAttribute content 
elements doesn't work in the editor.

- The default action is not always performed when the 
software clicks on an anchor element.

NEW IN RELEASE 2.110.0
---------------------------------------------------------
- New installer

- Export to SQL Server Compact is no longer supported.

BUG FIXES IN RELEASE 2.110.0
---------------------------------------------------------
- Missing file in the installation package. This file is 
used when installing the software on Amazon EC2.

BUG FIXES IN RELEASE 2.109.3
---------------------------------------------------------
- Unable to process input values with line feeds in text 
area form fields. 

BUG FIXES IN RELEASE 2.109.2
---------------------------------------------------------
- Executables are not timestamped. 

BUG FIXES IN RELEASE 2.109.1
---------------------------------------------------------
- The option "Must return to previous URL" is not ignored 
when using the option "Click link to move back to 
previous page" 

- Some non-latin content names may cause incorrect data 
export (Non-latin content names will still not work when 
exporting data to databases, and we recommend you only 
use latin content names).

BUG FIXES IN RELEASE 2.109.0
---------------------------------------------------------
- Some non-latin content names may cause incorrect data 
export (Non-latin content names will still not work when 
exporting data to databases, and we recommend you only 
use latin content names).

BUG FIXES IN RELEASE 2.108.5
---------------------------------------------------------
- Proxy server tests may not work correctly when using 
link transformation on the start URLs.

- Visual Web Ripper cannot connect to a database if the 
database password contains certain characters.

- Some websites require a sized browser of a minimum size 
to load all its content, so the width and height of a 
sized browser can now be set in project options.

BUG FIXES IN RELEASE 2.108.4
---------------------------------------------------------
- Data from a sub-template cannot be added as rows in the 
parent table if data from another sub-template is added 
to the parent table as columns.

BUG FIXES IN RELEASE 2.108.3
---------------------------------------------------------
- An error "Object reference not set to an instance of 
an object." occurs when running a project using version 1 
agents.

- Unable to select values from the Data column drop down 
box if the box extends over the web browser.

BUG FIXES IN RELEASE 2.108.2
---------------------------------------------------------
- Some uncommon file types may sometimes be saved to 
disk with the file extension octet-stream.

BUG FIXES IN RELEASE 2.108.1
---------------------------------------------------------
- When switching to navigation mode in the editor and 
navigating to a new page, highlighting is not turned back 
on when switching back to selection mode.

- The page loading message is not shown correctly when 
the editor is in navigation mode on Windows XP.

BUG FIXES IN RELEASE 2.108.0
---------------------------------------------------------
- Some debug messages are not logged when running a 
project in eth editor, unless the project LogLevel is 
set.

- An error occurs when using IE8 and moving the mouse 
over a frame element when the browser is configured to 
not load frames.

BUG FIXES IN RELEASE 2.107.1
---------------------------------------------------------
- Some AJAX calls are not processed correctly.

- Alert messages are not displayed in the 
Visual Web Ripper editor.

- Some JavaScript errors are not available in the 
Visual Web Ripper editor.


NEW IN RELEASE 2.107.0
---------------------------------------------------------
- New option "Append data" for CSV export. This option 
allows exported data to be appended to existing CSV 
files.

- The licensing module can now be changed to work with 
Amazon EC2 cloud service.

BUG FIXES IN RELEASE 2.106.10
---------------------------------------------------------
- Multiple values are sometimes selected in a select box 
when only a single value should be selected.

- Some AJAX calls are not processed correctly.

BUG FIXES IN RELEASE 2.106.9
---------------------------------------------------------
- Data is not exported when a project is configured to 
restart entire process.

BUG FIXES IN RELEASE 2.106.8
---------------------------------------------------------
- The WsParameterValues object is not passed on to data 
export scripts, which may cause issues in some export 
scripts using advanced features.

BUG FIXES IN RELEASE 2.106.7
---------------------------------------------------------
- Worksheet names are incorrect when exporting data to 
Excel.

BUG FIXES IN RELEASE 2.106.6
---------------------------------------------------------
- Error "Object not set to an instance of a project".

BUG FIXES IN RELEASE 2.106.5
---------------------------------------------------------
- Visual Web Ripper will now always attempt to stop 
processing if system memory is running low.

- Error "Object not set to an instance of a project".

BUG FIXES IN RELEASE 2.106.4
---------------------------------------------------------
- JavaScript calling Internet Explorer shell methods 
fail.

BUG FIXES IN RELEASE 2.106.3
---------------------------------------------------------
- The Web Browser agent hangs when restarting.

BUG FIXES IN RELEASE 2.106.2
---------------------------------------------------------
- Error using MySQL as input data source.

BUG FIXES IN RELEASE 2.106.1
---------------------------------------------------------
- The Web Browser agent will now try to clear IE memory 
leaks before exporting data when using IE9.

- Data export will now stop if the system is running out 
of memory.

- Visual Web Ripper may generate invalid Excel XML when 
using some special characters in template names.

- Increased database query timeout when reading input 
data.

NEW IN RELEASE 2.106.0
---------------------------------------------------------
- The option "Restart entire process" has been replaced 
with the new option "Restart method". This option is set 
to "Default" by default, which will only restart the 
entire process if using IE version 8 or below.

- Version 2 agents will now restart when available 
memory is running low, no matter the value of 
"Max. memory usage". The option "Min. available memory" 
can be used to specify the lowest level of available 
memory allowed before attempting a restart.

BUG FIXES IN RELEASE 2.105.6
---------------------------------------------------------
- The option "Output table name" is available for 
version 2 agents when it should only be available for 
version 1 agents.

- Projects with long names may cause an error when using 
SQL Server as internal data store.

- Some AJAX calls are not processed correctly.

- The API method WrAgent.RunProject(string projectName, 
bool isBlocking) loads projects by file path instead of 
by name.

BUG FIXES IN RELEASE 2.105.5
---------------------------------------------------------
- Some AJAX calls cause the software to crash.

BUG FIXES IN RELEASE 2.105.4
---------------------------------------------------------
- New browser windows are not closed properly when pages 
are loaded with a document converter.

BUG FIXES IN RELEASE 2.105.3
---------------------------------------------------------
- Unable to select elements in the editor after pressing 
the browser stop button.

NEW IN RELEASE 2.105.2
---------------------------------------------------------
- Input parameters are now added to the status email sent 
after a scheduled run.

NEW IN RELEASE 2.105.1
---------------------------------------------------------
- Additional information about JavaScript event errors 
are now added to the log file.

NEW IN RELEASE 2.105.0
---------------------------------------------------------
- New option "Move back from skipped template" for Back 
templates. This option was always set to true in previous 
versions, but is now set to false by default. This new 
behavior may break some projects.

BUG FIXES IN RELEASE 2.105.0
---------------------------------------------------------
- Some AJAX calls are not processed correctly.

BUG FIXES IN RELEASE 2.104.25
---------------------------------------------------------
- The option "Delay after completed action" does not 
always work for direct URLs.

- The HTML page attribute and XPaths selecting the outher 
HTML of the HTML tag don't always return the correct HTML 
content.

BUG FIXES IN RELEASE 2.104.24
---------------------------------------------------------
- Some closed tags are skipped when using the Fast 
WebCrawler parser.

BUG FIXES IN RELEASE 2.104.23
---------------------------------------------------------
- Some select boxes are not processed correctly when 
using the Web Crawler agent.

BUG FIXES IN RELEASE 2.104.22
---------------------------------------------------------
- The "click" action event does not work consistently 
across all types of actions. The "click" action event now 
always fires the click event, and the "domClick" action 
event now always emulate a click on the DOM element.

BUG FIXES IN RELEASE 2.104.21
---------------------------------------------------------
- Exporting a list of data to a single column sometimes 
causes an error.

BUG FIXES IN RELEASE 2.104.20
---------------------------------------------------------
- Some invalid HTML tags cause an error.

NEW IN RELEASE 2.104.19
---------------------------------------------------------
- Support for proxy configuration scripts (PAC).

BUG FIXES IN RELEASE 2.104.18
---------------------------------------------------------
- Error setting select boxes if they contain no values.

BUG FIXES IN RELEASE 2.104.17
---------------------------------------------------------
- Page transformation does not always work correctly in 
Web Cralwer mode.

- Some AJAX calls are not processed correctly.

BUG FIXES IN RELEASE 2.104.16
---------------------------------------------------------
- An error "Unable to find frame document" occurs when 
selecting content in some IFrames.

BUG FIXES IN RELEASE 2.104.15
---------------------------------------------------------
- Some AJAX calls are processed correctly.

BUG FIXES IN RELEASE 2.104.14
---------------------------------------------------------
- Not all AJAX calls are processed correctly.

- The advanced options window is opened in an 
inconvenient location when working in full-screen mode.

BUG FIXES IN RELEASE 2.104.13
---------------------------------------------------------
- Frame sets are not always loaded correctly on 
Windows XP/2003.

BUG FIXES IN RELEASE 2.104.12
---------------------------------------------------------
- IFrames are not always loaded correctly on 
Windows XP/2003.

BUG FIXES IN RELEASE 2.104.11
---------------------------------------------------------
- An error may sometimes occur when moving the mouse over 
a frame element.

BUG FIXES IN RELEASE 2.104.10
---------------------------------------------------------
- Export denormalization doesn't always work correctly.

BUG FIXES IN RELEASE 2.104.9
---------------------------------------------------------
- AJAX calls may cause a very small memory leak.

BUG FIXES IN RELEASE 2.104.8
---------------------------------------------------------
- The installer package contains the wrong version of the 
MySQL data connector.

- Pagination maybe processed in wrong order on resume 
when using SQL Server or MySQL as internal database.

BUG FIXES IN RELEASE 2.104.7
---------------------------------------------------------
- AJAX calls using relative URLs are not made correctly.

BUG FIXES IN RELEASE 2.104.6
---------------------------------------------------------
- Some URLs are parsed incorrectly when using the 
WebCrawler agent.

BUG FIXES IN RELEASE 2.104.5
---------------------------------------------------------
- Some websites using AJAX causes the software to crash.

BUG FIXES IN RELEASE 2.104.4
---------------------------------------------------------
- An error occurs instead of a warning when trying to 
screen capture while viewing the web browser.

- An error may occur in very rare scenarios when the 
web browser is unable to parse a frame element.

NEW IN RELEASE 2.104.3
---------------------------------------------------------
- New option "Block redirects" can be used to block 
redirects from the main document.

BUG FIXES IN RELEASE 2.104.2
---------------------------------------------------------
- A webpage continuesly making AJAX calls after a full 
page load may cause the software to hang.

BUG FIXES IN RELEASE 2.104.1
---------------------------------------------------------
- The WebBrowser agent doesn't return an error when 
trying to set a select box with a value that doesn't 
exist in the select box.

NEW IN RELEASE 2.104.0
---------------------------------------------------------
- Improved AJAX processing.

- The option "open new web browser" now redirects the 
entire request to a new web browser by default instead of 
just the URL.

- DeathByCaptcha server URL updated.

BUG FIXES IN RELEASE 2.103.4
---------------------------------------------------------
- The WebCrawler agent may parse HTML incorrectly when 
attributes contain the character '>'.

- The net_write_timeout and net_read_timeout settings 
have been increased for MySQL connections.

BUG FIXES IN RELEASE 2.103.3
---------------------------------------------------------
- Errors occur when using an internal database other than 
SQLite with a multi threaded WebCrawler agent.

BUG FIXES IN RELEASE 2.103.2
---------------------------------------------------------
- Error exporting data from some projects when using 
MySQL as internal data store.

BUG FIXES IN RELEASE 2.103.1
---------------------------------------------------------
- Unable to select elements if page load is manually 
stopped.

- Unable to select values from option drop down boxes if 
they drop down over the web browser.

NEW IN RELEASE 2.103.0
---------------------------------------------------------
- Multiple values can now be selected in a multi select 
box.

- New script parameter GlobalVariables can be used in 
scripts to store global variables.

BUG FIXES IN RELEASE 2.103.0
---------------------------------------------------------
- Back templates are not processed when a template action 
is set to Java Script and the option "Start new web 
browser" is also set.

BUG FIXES IN RELEASE 2.102.5
---------------------------------------------------------
- Auto-submit form templates don't wait for sub-elements.

BUG FIXES IN RELEASE 2.102.4
---------------------------------------------------------
- "Object reference not set to an instance of an object" 
error may occur when moving the mouse pointer over an 
empty frame element.

BUG FIXES IN RELEASE 2.102.3
---------------------------------------------------------
- Unable to mark elements on some websites.

- "Access denied" error when marking web elements in
frames on some websites.

BUG FIXES IN RELEASE 2.102.2
---------------------------------------------------------
- Elements are marked in the editor even when the editor 
doesn't have focus.

BUG FIXES IN RELEASE 2.102.1
---------------------------------------------------------
- Unable to select elements in frames within frames.

NEW IN RELEASE 2.102.0
---------------------------------------------------------
- A new toolbar button that can be used to show script 
errors on a webpage. Script error popup dialogs are now 
never shown.

- A new toolbar button that can be used to show security 
issues on a webpage. Security popup dialogs are now 
never shown.

BUG FIXES IN RELEASE 2.102.0
---------------------------------------------------------
- Security popup dialogs may sometime appear when running 
a project.

- Some websites make it impossible to mark or select web 
elements.

BUG FIXES IN RELEASE 2.101.11
---------------------------------------------------------
- All Web Crawler post requets include the "Expect: 100 
Continue" header, but some web servers fail to handle 
this feature correctly. Web Crawler post requets now 
never include the "Expect: 100 Continue" header.

BUG FIXES IN RELEASE 2.101.10
---------------------------------------------------------
- Some invalid HTML causes selections to fail in 
WebCrawler view.

BUG FIXES IN RELEASE 2.101.9
---------------------------------------------------------
- Setting the option "Start new web browser" when using a 
JavaScript action causes an error.

- Proxy authentication does not always work.

CHANGES IN RELEASE 2.101.8
---------------------------------------------------------
- Asynchronous JavaScript actions now always wait for 
AJAX to complete before starting to wait for the wait 
element, unless the option "Wait for AJAX on asynchronous 
action" is set to false.

BUG FIXES IN RELEASE 2.101.7
---------------------------------------------------------
- Version 1 agents do not suppress all security dialogs.

BUG FIXES IN RELEASE 2.101.6
---------------------------------------------------------
- Unable to select the WebCrawler agent on the Misc 
options tab in Project options.

BUG FIXES IN RELEASE 2.101.5
---------------------------------------------------------
- Void links with a # href attribute are not always 
processed correctly.

- The InternetExplorer agent should no longer be 
available but can still be selected.

BUG FIXES IN RELEASE 2.101.4
---------------------------------------------------------
- Web forms using an empty action property are processed 
incorrectly by the WebCrawler agent.

- Some web forms cannot be processed in a new web browser 
when they should be able to.

BUG FIXES IN RELEASE 2.101.3
---------------------------------------------------------
- Asynchronous JavaScript actions don't always work 
correctly if the action triggers a full page load.

BUG FIXES IN RELEASE 2.101.2
---------------------------------------------------------
- URLs containing line feeds or tabs are processed 
incorrectly by the WebCrawler parsers.

BUG FIXES IN RELEASE 2.101.1
---------------------------------------------------------
- Encoding is sometimes set incorrectly by the WebCrawler 
parsers.

NEW IN RELEASE 2.101.0
---------------------------------------------------------
- DeathByCaptcha automated CAPTCHA service integration.

BUG FIXES IN RELEASE 2.100.5
---------------------------------------------------------
- Database object names are sometimes generated 
incorrected when using MySQL.

BUG FIXES IN RELEASE 2.100.4
---------------------------------------------------------
- Error processing anchor URLs with URL encoded 
characters.

BUG FIXES IN RELEASE 2.100.3
---------------------------------------------------------
- Incorrect version number displayed when upgrading.

BUG FIXES IN RELEASE 2.100.2
---------------------------------------------------------
- AutoDetect actions do not work properly for 
PageNavigation templates and CAPTCHA.

- Visual Web Ripper does not allow a retry if a CAPTCHA 
value is entered incorrectly.

BUG FIXES IN RELEASE 2.100.1
---------------------------------------------------------
- Project version numbers are not updated correctly when 
upgrading a project.

NEW IN RELEASE 2.100.0
---------------------------------------------------------
- New Action type "AutoDetect" tries to detect the 
correct action automatically. The detection and 
configuration occur when the template is opened in the 
editor.

- Proxies can now be imported from a CSV file.

CHANGES IN RELEASE 2.100.0
---------------------------------------------------------
- The InternetExplorer agent is no longer available.

- All projects now use the modified browser option.

BUG FIXES IN RELEASE 2.100.0
---------------------------------------------------------
- Selecting both options "Start in new web browser" and 
"Visit each page only once" sometimes causes an error.

- Broken HTML with tags containing quotes causes on error 
in the Visual Web Ripper editor.

BUG FIXES IN RELEASE 2.99.1
---------------------------------------------------------
- Links with an onClick event and an anchor reference 
confuses the software and may not work correctly.

- It is difficult to change the internal database if the 
old internal database no longer exists.

NEW IN RELEASE 2.99.0
---------------------------------------------------------
- AJAX actions are now named JavaScript actions and can 
be one of 3 different types. Asynchronous JavaScript 
actions work like AJAX actions in the previous version. 
Synchronous JavaScript actions only waits for the action 
event to fire and processing then continues immediately. 
AJAX JavaScript actions intercept server requests made 
with XMLHttpRequest and wait for the server requests to 
complete before processing continues.

- New advanced option "Wait for AJAX after page load" 
can be used to wait for server requests made with 
XMLHttpRequest after a full page load.

CHANGES IN RELEASE 2.99.1
---------------------------------------------------------
- Input form fields without a type attribute are no 
longer submitted in WebCrawler mode unless specified as 
FormField elements.

BUG FIXES IN RELEASE 2.99.0
---------------------------------------------------------
- Some JavaScript events causes an error and are not 
fired correctly.

BUG FIXES IN RELEASE 2.98.9
---------------------------------------------------------
- Setting the option "Duplicate check" on FormField, File 
or Image content elements causes an error.

BUG FIXES IN RELEASE 2.98.8
---------------------------------------------------------
- The software does not look for wait elements on all 
frames when the selected frame is not found.

BUG FIXES IN RELEASE 2.98.7
---------------------------------------------------------
- Links with the tag attribute href="#" are processed 
incorrectly.

BUG FIXES IN RELEASE 2.98.6
---------------------------------------------------------
- "Dynamic list of links" pagination doesn't work 
properly when teh pagination uses INPUT elements.

BUG FIXES IN RELEASE 2.98.5
---------------------------------------------------------
- Delayed redirects cause pages to load incorrcetly in 
the editor.

- The button "Save List Values to File" saves all drop 
down values to a CSV file, but it does not escape quote 
characters, and can therefore generate an invalid CSV 
file.

BUG FIXES IN RELEASE 2.98.4
---------------------------------------------------------
- The editor does not always correctly load a new page if 
a template is configured to open a page in a 
new browser tab.

- Visual Web Ripper does not always search all frames if 
a specified frame is not found.

BUG FIXES IN RELEASE 2.98.3
---------------------------------------------------------
- Framesets are not loaded correctly. 

BUG FIXES IN RELEASE 2.98.2
---------------------------------------------------------
- Some web forms are submitted incorrcetly in WebCrawler 
mode. 

- RepeatParent templates cannot be edited.

- The "Custom user agent" option does not work correctly 
in version 2 agents

BUG FIXES IN RELEASE 2.98.1
---------------------------------------------------------
- Error processing links without a href attribute. 

NEW IN RELEASE 2.98.0
---------------------------------------------------------
- New selection styles. These styles don't interfer with 
page HTML and should result in a slightly improved 
project design experience.

BUG FIXES IN RELEASE 2.98.0
---------------------------------------------------------
- Visual Web Ripper may hang when opening the context 
menu on a drop down box with a large number of values. 

BUG FIXES IN RELEASE 2.97.11
---------------------------------------------------------
- Some dynamically created frames may cause 
Visual Web Ripper to process the same page more than 
once. 

- Unable to specify that Visual Web Ripper should click 
No/Cancel on dialogs when running a project. Yes/Ok is 
always clicked, which is not always appropriate.

BUG FIXES IN RELEASE 2.97.10
---------------------------------------------------------
- Too much log informaiton written to log be default. 

BUG FIXES IN RELEASE 2.97.9
---------------------------------------------------------
- Visual Web Ripper emulates a click on No/Cancel instead 
of Yes/OK when supressing a dialog. 

BUG FIXES IN RELEASE 2.97.8
---------------------------------------------------------
- Some dynamically created frames may cause 
Visual Web Ripper to process the same page more than 
once. 

BUG FIXES IN RELEASE 2.97.7
---------------------------------------------------------
- Some websites using frames may cause an error. 

BUG FIXES IN RELEASE 2.97.6
---------------------------------------------------------
- Content within skipped Page Area templates are not 
saved correctly.

- Incorrect warning that captcha images are not found.

BUG FIXES IN RELEASE 2.97.5
---------------------------------------------------------
- JavaScript is not injected correctly into all websites 
causing some actions to fail.

BUG FIXES IN RELEASE 2.97.4
---------------------------------------------------------
- Some web browser dialog boxes are being displayed at 
run-time.

- Unable to click on the custom context menu in some 
situations.

BUG FIXES IN RELEASE 2.97.3
---------------------------------------------------------
- Incorrect behavior of the custom context menu in some 
situations.

- Incorrect selections when selecting inside a Page Area 
using the Span option

BUG FIXES IN RELEASE 2.97.2
---------------------------------------------------------
- Setting the option "AddColumnMethod" to "SingleColumn" 
causes an error.

BUG FIXES IN RELEASE 2.97.1
---------------------------------------------------------
- The custom web browser context menu does not work 
correctly.

NEW IN RELEASE 2.97.0
---------------------------------------------------------
- All click events are now blocked, unless the toolbar 
button "Navigate in Browser" is pressed.

- New event monitor screen.

- New property "ExportDataConfiguration" available in 
WrProjectInitializeArguments. This property is applicable 
to version 2 agents only

BUG FIXES IN RELEASE 2.97.0
---------------------------------------------------------
- Unable to select content on sub-frames.

BUG FIXES IN RELEASE 2.96.3
---------------------------------------------------------
- Event blocking does not work correctly on all websites, 
so it has been temporarily disabled.

BUG FIXES IN RELEASE 2.96.2
---------------------------------------------------------
- Some JavaScript is injected incorrectly into the editor 
web browser.

BUG FIXES IN RELEASE 2.96.1
---------------------------------------------------------
- The web browser in the editor sometimes throws errors.

NEW IN RELEASE 2.96.0
---------------------------------------------------------
- All click events are now blocked, unless the toolbar 
button "Navigate in Browser" is pressed.

- The embedded MySql.Data assembly is now available in 
scripting.

BUG FIXES IN RELEASE 2.96.0
---------------------------------------------------------
- Security dialogs are sometimes displayed while a 
project is run.

- Downloading a document on form submit fails if the 
form submit loads a page that redirects to the document.

- Alert messages are not displayed in design mode.

- Unable to set the "Max. retries" option on Start URLs.

- The "Retry delay" option is not used properly.

BUG FIXES IN RELEASE 2.95.4
---------------------------------------------------------
- Default redirect method is not set to RedirectRequest 
when a Link template is using the Click event.

NEW IN RELEASE 2.95.3
---------------------------------------------------------
- New condition option "Fail when element missing".

BUG FIXES IN RELEASE 2.95.3
---------------------------------------------------------
- JavaScript links may not always be executed correctly.

BUG FIXES IN RELEASE 2.95.2
---------------------------------------------------------
- An error occurs when running a project with a Back 
template that contains sub-templates. The error only 
occurs when using version 2 agents.

BUG FIXES IN RELEASE 2.95.1
---------------------------------------------------------
- The project editor is unable to load HTML files 
directly from the file system.

NEW IN RELEASE 2.95.0
---------------------------------------------------------
- Frames are now selected automatically, and the Frames 
drop down box in the toolbar is no longer available.

- The "Search all frames" option has been removed. All 
frames will automatically be searched if the selected 
frame does not exist.

- The Click event is now blocked in the editor when 
clicking on elements in the web browser. A double-click 
will fire the Click event.

BUG FIXES IN RELEASE 2.95.0
---------------------------------------------------------
- Error using the toolbar button "Select outside page 
area"

BUG FIXES IN RELEASE 2.94.1
---------------------------------------------------------
- The FormField option "Save field value" does not work.

- The Scheduler sometimes create hidden Windows tasks.

- Unable to cancel a project using the WebCrawler agent 
if the project is submiting web forms.

- The template save method "AddColumnsInParentTable" does 
not always work if the template has sub-templates

NEW IN RELEASE 2.94.0
---------------------------------------------------------
- The template option "Start new web browser" can now be 
used on FormSubmit templates when using version 2 agents.
The option also now works better on Link templates.

- New template option "Redirect method" specifies how a 
page load should be redirected to a new web browser tab. 
This option is only available for version 2 agents and 
replaces the option "Click to get new URL". 

- A small adjustment to selection optimization within 
page areas should result in better selections in some 
scenarious.

NEW IN RELEASE 2.93.0
---------------------------------------------------------
- General performance optimizations.

BUG FIXES IN RELEASE 2.92.4
---------------------------------------------------------
- An error occurs during export when using MySQL as 
internal database.

BUG FIXES IN RELEASE 2.92.3
---------------------------------------------------------
- An error "Column parent_out_row_id does not exist" may 
occur when checking for duplicates.

BUG FIXES IN RELEASE 2.92.2
---------------------------------------------------------
- The WebCrawler agent is able to submit some forms that 
generate errors in teh project editor.

NEW IN RELEASE 2.92.1
---------------------------------------------------------
- The shared script database now supports a new method 
SetParameterBinaryValue.

NEW IN RELEASE 2.92.0
---------------------------------------------------------
- Oracle export is now supported.

BUG FIXES IN RELEASE 2.91.1
---------------------------------------------------------
- Links executing JavaScript are not always navigated 
correctly.

NEW IN RELEASE 2.91.0
---------------------------------------------------------
- The WebBrowser agent can now be configured to only 
restart the web browser thread instead of the entire 
process when a website leaks memory. This is done by 
setting the project option "Restart entire process" to 
false. This option should only be used when using IE9.

BUG FIXES IN RELEASE 2.90.6
---------------------------------------------------------
- The option "Search all frames" does not work for 
wait content and in the project editor.

BUG FIXES IN RELEASE 2.90.5
---------------------------------------------------------
- The WebBrowser agent sometimes load pages incorrectly 
if JavaScript is used to immediately redirect to another 
page.

- Image elements used for CAPTCHA should not be 
downloaded as normal image content, since it may 
interfere with CAPTCHA processing.

BUG FIXES IN RELEASE 2.90.4
---------------------------------------------------------
- Frame documents may get stuck in Inteactivae mode.

- An error occurs when returning from an optional 
FormSubmit template.

BUG FIXES IN RELEASE 2.90.3
---------------------------------------------------------
- Compressed pages are not always loaded correctly by the 
WebCrawler agent.

BUG FIXES IN RELEASE 2.90.2
---------------------------------------------------------
- The WebCrawler agent does not set the referrer 
correctly.

- The WebCrawler agent cannot load pages from web servers 
that only deliver compressed pages.

BUG FIXES IN RELEASE 2.90.1
---------------------------------------------------------
- Form submit with a direct URL does not work correctly.

NEW IN RELEASE 2.90.0
---------------------------------------------------------
- An external program can now be used to convert a
document into HTML and then be processed like any other 
web page.

- Serial key is now shown on Trial startup screen.

BUG FIXES IN RELEASE 2.90.0
---------------------------------------------------------
- The WebBrowser agent is sometimes unable to load a page 
if the page redirects.

BUG FIXES IN RELEASE 2.89.47
---------------------------------------------------------
- The WebCrawler agent does not always recognise end of 
pagination when it should.

- Unable to rename content element if the only change 
letter case.

BUG FIXES IN RELEASE 2.89.46
---------------------------------------------------------
- Duplicate check on export always checks against all 
content elements, instead of only the elements marked for 
duplicate check.

BUG FIXES IN RELEASE 2.89.45
---------------------------------------------------------
- Very long project names or template names may cause on 
error when exporting to MySQL.

- XPath functions are not recognised as valid functions.

BUG FIXES IN RELEASE 2.89.44
---------------------------------------------------------
- HTML tags with name spaces are processed incorrectly.

BUG FIXES IN RELEASE 2.89.43
---------------------------------------------------------
- The WebCrawler agent only submits one set of input 
values when processing web forms.

BUG FIXES IN RELEASE 2.89.42
---------------------------------------------------------
- File content elements are not saved in the internal 
database if the option "Save content" is reset.

BUG FIXES IN RELEASE 2.89.41
---------------------------------------------------------
- Error selecting an element within a PageArea if the 
element is part of the PageArea itself.

- Error extracting data if duplicate check is set on an 
alternative content element.

BUG FIXES IN RELEASE 2.89.40
---------------------------------------------------------
- Database command timeout is too short.

- Templates may get assigned an invalid XPath when a 
project is upgraded.

BUG FIXES IN RELEASE 2.89.39
---------------------------------------------------------
- Automatic DECAPTCHER may fail after a large number of 
CAPTCHA pages.

BUG FIXES IN RELEASE 2.89.38
---------------------------------------------------------
- char(160) is not recognised as a white space when using 
the WebCrawler agent.

BUG FIXES IN RELEASE 2.89.37
---------------------------------------------------------
- The project editor fails to load a page in WebCrawler 
mode if the page has no body tag.

BUG FIXES IN RELEASE 2.89.36
---------------------------------------------------------
- The WebCrawler agent fails to load a page if the page 
specifies invalid character encoding information.

- The project editor fails to load a page in WebCrawler 
mode if the page has no body tag.

- The Count option for FormField content is not working 
properly.

BUG FIXES IN RELEASE 2.89.35
---------------------------------------------------------
- The web browser does not suppress system messages.

BUG FIXES IN RELEASE 2.89.34
---------------------------------------------------------
- The WebCrawler agent may sometimes fail to parse 
comments on a HTML page causing the page load to fail.

- Error exporting data when using MySQL as internal 
database.

BUG FIXES IN RELEASE 2.89.33
---------------------------------------------------------
- The "Run Project" window sometimes resizes incorrectly.

BUG FIXES IN RELEASE 2.89.32
---------------------------------------------------------
- The project editor runs projects inside the editor 
instead of using an agent.

BUG FIXES IN RELEASE 2.89.31
---------------------------------------------------------
- Page Transformation throws an error when processing an 
empty HTML element.

BUG FIXES IN RELEASE 2.89.30
---------------------------------------------------------
- The MySQL character encoding option is not available 
when configuring the shared script database.

BUG FIXES IN RELEASE 2.89.29
---------------------------------------------------------
- Screenshots are not exported corrcetly.

BUG FIXES IN RELEASE 2.89.28
---------------------------------------------------------
- CAPTCHA processing may fail on some conputers when 
using version 1 agents.

BUG FIXES IN RELEASE 2.89.27
---------------------------------------------------------
- Error editing and then saving a PageNavigation 
template.

BUG FIXES IN RELEASE 2.89.26
---------------------------------------------------------
- CAPTCHA processing may fail on some conputers.

BUG FIXES IN RELEASE 2.89.25
---------------------------------------------------------
- Data export may fail if a non-list template is added 
after a list template.

- An exception may occur during data extraction if a 
copied template has been configued to cancel an entire 
list on duplicate when debug is turned on.

BUG FIXES IN RELEASE 2.89.24
---------------------------------------------------------
- Templates that check for duplicates and have been 
copied may cancel the entire project instead of the 
current template.

- JavaScript that call windows.External may fail and 
prevent websites from loading correctly.

BUG FIXES IN RELEASE 2.89.23
---------------------------------------------------------
- Data is exported when an agent restarts, but should 
only get exported when the agent completes or is stopped.

BUG FIXES IN RELEASE 2.89.22
---------------------------------------------------------
- Some Condition options cannot be changed when using 
version 2 agents.

BUG FIXES IN RELEASE 2.89.21
---------------------------------------------------------
- Some JavaScript don't work correctly without a sized 
browser Window, and a sized Window is not instantiated 
when running an invisible WebBrowser agent. A new project 
option "Use sized Window" is now available to solve this 
problem.

BUG FIXES IN RELEASE 2.89.20
---------------------------------------------------------
- Automatic CAPTCHA decoding may fail if the Internet 
cache is full.

- The RunProject.exe utility does not return an exit 
code.

BUG FIXES IN RELEASE 2.89.19
---------------------------------------------------------
- Regex tramsformation does not work correctly in 
version 2 agents when using extracted data in the regex.

BUG FIXES IN RELEASE 2.89.18
---------------------------------------------------------
- The Ok and Cancel buttons may not be vissible on the 
Export Data screen on some computer configurations.

BUG FIXES IN RELEASE 2.89.17
---------------------------------------------------------
- The File name transformation button is not visible for 
Image and File content.

- The option "Redirect on meta refresh" does not always 
work correctly.

- Invalid file names are sometimes generated for images 
and files.

NEW IN RELEASE 2.89.16
---------------------------------------------------------
- File download on form submit now works with the 
WebBrowser agent.

- File name transformation now works in screen shots.

BUG FIXES IN RELEASE 2.89.16
---------------------------------------------------------
- Alternative content elements for images and files don't 
work properly.

- The template list count option does not work properly 
in WebCrawler mode.

BUG FIXES IN RELEASE 2.89.15
---------------------------------------------------------
- CAPTCHA functionality does not work with version 2 
agents.

NEW IN RELEASE 2.89.14
---------------------------------------------------------
- Basic Windows authentication is now supported.

BUG FIXES IN RELEASE 2.89.13
---------------------------------------------------------
- Email links are extracted incorrectly.

- "Next page" pagination does not stop in WebCrawler mode 
when reaching an invalid next page link.

BUG FIXES IN RELEASE 2.89.12
---------------------------------------------------------
- Email links are not displayed correctly in the Capture 
window.

- The "Default data extractor" drop down box on the 
"Run Project" screen does not work correctly.

- Minor updates to the proxy configuration screen.

BUG FIXES IN RELEASE 2.89.11
---------------------------------------------------------
- Visual Web Ripper follows popup URLs even when it's a 
blank URL.

BUG FIXES IN RELEASE 2.89.10
---------------------------------------------------------
- Text may disappear from buttons on some Windows 
installations.

BUG FIXES IN RELEASE 2.89.9
---------------------------------------------------------
- Error navigating in the designer in Web Crawler mode 
when the Web Crawler is set to Fast or 
BackwardCompatibility.

BUG FIXES IN RELEASE 2.89.8
---------------------------------------------------------
- The default IE context menu is sometimes shown in 
design mode.

BUG FIXES IN RELEASE 2.89.7
---------------------------------------------------------
- Web pages are not always loaded correctly with the 
Web Crawler agent in WebBrowsercompatibility mode.

BUG FIXES IN RELEASE 2.89.6
---------------------------------------------------------
- Error excluding a FormSubmit template from export data.

- An empty row is generated if no data is extracted for a 
start URL.

BUG FIXES IN RELEASE 2.89.5
---------------------------------------------------------
- Visual Web Ripper may stop executing JavaScript on a 
website if a JavaScript error occurs on the website.

BUG FIXES IN RELEASE 2.89.4
---------------------------------------------------------
- The Web Browser agent may not always load a web page 
correctly if the previous page contains multiple frames 
and the project has been configured not to wait for all 
frames.

BUG FIXES IN RELEASE 2.89.3
---------------------------------------------------------
- Projects don't run correctly in Web Browser mode when 
the browser is not visible.

BUG FIXES IN RELEASE 2.89.2
---------------------------------------------------------
- A script error window is sometimes shown while running 
a project.

BUG FIXES IN RELEASE 2.89.1
---------------------------------------------------------
- An event doesn't fire correctly if JQuery is used on a 
website, but the event is not a JQeury event.

NEW IN RELEASE 2.89.0
---------------------------------------------------------
- New Web Crawler parser "WebBrowserCompatibility". This 
parser is now the default Web Crawler parser.

BUG FIXES IN RELEASE 2.89.0
---------------------------------------------------------
- The software may freeze on some websites when using a 
text filter.

- Pagination does not always work correctly after a 
FormSubmit template when using the WebCrawler agent.

- Default form field values are not always selected 
correctly when submitting forms using the WebCrawler 
agent.

BUG FIXES IN RELEASE 2.88.1
---------------------------------------------------------
- The software throws an error when a sub-frame cannot be 
loaded. The software should instead ignore such errors 
similar to normal IE behaviour.

NEW IN RELEASE 2.88.0
---------------------------------------------------------
- SQL Server Compact is no longer available as internal 
database.

BUG FIXES IN RELEASE 2.88.0
---------------------------------------------------------
- The software may in rare cases consume too much memory 
when exporting data, causing an "Out of memory" error.

- Exporting the last segment of an empty table causes an 
error.

BUG FIXES IN RELEASE 2.87.9
---------------------------------------------------------
- The startup webpage keeps loading when starting a new 
project.

- The Video link on the startup webpage does not work.

- Files and images are stored in BLOB fields when 
exporting data to MySQL, and BLOB fields can only store 
very small files.

BUG FIXES IN RELEASE 2.87.8
---------------------------------------------------------
- The template option "Save method" can now be set to 
MainTable, which will add new data rows to the main 
project table.

BUG FIXES IN RELEASE 2.87.7
---------------------------------------------------------
- The MySQL.NET adapter included with Visual Web Ripper 
does not work properly with the latest version of MySQL.

- An error may occur when using the filter option on
DT/DL HTML tags.

BUG FIXES IN RELEASE 2.87.6
---------------------------------------------------------
- Page timeout is set too low and many pages cannot load 
in the designer.

BUG FIXES IN RELEASE 2.87.5
---------------------------------------------------------
- Multiple templates with the same name may be added to a 
project when copying templates. This will cause errors 
when running the project, since all templates must have 
unique names.

BUG FIXES IN RELEASE 2.87.4
---------------------------------------------------------
- The web browser loses it's session causing most logins 
to fail.

BUG FIXES IN RELEASE 2.87.3
---------------------------------------------------------
- Resizing of the main editor window does not work as 
intended.

BUG FIXES IN RELEASE 2.87.2
---------------------------------------------------------
- The project editor does not render properly if Windows 
font size is set to more than 100%.

BUG FIXES IN RELEASE 2.87.1
---------------------------------------------------------
- The default IE context menu is displayed in the editor 
and hides the custom context menu.

NEW IN RELEASE 2.87.0
---------------------------------------------------------
- Proxy servers with user authentication now works in the 
Web Browser agent

- Websites using an invalid SSL certificate can now be 
loaded in the web browser.

BUG FIXES IN RELEASE 2.87.0
---------------------------------------------------------
- Some times the web browser fails to load a new page and 
uses the previous page instead.

BUG FIXES IN RELEASE 2.86.9
---------------------------------------------------------
- Error when using the option "Extract text" on optional 
link templates.

- Error loading some pages where sub-frames fail to load.

- Minor user interface corrections.

BUG FIXES IN RELEASE 2.86.8
---------------------------------------------------------
- The user interface does not render correctly on all 
computers.

- Long project names may cause errors when running a 
project.

BUG FIXES IN RELEASE 2.86.7
---------------------------------------------------------
- The user interface does not render correctly on all 
computers.

BUG FIXES IN RELEASE 2.86.6
---------------------------------------------------------
- Visual Web Ripper may hang when processing a FormSubmit 
template in WebCrawler mode with mutiple threads.

BUG FIXES IN RELEASE 2.86.5
---------------------------------------------------------
- Project fails to run after having been renamed directly 
in the file system.

- Table denormalization sometimes causes an error.

- Duplicate check on export data fails in some rare 
scenarios.

BUG FIXES IN RELEASE 2.86.4
---------------------------------------------------------
- Error running a project where FormField content has 
been set to a specific FormSubmit template.

BUG FIXES IN RELEASE 2.86.3
---------------------------------------------------------
- Unable to set FixedValue content.

BUG FIXES IN RELEASE 2.86.2
---------------------------------------------------------
- The option "Exclude template" does not work properly 
with version 2 agents.

BUG FIXES IN RELEASE 2.86.1
---------------------------------------------------------
- Error when opening the web browser emulation screen.

BUG FIXES IN RELEASE 2.86.0
---------------------------------------------------------
- New template option "Duplicate check at end" can be 
used to choose if duplicate check should be made before 
or after sub-templates.

BUG FIXES IN RELEASE 2.86.0
---------------------------------------------------------
- Error checking for duplicates when using MySQL as 
internal database.

- Status progress message is incorrect when using the 
XPath SPAN method for a PageArea template.

BUG FIXES IN RELEASE 2.85.9
---------------------------------------------------------
- If a FormSubmit template fails a single time, all 
submits are cancelled.

- Some errors are not correctly logged as errors.

- The template option "Click to get URL" does not work 
correctly.

BUG FIXES IN RELEASE 2.85.8
---------------------------------------------------------
- The "span" XPath method does not always work correctly.

BUG FIXES IN RELEASE 2.85.7
---------------------------------------------------------
- Error adding a content element without a selection.

BUG FIXES IN RELEASE 2.85.6
---------------------------------------------------------
- The "Project Data" tab is missing in Project Options.

BUG FIXES IN RELEASE 2.85.5
---------------------------------------------------------
- Some downloaded file paths are not added to the 
extracted data in WebCrawler mode.

BUG FIXES IN RELEASE 2.85.4
---------------------------------------------------------
- Form input scripts are not always executed correctly 
in design mode.

BUG FIXES IN RELEASE 2.85.3
---------------------------------------------------------
- The form field HTML element is null in Form Input 
scripts.

BUG FIXES IN RELEASE 2.85.2
---------------------------------------------------------
- Setting the "Default data extractor" option in project 
options does not work correctly.

BUG FIXES IN RELEASE 2.85.1
---------------------------------------------------------
- Unpredictable errors in the Visual Web Ripper editor 
when an enabled input data source is inaccessible.

NEW IN RELEASE 2.85.0
---------------------------------------------------------
- Web browser emulation version is now set to Internet 
Explorer 9 on software install.

BUG FIXES IN RELEASE 2.85.0
---------------------------------------------------------
- Some events don't fire properly, especially when using
IE9 emulation.

BUG FIXES IN RELEASE 2.84.1
---------------------------------------------------------
- Browser emulation is set for the currnet user instead 
of the entire machine.

NEW IN RELEASE 2.84.0
---------------------------------------------------------
- Web browser emulation version is no longer set during 
software install, but can be set manually after the 
software has been installed.

BUG FIXES IN RELEASE 2.83.11
---------------------------------------------------------
- Alternative Image content selections cause errors.

- The project editor does not use proxies from the 
project proxy list.

BUG FIXES IN RELEASE 2.83.10
---------------------------------------------------------
- A missing form field causes a failure even when the 
form field is optional.

BUG FIXES IN RELEASE 2.83.9
---------------------------------------------------------
- The option "Retry errors on resume" does not work.

- A missing form field does not generate an error entry.

BUG FIXES IN RELEASE 2.83.8
---------------------------------------------------------
- Unable to set the "Page load delay" options properly.

BUG FIXES IN RELEASE 2.83.7
---------------------------------------------------------
- When using the option "Restart web browser", the web 
browser is not visible after a restart.

BUG FIXES IN RELEASE 2.83.6
---------------------------------------------------------
- Error "Object not set to an instance of an object" when 
processing an image tag without a source property.

BUG FIXES IN RELEASE 2.83.5
---------------------------------------------------------
- The debug window makes a sound while a project is 
running.

BUG FIXES IN RELEASE 2.83.4
---------------------------------------------------------
- An error message is not always shown in the debug 
window when failing to download a file.

- Vertial scroll bar does not work properly in the debug 
window.

NEW IN RELEASE 2.83.3
---------------------------------------------------------
- New template options "Max. retries" and "Delay between 
retries" can be used to retry page loads.

BUG FIXES IN RELEASE 2.83.2
---------------------------------------------------------
- Famesets are not loaded correctly.

BUG FIXES IN RELEASE 2.83.1
---------------------------------------------------------
- Error using duplicate checks on export data.

BUG FIXES IN RELEASE 2.83.0
---------------------------------------------------------
- Single selection templates sometimes appear to be list 
templates in the project designer.

- Multiple single selection templates can cause data 
export to fail.

- Error using SQL Server as internal database.

- "Out of memory" error when exporting large amount of 
data to XML.

BUG FIXES IN RELEASE 2.82.8
---------------------------------------------------------
- Expanding and limiting a list does not always work.

BUG FIXES IN RELEASE 2.82.7
---------------------------------------------------------
- Loading input files can be very slow.

BUG FIXES IN RELEASE 2.82.6
---------------------------------------------------------
- HTML tags containing Unicode properties are not parsed 
correctly by the fast web crawler parser.

BUG FIXES IN RELEASE 2.82.5
---------------------------------------------------------
- Version 2 agents don't always process Redirect and 
Group templates correctly.

- Empty rows are sometimes added to data export when 
using Version 2 agents.

BUG FIXES IN RELEASE 2.82.4
---------------------------------------------------------
- The design row index on an input data source only works 
on project input data sources.

- An error "Object reference not set to an instance of an 
object" may occur when loading a webpage.

- Settings on the "Run Project" screen are not saved 
properly.

- Project connection options are not saved correctly.

BUG FIXES IN RELEASE 2.82.3
---------------------------------------------------------
- The debug window makes a sound while running a project.

BUG FIXES IN RELEASE 2.82.2
---------------------------------------------------------
- Some links may not work correctly in WebCrawler mode if 
a website redirects links.

BUG FIXES IN RELEASE 2.82.1
---------------------------------------------------------
- Error running projects in WebCrawler mode.

- Error activating the software on new computers.

BUG FIXES IN RELEASE 2.82.0
---------------------------------------------------------
- The software sometimes crash on older versions of 
Windows in particular Windows 2003.

- Links on the Visual web Ripper homepage don't work

BUG FIXES IN RELEASE 2.81.2
---------------------------------------------------------
- Webpages opening in new windows are not always cought.

BUG FIXES IN RELEASE 2.81.1
---------------------------------------------------------
- Memory leak in 2.81.0.

BUG FIXES IN RELEASE 2.81.0
---------------------------------------------------------
- Webpages opening in new windows are not always cought.

BUG FIXES IN RELEASE 2.80.2
---------------------------------------------------------
- JavaScript is not injected correctly when running 
projects from the commandline or the scheduler.

BUG FIXES IN RELEASE 2.80.1
---------------------------------------------------------
- Clicking the Help button on the project process window 
causes an error.

- The resume button on the project process window does 
not turn gray when a project has completed.

NEW IN RELEASE 2.80.0
---------------------------------------------------------
- Visual Web Ripper now uses partial page load by 
default.

- Some options that had little or no effect on page 
processing have been removed.

BUG FIXES IN RELEASE 2.80.0
---------------------------------------------------------
- Project files are saved without the .rip extension.

- Clicking the "Start new project" toolbar button causes 
an error.

BUG FIXES IN RELEASE 2.79.2
---------------------------------------------------------
- No wait message is displayed while waiting for data 
extrator agent to start.

BUG FIXES IN RELEASE 2.79.1
---------------------------------------------------------
- Visual Web Ripper may become unstable and crash on some 
websites.

- Visual Web Ripper is set to modify browser behavior by 
default, which causes memory leaks on older versions of 
Windows. 

BUG FIXES IN RELEASE 2.79.0
---------------------------------------------------------
- Exporting data can take a long time when using a SQLite 
internal database.

- Some instability issues have been fixed.

BUG FIXES IN RELEASE 2.78.9
---------------------------------------------------------
- Incorrect online updater version included with the full 
installer package.

BUG FIXES IN RELEASE 2.78.8
---------------------------------------------------------
- Error when duplicate check is set on content in 
non-list templates.

- Error "Unexpected error: Index was out of range...".

- Error viewing extracted data when running a project 
using the Agent.

BUG FIXES IN RELEASE 2.78.7
---------------------------------------------------------
- An error "Error creating internal database" may occur 
when using a FormSubmit template without associated 
FormField content.

NEW IN RELEASE 2.78.7
---------------------------------------------------------
- New project option "Redirect to modal dialogs" allows 
the web browser to redirect to the content of a modal 
dialog window.

BUG FIXES IN RELEASE 2.78.6
---------------------------------------------------------
- Exported CSV files are invalid when exporting into 
multiple files.

NEW IN RELEASE 2.78.5
---------------------------------------------------------
- New Advanced option "Action JavaScript" can be used to 
execute custom JavaScript instead of firing events when 
performing an action.

BUG FIXES IN RELEASE 2.78.4
---------------------------------------------------------
- Setting data values using the API may cause an error.

BUG FIXES IN RELEASE 2.78.3
---------------------------------------------------------
- The Fast HTML parser does not recognise all character 
encodings.

- Dynamic link PageNavigation templates don't always work 
proeprly with the WebCrawler agent.

BUG FIXES IN RELEASE 2.78.2
---------------------------------------------------------
- C# and VB.NET scripts always reference System.Web.dll 
which is not part of the .NET4 Client Profile, and 
therefore cause a script compile error if the full 
version of .NET4 is not installed.

NEW IN RELEASE 2.78.1
---------------------------------------------------------
- New export targets "Excel 2003" and "Excel 2007/2010".

BUG FIXES IN RELEASE 2.78.1
---------------------------------------------------------
- The fast WebCrawler HTML parser does not always handle 
script tags correctly.

NEW IN RELEASE 2.78.0
---------------------------------------------------------
- Visual Web Ripper now uses .NET v4.

BUG FIXES IN RELEASE 2.77.15
---------------------------------------------------------
- PageNavigation templates are not always processed.

- Internal data is not always converted to external data 
correctly.

BUG FIXES IN RELEASE 2.77.14
---------------------------------------------------------
- Condition scripts don't work properly on templates.

- Unable to access link template text in scripts.

BUG FIXES IN RELEASE 2.77.13
---------------------------------------------------------
- Proxy server configuration is set system wide when 
running a project using the WebBrowser agent.

- Visual Web Ripper may sometimes try to write data to 
invalid database tables instead of recreating the tables.

BUG FIXES IN RELEASE 2.77.12
---------------------------------------------------------
- Using a reserved name as content name causes an error 
at runtime instead of design time.

- The project option 
"Save extracted images and documents to disk" does not 
work correctly.

BUG FIXES IN RELEASE 2.77.11
---------------------------------------------------------
- An error occurs when an image element is defined in a 
template, but not found on the webpage.

BUG FIXES IN RELEASE 2.77.10
---------------------------------------------------------
- Some JavaScript events are not fired correctly when the 
WebBrowser runs in IE9 emulation mode. Visual Web Ripper 
now uses IE8 emulation mode instead. A full reinstall is 
required for this change to take effect.

BUG FIXES IN RELEASE 2.77.9
---------------------------------------------------------
- Unable to set export file paths.

BUG FIXES IN RELEASE 2.77.8
---------------------------------------------------------
- Error when viewing project error data.

BUG FIXES IN RELEASE 2.77.7
---------------------------------------------------------
- Error exporting data to MySQL databases.

BUG FIXES IN RELEASE 2.77.6
---------------------------------------------------------
- Error exporting data to XML.

BUG FIXES IN RELEASE 2.77.5
---------------------------------------------------------
- PageNavigation templates on a dynamic list of links 
don't work with version 2 agents.

BUG FIXES IN RELEASE 2.77.4
---------------------------------------------------------
- Error "Object not set to an instance of a reference" 
may occur in some rare situations.

BUG FIXES IN RELEASE 2.77.3
---------------------------------------------------------
- Error exporting data in some situations.

BUG FIXES IN RELEASE 2.77.2
---------------------------------------------------------
- Error exporting data to CSV.

- Error refreshing data on the Data Inspector screen when 
running a project using teh "Run Agent" toolbar button.

- The file extension is added twice to downloaded files.

BUG FIXES IN RELEASE 2.77.1
---------------------------------------------------------
- Error exporting data to a database.

- Error refreshing data on the Data Inspector screen.

- Incorrect help file references.

NEW IN RELEASE 2.77.0
---------------------------------------------------------
- New data extractor agents. The old agents are still 
included for backward compatibillity. Please see the help 
file for more information about the new data extractor 
agents.

BUG FIXES IN RELEASE 2.76.5
---------------------------------------------------------
- A corrupt license file does not result in a prompt for 
a new serial key.

BUG FIXES IN RELEASE 2.76.4
---------------------------------------------------------
- Warning 1010 when running a project using the Agent.

BUG FIXES IN RELEASE 2.76.3
---------------------------------------------------------
- Visual Web Ripper connects to the wrong licensing 
server.

BUG FIXES IN RELEASE 2.76.2
---------------------------------------------------------
- Visual Web Ripper always shows the version is 
up-to-date.

BUG FIXES IN RELEASE 2.76.1
---------------------------------------------------------
- Error entering empty values for Input Parameters.

- The software keeps asking for a new serial key every 
time some computers is rebooted.

NEW IN RELEASE 2.76.0
---------------------------------------------------------
- Visual Web Ripper now uses the Windows Task Scheduler 
instead of a build-in scheduler. A complete reinstall is 
required for this version.

BUG FIXES IN RELEASE 2.76.0
---------------------------------------------------------
- Visual Web Ripper does not display a correct error 
message when trying to update a version of 
Visual Web Ripper that cannot be updated to the latest 
version.

NEW IN RELEASE 2.75.3
---------------------------------------------------------
- Visual Web Ripper now runs in IE9 rendering mode if 
IE9 is installed (requires complete reinstall of 
Visual Web Ripper).

BUG FIXES IN RELEASE 2.75.2
---------------------------------------------------------
- Error "Invalid license information" when running a 
project in WebCrawler mode.

BUG FIXES IN RELEASE 2.75.1
---------------------------------------------------------
- Missing file makes it impossible to activate the 
software.

NEW IN RELEASE 2.75.0
---------------------------------------------------------
- New licensing system.

BUG FIXES IN RELEASE 2.75.0
---------------------------------------------------------
- Error entering empty values for Input Parameters.

- The Scheduler screen cannot be resized causing some 
issues on low resolution screens.

- Grid buttons are missing text on some computers.

BUG FIXES IN RELEASE 2.74.24
---------------------------------------------------------
- The trial version stops with warning 1010 when running  
projects.

BUG FIXES IN RELEASE 2.74.23
---------------------------------------------------------
- The trial startup screen may block access to the 
software if using a very low resolution.

BUG FIXES IN RELEASE 2.74.22
---------------------------------------------------------
- The "Save in parent table" option applies only to Excel 
and CSV output, but is applied to all output formats.

BUG FIXES IN RELEASE 2.74.21
---------------------------------------------------------
- Starting two projects at the exact same time may cause 
one project to fail because of a licensing error.

- The XPath function "text()" is not implemented.

- Checking for existence of an attribute in XPath does 
not work.

BUG FIXES IN RELEASE 2.74.20
---------------------------------------------------------
- FixedValue content elements may cause an error in the 
Visual Web Ripper editor.

BUG FIXES IN RELEASE 2.74.19
---------------------------------------------------------
- Webpages that incorrectly starts with two HTML tags 
are processed incorrcetly by the HTML parser.

BUG FIXES IN RELEASE 2.74.18
---------------------------------------------------------
- NextPage navigation does not resume correctly the 
second time a project is resumed.

- JavaScript may cause the Web Browser to hang, and the 
Stop button will then be unable to stop a project. A new 
Terminate button will force a project to stop even when 
the Web Browser hangs.

BUG FIXES IN RELEASE 2.74.17
---------------------------------------------------------
- Internal data is not saved when running a project to 
the end.

BUG FIXES IN RELEASE 2.74.16
---------------------------------------------------------
- Internal data is not saved when running a project to 
the end.

BUG FIXES IN RELEASE 2.74.15
---------------------------------------------------------
- Proxy servers in WebBrowser mode does not take effect 
immediately.

- When testing proxy servers in Project Options, the 
status always shows green, even when a proxy server is 
inaccessible.

BUG FIXES IN RELEASE 2.74.14
---------------------------------------------------------
- Resuming a project that saves data to a database will 
result in a "Duplicate key" error.

BUG FIXES IN RELEASE 2.74.13
---------------------------------------------------------
- When running a project using the Agent, the "Run Time" 
label is not positioned correctly.

BUG FIXES IN RELEASE 2.74.12
---------------------------------------------------------
- Visual Web Ripper removes frames when it should only 
remove Flash in some situations.

BUG FIXES IN RELEASE 2.74.11
---------------------------------------------------------
- When running a project using the Agent, the "Run Time" 
label is not positioned correctly.

- The "Custom" button is not visible on the 
"Destination Data Source" screen.

BUG FIXES IN RELEASE 2.74.10
---------------------------------------------------------
- Error exporting data to a database if the project 
contains a RepeatParent template.

BUG FIXES IN RELEASE 2.74.9
---------------------------------------------------------
- Some webpages cannot load in WebCrawler mode because 
they contain text termination characters.

- It is not possible to open a RepeatParent template with 
a specific selected link.

- RepeatParent templates don't work properly in 
WebCrawler mode.

BUG FIXES IN RELEASE 2.74.8
---------------------------------------------------------
- The Stop button does not work correctly in WebBrowser 
mode.

BUG FIXES IN RELEASE 2.74.7
---------------------------------------------------------
- Rendering issues on the Action options tab.

BUG FIXES IN RELEASE 2.74.6
---------------------------------------------------------
- Text is missing on some buttons in the project editor.

BUG FIXES IN RELEASE 2.74.5
---------------------------------------------------------
- The project editor may crash in WebCrawler mode when 
navigating to a URL that doesn't exist.

BUG FIXES IN RELEASE 2.74.4
---------------------------------------------------------
- Unable to extract data in InternetExplorer mode.

BUG FIXES IN RELEASE 2.74.3
---------------------------------------------------------
- GUI issues in the Visual Web Ripper project editor, 
especially when using a default Windows font size larger 
than 100%.

- Custom scripts may throw an error when using 
"Multi-threaded downloads" in WebBrowser mode.

- CSV string data is not encoded correctly.

- Error "Parameter value is invalid" when using the 
Visual Web Ripper project editor.

BUG FIXES IN RELEASE 2.74.2
---------------------------------------------------------
- The WebCrawler HTML parser sometimes parses tags 
incorrectly.

BUG FIXES IN RELEASE 2.74.1
---------------------------------------------------------
- File missing in online update package.

NEW IN RELEASE 2.74.0
---------------------------------------------------------
- New project property CustomUserAgent can be used to 
set the user agent in WebBrowser mode.

- New content capture type "Flash".

BUG FIXES IN RELEASE 2.74.0
---------------------------------------------------------
- Downloaded flash files have an incorrect extension.

- Unable to select Flash objects because they are being 
removed in design mode.

- Visual Web Ripper will fail to load a website if it 
needs to download a certificate beofore it can access 
the website.

NEW IN RELEASE 2.73.0
---------------------------------------------------------
- The Visual Web Ripper application and APIs no longer 
target .NET version v4, but is back to target .NET v2

NEW IN RELEASE 2.72.0
---------------------------------------------------------
- The Visual Web Ripper application and all APIs are now 
using .NET version 4. Applications using the Visual Web 
Ripper API must target .NET version 4.

- All selection XPaths are now relative to the page HTML 
element instead of the BODY element. This allows 
selection of elements above the BODY element, such as 
the HEAD element.

BUG FIXES IN RELEASE 2.72.0
---------------------------------------------------------
- The correct file extension is not always used when 
downloading files.

- PageAttribute elements always work on the main web frame 
and not the selected web frame.

BUG FIXES IN RELEASE 2.71.2
---------------------------------------------------------
- The element count for Page Area selections are often 
wrong.

- An input data source with zero columns causes an error 
when opening the project options screen.

BUG FIXES IN RELEASE 2.71.1
---------------------------------------------------------
- The Referer header is not set correctly when 
downloading files and images. This causes some downloads 
to fail.

NEW IN RELEASE 2.71.1
---------------------------------------------------------
- Two new page transformations. ReplaceHTML and 
InsertHTML can be used to easily replace or insert HTML 
into a web page.

- HTML syntax coloring.

BUG FIXES IN RELEASE 2.71.0
---------------------------------------------------------
- Saving a content element after a page transformation 
sometimes clears the selection XPath of the content 
element.

BUG FIXES IN RELEASE 2.70.13
---------------------------------------------------------
- The XPath Span method does not work on PageArea 
templates that are not defined as a list.

BUG FIXES IN RELEASE 2.70.12
---------------------------------------------------------
- Incorrect XPath behaviour in WebBcroser mode when 
using // inside a predicate.

- Error setting the option "Max capture text length".

BUG FIXES IN RELEASE 2.70.11
---------------------------------------------------------
- Visual Web Ripper may not continue extraction correctly 
when using the Group FormField option.

BUG FIXES IN RELEASE 2.70.10
---------------------------------------------------------
- Web page frames are not available in the project editor.

BUG FIXES IN RELEASE 2.70.9
---------------------------------------------------------
- Help windows now open up as top most Windows.

BUG FIXES IN RELEASE 2.70.8
---------------------------------------------------------
- Opening help or support menus sometimes causes an 
error.

BUG FIXES IN RELEASE 2.70.7
---------------------------------------------------------
- Project upgrade error.

BUG FIXES IN RELEASE 2.70.6
---------------------------------------------------------
- The WebBrowserCompatibility parser is unstable and has 
been disabled.

BUG FIXES IN RELEASE 2.70.5
---------------------------------------------------------
- The WebBrowserCompatibility parser crashes.

BUG FIXES IN RELEASE 2.70.4
---------------------------------------------------------
- Projects running in WebCrawler mode are now upgraded 
to use the BackwardCompability parser by default.

- The WebBrowserCompatibility and Fast parsers now 
removes scripts by default.

NEW IN RELEASE 2.70.3
---------------------------------------------------------
- New content type "Screen" can be used to take a 
screenshot of a specific element on webpage.

BUG FIXES IN RELEASE 2.70.2
---------------------------------------------------------
- Extracted text is not HTML decoded in fast WebCrawler 
mode.

BUG FIXES IN RELEASE 2.70.1
---------------------------------------------------------
- The WebCrawler does not always read web pages 
correctly.

- The WebCrawler parsers accept invalid attribute names.

NEW IN RELEASE 2.70.0
---------------------------------------------------------
- The WebCrawler can now run in three different modes.
WebBrowserCompatibility, Fast or BackwardCompatibility.

- The project editor now runs smoother in WebCrawler 
mode.

BUG FIXES IN RELEASE 2.69.16
---------------------------------------------------------
- The project editor cuts off long captured text used as 
script input.

BUG FIXES IN RELEASE 2.69.15
---------------------------------------------------------
- FixedValue content elements don't accept data values 
from input data sources associated with specific templates.

BUG FIXES IN RELEASE 2.69.14
---------------------------------------------------------
- Web browsers with modified behaviour don't run in a 
single Window when using the option "View Browser".

NEW IN RELEASE 2.69.13
---------------------------------------------------------
- All web browsers now run in a single Window when using 
the option "View Browser". 

BUG FIXES IN RELEASE 2.69.13
---------------------------------------------------------
- Redirect templates don't work correctly with lookup 
data sources.

BUG FIXES IN RELEASE 2.69.12
---------------------------------------------------------
- An alternative Image content element doesn't work if 
the main content element uses Content Transformation.

NEW IN RELEASE 2.69.11
---------------------------------------------------------
- New project option "Synch with database keys".

- The Visual Web Ripper support website is now accessible 
from within Visual Web Ripper.

BUG FIXES IN RELEASE 2.69.10
---------------------------------------------------------
- An error may occur when exporting data to a database 
when the project has a Link template that uses the option 
"Extract text" and also contains a PageNavigation template.

BUG FIXES IN RELEASE 2.69.9
---------------------------------------------------------
- Running a project with mutiple start URLs may sometimes 
cause an error when also exporting data periodically.

NEW IN RELEASE 2.69.8
---------------------------------------------------------
- The input data source file path is now automatically 
set to the default project folder when the specified file 
path is not found and the file is found in the default 
project folder.

BUG FIXES IN RELEASE 2.69.8
---------------------------------------------------------
- The Start URL option "Feed URLs from input data source" 
is always reset.

NEW IN RELEASE 2.69.7
---------------------------------------------------------
- New project option "Exclude Start URL table".

NEW IN RELEASE 2.69.6
---------------------------------------------------------
- The XPath SPAN methods now always stop when they reach 
the following list element.

BUG FIXES IN RELEASE 2.69.6
---------------------------------------------------------
- The Start URL input data column drop down is always 
disabled.

BUG FIXES IN RELEASE 2.69.5
---------------------------------------------------------
- The WebCrawler does not correctly recognise XML 
documents.

BUG FIXES IN RELEASE 2.69.4
---------------------------------------------------------
- Link transformation doesn't work for PageNavigation 
templates.

BUG FIXES IN RELEASE 2.69.3
---------------------------------------------------------
- The "Cache timer" project option does not work when 
set to more than 1 hour.

BUG FIXES IN RELEASE 2.69.2
---------------------------------------------------------
- The current input data row is not parsed to scripts.

BUG FIXES IN RELEASE 2.69.1
---------------------------------------------------------
- All scripts throw an error if an input data source is 
not enabled.

NEW IN RELEASE 2.69.0
---------------------------------------------------------
- An Input Data Source can now be defined for Group 
templates.

- An Input Data Source defined for a Group or Form 
template is now available in all subtemplates.

API CHANGES IN RELEASE 2.69.0
---------------------------------------------------------
- The property WrProject.DataConfiguration.InputDataSource 
has been moved to WrProject.Template.InputDataSource.

BUG FIXES IN RELEASE 2.69.0
---------------------------------------------------------
- The template option "Exclude template" has no effect 
on XMl output.

- The API may throw an error similar to "Unable to find 
assembly..."

- Some JavaScript causes unexpected behaviour in 
WebCralwer mode.

BUG FIXES IN RELEASE 2.68.19
---------------------------------------------------------
- The online updater downloads the third party 
decaptcher.dll file which is recognised as an unwanted 
file by some virus scanners. The file should only be 
available as a separate optional download. This issue was 
not fixed properly in v2.68.14 as announced.

BUG FIXES IN RELEASE 2.68.18
---------------------------------------------------------
- The default Blocked URL has been removed, since it 
causes problems for some websites.

BUG FIXES IN RELEASE 2.68.17
---------------------------------------------------------
- The content of drop down boxes with many entries are 
not displayed correctly in the project editor.

- Page loads are displayed incorrectly when resuming a 
project.

BUG FIXES IN RELEASE 2.68.16
---------------------------------------------------------
- Visual Web Ripper sometimes incorrectly reports an 
error when processing a Back template inside an optional 
template.

BUG FIXES IN RELEASE 2.68.15
---------------------------------------------------------
- Visual Web Ripper may crash while navigating in the 
project editor.

NEW IN RELEASE 2.68.14
---------------------------------------------------------
- New methods to load a CSV file in the ScriptUtils 
module.

BUG FIXES IN RELEASE 2.68.14
---------------------------------------------------------
- The online updater downloads the third party 
decaptcher.dll file which is recognised as an unwanted 
file by some virus scanners. The file should only be 
available as a separate download.

NEW IN RELEASE 2.68.13
---------------------------------------------------------
- New project option "Blocked URLs" can be used to 
prevent Visual Web Ripper from navigating specific URLs, 
including iframe URLs.

- It is now always possible to Continue data extraction 
if a data extract exists, even when Visual Web Ripper has 
marked the data extract as complete. If the data extract 
is marked as complete, the icon on the Continue button 
will be gray.

BUG FIXES IN RELEASE 2.68.12
---------------------------------------------------------
- When using the option "Export data & clear memory" 
Visual Web Ripper still keeps too much data in memory.

BUG FIXES IN RELEASE 2.68.11
---------------------------------------------------------
- Visual Web Ripper may crash while removing Flash 
objects from some websites.

BUG FIXES IN RELEASE 2.68.10
---------------------------------------------------------
- Pressing the pause button in WebCrawler mode causes an 
error.

BUG FIXES IN RELEASE 2.68.9
---------------------------------------------------------
- The WebCrawler hangs after running for a long time.

BUG FIXES IN RELEASE 2.68.8
---------------------------------------------------------
- Running a project in the Agent causes the Agent to 
crash at startup.

BUG FIXES IN RELEASE 2.68.7
---------------------------------------------------------
- The project editor thows an error "Invalid URL..." when 
entering the URL address box.

- If the start URL fails to load, Visual Web Ripper will 
keep trying to load the URL in an infinite loop.

BUG FIXES IN RELEASE 2.68.6
---------------------------------------------------------
- The project editor may fail to navigate to a new web 
page.

BUG FIXES IN RELEASE 2.68.5
---------------------------------------------------------
- The "Restart project" option has been replaced with a 
"Resume" button.

BUG FIXES IN RELEASE 2.68.4
---------------------------------------------------------
- The agent is unable to run a project that is not 
located in the default project folder. 

BUG FIXES IN RELEASE 2.68.3
---------------------------------------------------------
- An error "Value must be within minimum and maximum" may 
occur for some projects when run from the project editor. 

BUG FIXES IN RELEASE 2.68.2
---------------------------------------------------------
- Extracted data in not saved correctly in WebCrawler 
mode.

BUG FIXES IN RELEASE 2.68.1
---------------------------------------------------------
- A project does not restart when it's unable to continue 
with the existing data extract, but instead displays a 
somewhat cryptic error message.

NEW IN RELEASE 2.68.0
---------------------------------------------------------
- Data extraction can now continue from where it was last 
stopped. The Continue option only works in WebBrowser 
mode.

- A data extraction project can now Automatically restart 
the data extraction agent in WebBrowser mode. This will 
free leaked memory in cases where a website leaks memory 
in Internet Explorer.

- A data extraction project can now save data with 
specified intervals without having to export the data. 
The intervals are set using the "Data row cache" option. 
This option no longer forces data to be exported unless 
the option "Export data & clear memory" is set. The 
intervals can also be set as time intervals.

- The data extraction progress bar is now an indication 
of the actual progress instead of an estimate based on 
previous data extractions.

- Visual Web Ripper now makes a better attempt at removing 
Flash objects in WebBrowser mode. Flash objects can 
sometimes cause Internet Explorer to crash if they are 
not removed during processing.

- The project log path can not be set using the API.

BUG FIXES IN RELEASE 2.68.0
---------------------------------------------------------
- The "Clean HTML" option removes JavaScript tags, but 
leaves encoded JavaScript in the extract content.

- The "Clean HTML" option removes DL, DT and DD tags.

BUG FIXES IN RELEASE 2.67.13
---------------------------------------------------------
- The WebCrawler collector fails when page encoding is 
specified in a certain way.

BUG FIXES IN RELEASE 2.67.12
---------------------------------------------------------
- If a data extraction project fails or is stopped at a 
certain moment, it can cause data output to get corrupted.

BUG FIXES IN RELEASE 2.67.11
---------------------------------------------------------
- The 3rd party file decaptcher.dll has been removed 
from the installer because some virus software 
categorises the file as unwanted software.

NEW IN RELEASE 2.67.10
---------------------------------------------------------
- New option "Pause when elements missing" can be used 
in web browser mode to pause processing if a template or 
content element is not found.

- New toolbar button "Reset browser session" can be used 
to reset a website session while designing a project.

NEW IN RELEASE 2.67.9
---------------------------------------------------------
- New project option "Save full local path" can be set to 
false in order to only save the file name of downloaded 
files.

- The "Line breaks" option has been improved.

NEW IN RELEASE 2.67.8
---------------------------------------------------------
- New database helper methods in the script utility 
class.

NEW IN RELEASE 2.67.7
---------------------------------------------------------
- New option "Allow auto redirect" for image and file 
content.

BUG FIXES IN RELEASE 2.67.6
---------------------------------------------------------
- Visual Web Ripper does not wait for elements when 
moving back using a back template containing 
sub-templates.

NEW IN RELEASE 2.67.5
---------------------------------------------------------
- Input Transformation can now always be applied to 
FormField elements even when they have the option 
"Iterate list values".

- New template option "restart browser session" can be 
used to emulate restarting the web browser.

BUG FIXES IN RELEASE 2.67.5
---------------------------------------------------------
- Sub-elements can be added to a Selection template in 
the designer.

BUG FIXES IN RELEASE 2.67.4
---------------------------------------------------------
- Selection filters are not always applied correctly.

BUG FIXES IN RELEASE 2.67.3
---------------------------------------------------------
- Error setting the "CAPTCHA element" option.

- No proper error message when using a CAPTCHA element 
name that doesn't exist.

NEW IN RELEASE 2.67.2
---------------------------------------------------------
- The selection XPath is now optimized in a slightly 
different way, resulting in shorter XPaths.

BUG FIXES IN RELEASE 2.67.1
---------------------------------------------------------
- Missing support file in the 2.67.0 release.

NEW IN RELEASE 2.67.0
---------------------------------------------------------
- CAPTCHA scripts can be used to automatically call a 
decaptcher service to decode CAPTCHA images.

- Scripts are now compiled with the /unsafe option 
allowing unsafe code in scripts.

BUG FIXES IN RELEASE 2.66.1
---------------------------------------------------------
- Error saving data to databases in some situation where 
a PageNavigation templates is placed within a list 
template.

BUG FIXES IN RELEASE 2.66.0
---------------------------------------------------------
- Some complex project data is not denormalized properly.

- Incorrect column names when processing a form in 
WebCrawler mode.

NEW IN RELEASE 2.65.0
---------------------------------------------------------
- A template name is now displayed with disabled text if 
the template is disabled or the template is not saved to 
output.

BUG FIXES IN RELEASE 2.65.0
---------------------------------------------------------
- The option "Wait for frame name" is not available for 
templates.

- The "Random time delay" options don't work for standard 
click actions.

- Wait elements dont't always work correctly when moving 
back to a PageArea template.

NEW IN RELEASE 2.64.11
---------------------------------------------------------
- The support key is now automatically suplied when 
opening the manual from within Visual Web Ripper.

BUG FIXES IN RELEASE 2.64.10
---------------------------------------------------------
- The LinkArea options "Start Index" and "Count" cannot 
be set higher than 100.

BUG FIXES IN RELEASE 2.64.9
---------------------------------------------------------
- Error saving data to a database when the project 
contains form templates and data is not being 
de-normalized.

BUG FIXES IN RELEASE 2.64.8
---------------------------------------------------------
- Error saving data to a database when the project 
contains form templates and data is not being 
de-normalized.

NEW IN RELEASE 2.64.7
---------------------------------------------------------
- New template option "Repeat first element" can be used 
on list templates to repeat the first list element as 
long as it exists.

BUG FIXES IN RELEASE 2.64.6
---------------------------------------------------------
- The template option "Navigate back" is ignored when 
moving back to a group template.

BUG FIXES IN RELEASE 2.64.5
---------------------------------------------------------
- The WebCrawler HTML parser is unable to parse some HTML 
attributes properly.

BUG FIXES IN RELEASE 2.64.4
---------------------------------------------------------
- Visual Web Ripper does not navigate back when returning 
to a PageArea template in the designer.

- The option "AJAX in page areas" does not work for 
FormSubmit templates.

NEW IN RELEASE 2.64.3
---------------------------------------------------------
- New context menu "Copy XPath Node to Clipboard" in the 
Tree View Browser.

NEW IN RELEASE 2.64.2
---------------------------------------------------------
- New AJAX option "Reselect AJAX check element" can be 
used to force Visual Web Ripper top reselect an AJAX 
check element while waiting for an AJAX action to 
complete. This is required if a check element selection 
changes as a result of the AJAX action.

NEW IN RELEASE 2.64.1
---------------------------------------------------------
- When getting or setting a column value in a row using 
the API, Visual Web Ripper will automatically look for 
the column in parent rows if the column name doesn't 
exist in the current data row.

NEW IN RELEASE 2.64.0
---------------------------------------------------------
- New template type "Group" can be used to group content 
and templates.

- Templates are now processed in the order in which they 
are listed in the Captured Elements window.

BUG FIXES IN RELEASE 2.64.0
---------------------------------------------------------
- An error occurs when deleting the last template or 
content element in the Captured Elements window.

NEW IN RELEASE 2.63.9
---------------------------------------------------------
- The "Captured Elements" window now supports 
drag-and-drop.

BUG FIXES IN RELEASE 2.63.9
---------------------------------------------------------
- The "Captured Elements" window no longer scrolls to the 
top when saving a content element.

BUG FIXES IN RELEASE 2.63.8
---------------------------------------------------------
- The WebCrawler does not select the most appropriate 
body tag when a HTMl document has multiple body tags.

NEW IN RELEASE 2.63.8
---------------------------------------------------------
- Word-wrap is now available in the Capture editor.

BUG FIXES IN RELEASE 2.63.7
---------------------------------------------------------
- The option "Delay after action" does not work correctly 
when using multiple events.

BUG FIXES IN RELEASE 2.63.6
---------------------------------------------------------
- "Dynamic list of links" page navigation does not work 
properly in WebCrawler mode.

- The condition action CancelDataTable does not work 
correctly in WebCrawler mode.

BUG FIXES IN RELEASE 2.63.5
---------------------------------------------------------
- Using the "Row cache size" option can cause primary 
key violations when saving data to a database.

- Using the "Row cache size" option may in rare cases 
cause database tables to be re-created during processing.

- A project will fail to load if a custom output folder 
has ben set to a drive that doesn't exist.

BUG FIXES IN RELEASE 2.63.4
---------------------------------------------------------
- The option "Buttonless submit" has been renamed to 
"Auto submit", so it matches the name in the manual.

-When changing the output folders, the raw data file is 
still being written to the default output folder.

NEW IN RELEASE 2.63.3
---------------------------------------------------------
- The option "Load frames" can now be set on individual 
templates.

BUG FIXES IN RELEASE 2.63.2
---------------------------------------------------------
- Link transformation is not applied to the start URL in 
design mode.

BUG FIXES IN RELEASE 2.63.1
---------------------------------------------------------
- Pure text pages, such as pages retrieved from JASON 
requests, fail to load in WebCrawler mode.

NEW IN RELEASE 2.63.0
---------------------------------------------------------
- A script can now be used as Input Data Source.

BUG FIXES IN RELEASE 2.63.0
---------------------------------------------------------
- The template option "Click to get new URL" is now set 
to false by default.

- The option "Form submit links" does not work in design 
mode.

- The content capture of multiple elements are listed 
incorrcetly when designing a project in WebCrawler mode. 

NEW IN RELEASE 2.62.8
---------------------------------------------------------
- New XPath attribute @root-node-position.

BUG FIXES IN RELEASE 2.62.8
---------------------------------------------------------
- The OleDB connection string is not saved correctly when 
configuring a shared database connection.

BUG FIXES IN RELEASE 2.62.7
---------------------------------------------------------
- Unable to change the condition fail action for content 
elements.

BUG FIXES IN RELEASE 2.62.6
---------------------------------------------------------
- Invalid URLs causes an error in WebBrowser mode. 
In WebCrawler mode the current template will be cancelled.

NEW IN RELEASE 2.62.5
---------------------------------------------------------
- New content option "All paragraphs".

BUG FIXES IN RELEASE 2.62.4
---------------------------------------------------------
- Automatic software upgrade doesn't always work 
properly.

BUG FIXES IN RELEASE 2.62.3
---------------------------------------------------------
- Visual Web Ripper may in rare circumstances insert 
extracted values into the wrong columns in a database 
table.

NEW IN RELEASE 2.62.2
---------------------------------------------------------
- The option "AJAX before page load" is n ow available 
for FormField content.

- Visual Web Ripper now waits for any full page loads to 
complete after waiting for an AJAX callback.

BUG FIXES IN RELEASE 2.62.1
---------------------------------------------------------
- Nested page area templates can cause errors in 
WebBrowser mode.

- Page transformation does not work correctly if 
Visual Web Ripper Navigates back to a PageArea template.

- Page transformation does not always work correctly in 
WebCrawler mode.

NEW IN RELEASE 2.62.0
---------------------------------------------------------
- Help buttons in Visual Web Ripper now links to the 
online manual.

BUG FIXES IN RELEASE 2.62.0
---------------------------------------------------------
- The error "Invalid license information" occurs when 
running a project from the command-line or when using the 
scheduler.

NEW IN RELEASE 2.61.19
---------------------------------------------------------
- New FormField option "Check select values".

- New FormField option "Form values required".

BUG FIXES IN RELEASE 2.61.18
---------------------------------------------------------
- Using a lookup data source for form elements does not 
always work correctly.

NEW IN RELEASE 2.61.17
---------------------------------------------------------
- The HTML page attribute now always return the 
unprocessed HTML in WebCrawler mode.

BUG FIXES IN RELEASE 2.61.17
---------------------------------------------------------
- The advanced option Windows block the view of script 
editors.

NEW IN RELEASE 2.61.16
---------------------------------------------------------
- A random time delay can now be inserted between all 
page loads.

BUG FIXES IN RELEASE 2.61.16
---------------------------------------------------------
- The web browser cancel button is not always active in 
Visual Web Ripper.

- AJAX events sometime complete too early.

- Default template sort order is not always set correctly.

BUG FIXES IN RELEASE 2.61.15
---------------------------------------------------------
- Error denormalizing data output from some projects.

NEW IN RELEASE 2.61.14
---------------------------------------------------------
- The project owner settings can now be saved without 
having to save the Scheduler settings.

BUG FIXES IN RELEASE 2.61.14
---------------------------------------------------------
- Error denormalizing data output from some complex 
projects.

NEW IN RELEASE 2.61.13
---------------------------------------------------------
- The FormSubmit option Direct URL can now be a relative 
URL.

BUG FIXES IN RELEASE 2.61.13
---------------------------------------------------------
- The browser stop button is unavailable while loading 
frame documents.

- Start and count options are not working on FormField 
content for Direct URL forms.

NEW IN RELEASE 2.61.12
---------------------------------------------------------
- The link template option "Extract text" will now 
extract the alt text of an image if the link contains an 
image instead of text.

BUG FIXES IN RELEASE 2.61.12
---------------------------------------------------------
- Content names starting with the character # causes an 
error when saving extracted data. The character # is now 
no longer allowed in names.

- The AJAX option "No wait in design mode" has been 
removed, since AJAX actions can now be cancelled by 
clicking the browser stop button.

BUG FIXES IN RELEASE 2.61.11
---------------------------------------------------------
- Output file encoding is set to Unicode by default, but 
correct CSV encoding is ASCII. The option 
"Output file encoding" is now obsolete, and CSV file 
encoding should be set in the Destination Data Source 
screen. The default encoding is ASCII.

NEW IN RELEASE 2.61.10
---------------------------------------------------------
- New page transformation type "CustomOuterHtml" works on 
the outer HTML of a selection instead of the inner HTML.

BUG FIXES IN RELEASE 2.61.10
---------------------------------------------------------
- XML encoding information causes an error in WebCrawler 
mode.

BUG FIXES IN RELEASE 2.61.9
---------------------------------------------------------
- Form field events attached through JavaScript is 
sometimes not fired by Visual Web Ripper.

BUG FIXES IN RELEASE 2.61.8
---------------------------------------------------------
- Error submitting forms with multiple input values in 
WebCrawler mode.

NEW IN RELEASE 2.61.7
---------------------------------------------------------
- The current activation key is now displayed on the 
About box.

BUG FIXES IN RELEASE 2.61.6
---------------------------------------------------------
- XML output files are encoded using Windows Unicode 
instead of UTF-8.

BUG FIXES IN RELEASE 2.61.5
---------------------------------------------------------
- The WebCrawler option "Download file on submit" does 
not work if the web request does not redirected to the 
downloadable file after submit.

BUG FIXES IN RELEASE 2.61.4
---------------------------------------------------------
- The Visual Web Ripper API is sometimes unable to find 
the software installation folder when used in an external 
application.

NEW IN RELEASE 2.61.3
---------------------------------------------------------
- New toolbar button "View extracted data".

- Additonal log information about navigation errors in 
WebBrowser mode.

BUG FIXES IN RELEASE 2.61.2
---------------------------------------------------------
- The current project settings are not always used in 
design mode.

- WebCrawler UserAgent header updated to IE8.

BUG FIXES IN RELEASE 2.61.1
---------------------------------------------------------
- Using the option "Form field group" can cause an 
infinite loop.

NEW IN RELEASE 2.61.0
---------------------------------------------------------
- New option "Form field group" can be used to group 
radio buttons or check boxes together. Grouped form fields 
will be iterated like values in a drop down box.

BUG FIXES IN RELEASE 2.61.0
---------------------------------------------------------
- An error may occur when using the API to get empty 
values from a data table.

BUG FIXES IN RELEASE 2.60.4
---------------------------------------------------------
- File URLs are not saved in parent tables when setting 
the option "Save in parent table".

NEW IN RELEASE 2.60.3
---------------------------------------------------------
- The RemoveContent page transformation will now remove 
the entire selected HTML element and not just the inner 
content.

NEW IN RELEASE 2.60.2
---------------------------------------------------------
- New project option "Allow unsafe header parsing" can be 
reset to disallow incorrect response headers in WebCrawler 
mode.

BUG FIXES IN RELEASE 2.60.2
---------------------------------------------------------
- An incorrect XPath is generated when using the Span 
feature on PageArea templates.

BUG FIXES IN RELEASE 2.60.1
---------------------------------------------------------
- Recursive link templates don't work correctly in design 
mode.

- Some minor GUI bug fixes.

NEW IN RELEASE 2.60.0
---------------------------------------------------------
- New FormField option "Multiple input fields" and 
"Multiple input fields reset value" can be used to iterate 
through a list of radio or checkbox form fields without 
the need of an Input Data Source. These options work only 
for standard forms in WebBrowser mode.

- New option "Wait for page load during AJAX" can be 
reset to tell Visual Web Ripper not to wait for a web 
page to load completely during AJAX actions.


BUG FIXES IN RELEASE 2.59.2
---------------------------------------------------------
- The project option "Remove Flash" has no affect.

NEW IN RELEASE 2.59.1
---------------------------------------------------------
- New Page Transformation "RemoveContent" can be used to 
easily remove unstable Flash from a web page.

BUG FIXES IN RELEASE 2.59.0
---------------------------------------------------------
- The Span XPath method does not always work correctly.

- Cookies are not always set correctly in WebCrawler mode.

NEW IN RELEASE 2.58.0
---------------------------------------------------------
- New project option "Load default cookie" can be used in 
WebCrawler mode to load the default cookie for the start 
URL. This option is set to true by default.

BUG FIXES IN RELEASE 2.58.0
---------------------------------------------------------
- Saving extracted data to a OleDb data destination 
sometimes cause an error.

- When saving extracted data to a database, empty tables 
are not always being generated if a data table contains 
no data.

- When saving extracted data to a database, the initial 
truncating of database tables does not always work.


BUG FIXES IN RELEASE 2.57.7
---------------------------------------------------------

- Error waiting for content elements in child PageArea 
templates.


NEW IN RELEASE 2.57.6
---------------------------------------------------------

- New template option "Parse WebCrawler HTML". This 
option can be used to optimize processing in WebCrawler 
mode if you only need access to the raw HTML.


BUG FIXES IN RELEASE 2.57.6
---------------------------------------------------------

- WebCrawler mode does not spawn multiple threads if 
single link templates are within PageArea list templates.

- When the start URLs are supplied by an Input Data 
source, the URL from the current design index is not used 
as start URL in the Visual Designer.


BUG FIXES IN RELEASE 2.57.5
---------------------------------------------------------

- Error saving extracted data to an OleDB data source.


BUG FIXES IN RELEASE 2.57.4
---------------------------------------------------------

- Some AJAX actions don't work properly.


BUG FIXES IN RELEASE 2.57.3
---------------------------------------------------------

- The "Loading" panel keeps flashing when browsing in 
navigation mode.


BUG FIXES IN RELEASE 2.57.2
---------------------------------------------------------

- The API method WrDataRow.GetColumnValue(string) always 
return an empty string for some projects.


BUG FIXES IN RELEASE 2.57.1
---------------------------------------------------------

- A large list of static start URLs can cause the user 
interface to freeze.


NEW IN RELEASE 2.57.0
---------------------------------------------------------

- Project input parameters can now be defined. Input 
parameters can be used in all scripts.

- A custom project initialization script can be used to 
set project properties before the project is run.


BUG FIXES IN RELEASE 2.56.4
---------------------------------------------------------

- Some scripts using the depricated method 
ContainsColumn(string, string) fail.


BUG FIXES IN RELEASE 2.56.3
---------------------------------------------------------

- Some scripts fail because column names are now case 
sensitive. Column names have now been made case 
insensitive again.


BUG FIXES IN RELEASE 2.56.2
---------------------------------------------------------

- Some scripts using the depricated method 
AddColumn(string, string, string) fail.


NEW IN RELEASE 2.56.1
---------------------------------------------------------

- When ordering data columns by name, any column count 
part of the name is now ordered numerically.


BUG FIXES IN RELEASE 2.56.0
---------------------------------------------------------

- Data columns are sometimes included in output when 
they shoudn't be. This fix required changes to the 
internal data structures, and existing extracted data may 
become invalid after upgrading to this version.


NEW IN RELEASE 2.55.0
---------------------------------------------------------

- The option "Wait is optional" now applies to all links 
in a list unless the option "Optional wait applies only 
to first link in a list" is set.


NEW IN RELEASE 2.54.0
---------------------------------------------------------

- Data columns can now be saved in parent tables. The 
save mode can be MultipleColumns or SingleColumn. If the 
save mode is MultipleColumns, each data row in a table 
will generate an extra column in the parent table. If the 
save mode is SingleColumn, values in all data rows will 
be concatenated and saved in one extra column in the 
parent table.


BUG FIXES IN RELEASE 2.53.8
---------------------------------------------------------

- Error writing extracted data to some OleDB providers.


BUG FIXES IN RELEASE 2.53.7
---------------------------------------------------------

- The OleDB connector depends on schema information, but 
not all OleDB providers support schema information.


BUG FIXES IN RELEASE 2.53.6
---------------------------------------------------------

- Images with capital letters extensions are not 
downloaded correctly.


NEW IN RELEASE 2.53.5
---------------------------------------------------------

- The option "Visit each page once only" now works 
slightly different for PageNavigation templates of type 
"List of links". Visual Web Ripper will now look at the 
inner text of a link element and only proceed if it has 
not already followed a link with the same inner text.


BUG FIXES IN RELEASE 2.53.4
---------------------------------------------------------

- A new session is not created for each start URL in 
WebCrawler mode. This causes problems on a very few 
websites.


BUG FIXES IN RELEASE 2.53.3
---------------------------------------------------------

- The template option "Insert empty rows" causes an 
error when denormalizing output data.


BUG FIXES IN RELEASE 2.53.2
---------------------------------------------------------

- Page transformations are not always applied correctly 
in WebCrawler mode.


BUG FIXES IN RELEASE 2.53.1
---------------------------------------------------------

- Selection XPaths are constructed incorrectly causing 
numerous issues.


NEW IN RELEASE 2.53.0
---------------------------------------------------------

- Improvements to the way Visual Web Ripper injects 
JavaScripts.

- New project option "Load Frames" can be reset to 
prevent iframes from loading in WebBrowser mode.


BUG FIXES IN RELEASE 2.53.0
---------------------------------------------------------

- Quotes are added to column names when writing data to 
Oracle through OleDb.


BUG FIXES IN RELEASE 2.52.15
---------------------------------------------------------

- Error processing next page area in a list after 
skipping a link template in the page area.


BUG FIXES IN RELEASE 2.52.14
---------------------------------------------------------

- Error selecting elements within a page area.


BUG FIXES IN RELEASE 2.52.13
---------------------------------------------------------

- Error processing templates within a page area.


BUG FIXES IN RELEASE 2.52.12
---------------------------------------------------------

- Error selecting content within a page area.


NEW IN RELEASE 2.52.11
---------------------------------------------------------

- A charset can now be specified when using a MySql data 
source. 


BUG FIXES IN RELEASE 2.52.11
---------------------------------------------------------

- Selection templates don't work correctly.


BUG FIXES IN RELEASE 2.52.10
---------------------------------------------------------

- Local file URLs are not allowed as start URLs.

- New option "Transfer session to WebCrawler" can be reset 
to start a new session when switching from WebBrowser to 
WebCrawler mode.


NEW IN RELEASE 2.52.9
---------------------------------------------------------

- New toolbar button "Select Outside Page Area" allows 
selections outside the active page area. Content selected 
outside the active page area will be repeated for each 
page area in a list.


BUG FIXES IN RELEASE 2.52.9
---------------------------------------------------------

- The row span option does not work correctly.


BUG FIXES IN RELEASE 2.52.8
---------------------------------------------------------

- Error editing elements with a non-existing selection.

- Error selecting the page area root element in a page 
area template.


BUG FIXES IN RELEASE 2.52.7
---------------------------------------------------------

- The online updater does not work. A complete re-install 
is required to fix this problem.


NEW IN RELEASE 2.52.6
---------------------------------------------------------

- New XPath axis "root" can be used to reference the 
current page area, or the document root if not operating 
within a page area.


BUG FIXES IN RELEASE 2.52.6
---------------------------------------------------------

- Table denormalization does not always work in 
WebCrawler mode.

- The option "Use HTML as regex input" does not always 
work correctly in design mode.

- The Cpature window shows elements within a page area 
list in the wrong order.


BUG FIXES IN RELEASE 2.52.5
---------------------------------------------------------

- When denormalizing table TH elements, additional TD 
elements are inserted instead of TH elements.

- An error occurs when using a column header filter if 
the header text contains quotes.


BUG FIXES IN RELEASE 2.52.4
---------------------------------------------------------

- Work sheets are now added in the correct order when 
saving output data to Excel.

- The filter option "Must contain this element" does not 
always work correctly.


BUG FIXES IN RELEASE 2.52.3
---------------------------------------------------------

- Select form fields do not behave correctly if all 
values have been set specifically to empty string.

- Selecting HTML elements with attribute values containing 
quotes can cause errors.


BUG FIXES IN RELEASE 2.52.2
---------------------------------------------------------

- Normalizing specific tables causes all child tables to 
also be normalized.

- Normalizing specific tables can cause errors if some 
data rows don't have child data.

Help file update for the Redirect template.


BUG FIXES IN RELEASE 2.52.1
---------------------------------------------------------

- The online updater is not signed with the Sequentum 
code signing certificate.


NEW IN RELEASE 2.52.0
---------------------------------------------------------

- New option "Refresh after page load" refreshes a 
web page completely after it has been loaded by the 
web browser.

- A redirect template can now redirect to a list of URLs 
read from a lookup data source.

- Visual Web Ripper is now signed with the Sequentum code 
signing certificate.


BUG FIXES IN RELEASE 2.51.5
---------------------------------------------------------

- Page loads and wait conditions cannot always be 
cancelled when designing projects.

- The "Denormalize data" option does not always 
denormalize data when it should.


BUG FIXES IN RELEASE 2.51.4
---------------------------------------------------------

- Condition script options are not available in the 
Advanced options tab for Content.

- Optional link template within page area templates don't 
always work.


BUG FIXES IN RELEASE 2.51.3
---------------------------------------------------------

- Text filters on text containing the character ' may not 
work for all languages.


NEW IN RELEASE 2.51.2
---------------------------------------------------------

- The WebCrawler collector can now load documents without 
a body tag.

- The WebCrawler collector now recognises XML documents, 
and does not apply XHTML rules to such documents.


BUG FIXES IN RELEASE 2.51.1
---------------------------------------------------------

- The Limit and Expand selection options don't always 
work properly on manual list selections.

- Relative file URLs are not converted into absolute URLs 
if they are constructed by content transformation.


NEW IN RELEASE 2.51.0
---------------------------------------------------------

- The "Element" options tab is now named "Misc".

- The "More" options tab is now named "Advanced".

- The "Condition" options tab has been removed and 
condition options are now only available in the "Advanced" 
options tab.

- The "More" project options tab is now named "Advanced".

- The "Data" project options tab has been removed and 
data options are now only available in the "Advanced" 
options tab.


BUG FIXES IN RELEASE 2.51.0
---------------------------------------------------------

- Visual Web Ripper does not support embedded images, and 
an error sometimes occur when selecting an embedded image 
in the designer.


NEW IN RELEASE 2.50.5
---------------------------------------------------------

- New project option "Ignore page load status codes" can be 
used to accommodate a few websites that use status code 
in an unusual way.


BUG FIXES IN RELEASE 2.50.4
---------------------------------------------------------

- The WebCrawler collector sometimes tries to access data 
collected by threads that have not completed.


BUG FIXES IN RELEASE 2.50.3
---------------------------------------------------------

- Visual Web Ripper does not transfer cookies correctly 
from the WebBrowser collector to the WEbCrawler collector.


BUG FIXES IN RELEASE 2.50.2
---------------------------------------------------------

- Visual Web Ripper cannot be activated on some computer 
configurations.


BUG FIXES IN RELEASE 2.50.1
---------------------------------------------------------

- Visual Web Ripper fails to return to the form URL when 
a form submit fails.

- Visual Web Ripper does not allow re-entering default 
proxy configuration.

- Duplicate data is never removed from XML output.


NEW IN RELEASE 2.50.0
---------------------------------------------------------

- The PageNavigation template option "Link Area" is now 
called "List of links" and must select a list of links 
and not a link area.

- The PageNavigation template option "Continuing Link Area" 
is now called "Dynamic list of links" and must select a 
list of links and not a link area.


BUG FIXES IN RELEASE 2.49.7
---------------------------------------------------------

- The page load delay option does not work when a page 
is loaded in a new browser.

- No parent templates are available after opening the 
Move/Copy Content Window.

- An error "Object not set to an instance of an object" 
may occur in the Mode/Copy template Window.


BUG FIXES IN RELEASE 2.49.6
---------------------------------------------------------

- The start URL is set incorrectly in version 2.49.5.


BUG FIXES IN RELEASE 2.49.5
---------------------------------------------------------

- Visual Web Ripper fails to load a web page at all when 
any sub-frames fail to load.

- When navigating a website in the project designer in 
navigation mode the start URL does not change.

- Some web sites block click events on some elements 
making it impossible to click to select elements in the 
project designer.


NEW IN RELEASE 2.49.4
---------------------------------------------------------

- Position and size of most designer Windows are now 
retained between sessions.

- Data view screens are now floating Windows, so they 
can stay open while modifying a project.


BUG FIXES IN RELEASE 2.49.4
---------------------------------------------------------

- Web sites opening new browser Windows are not always 
processed correctly.


BUG FIXES IN RELEASE 2.49.3
---------------------------------------------------------

- Continuing page navigation templates don't always work 
when they should.


BUG FIXES IN RELEASE 2.49.2
---------------------------------------------------------

- Visual Web Ripper sometimes navigates back from AJAX 
templates when it shouldn't.

- Back templates containing sub-templates don't always 
work correctly.


BUG FIXES IN RELEASE 2.49.1
---------------------------------------------------------

- Transformation content elements appear in output data.


NEW IN RELEASE 2.49.0
---------------------------------------------------------

- New content type "Transformation" can be used to 
transform a web page before any other content elements 
or templates are applied.


BUG FIXES IN RELEASE 2.48.3
---------------------------------------------------------

- URLs with anchors sometimes confuses Visual Web Ripper 
resulting in extra unnecessary page loads.

- Content and template names using the character "#" to 
indicate an alternative selection don't cause an error 
when the primary element does not exist.

- The visual designer does not indicate that a page is 
loading while sub-frames are loading.


BUG FIXES IN RELEASE 2.48.2
---------------------------------------------------------

- The Visual Web Ripper designer crashes after a while if 
a selected sub-frame never loads completely.

- Flat format data is not saved correctly to databases.


NEW IN RELEASE 2.48.1
---------------------------------------------------------

- New option "Fixed file extension" can be used to set a 
fixed file extension on downloaded images and files.


BUG FIXES IN RELEASE 2.48.1
---------------------------------------------------------

- The processing status window does not indicate that a 
page is loading when Visual Web Ripper navigates back to 
a previous page.

- Visual Web Ripper may crash if an image cannot be saved 
correctly to disk.


NEW IN RELEASE 2.48.0
---------------------------------------------------------

- Data is now converted into a flat format before the 
post-processing step, unless setting the post-processing 
option "Process raw data".


BUG FIXES IN RELEASE 2.47.5
---------------------------------------------------------

- Missing file in the update package.


NEW IN RELEASE 2.47.4
---------------------------------------------------------

- The web browser collector now downloads files in 
separate threads by default, which can increase 
performance significantly for some projects.


BUG FIXES IN RELEASE 2.47.4
---------------------------------------------------------

- The option "Strip invalid XML" is not always applied 
to extracted text.

- Some links opening new windows are not handled 
correctly.

- Some page load errors are not recognised by Visual Web 
Ripper, which could result in missing data without any 
errors.


BUG FIXES IN RELEASE 2.47.3
---------------------------------------------------------

- The Text Filter context menu does not work well for 
HTML definition lists.

- Text filter markings may change position depending on 
which web page is open, which is confusing.


BUG FIXES IN RELEASE 2.47.2
---------------------------------------------------------

- Visual Web Ripper navigates back in design mode when 
the option "Navigate back" is reset.

- In design mode, content transformation is applied to 
multiple elements when a single element is selected 
within a page area list.


NEW IN RELEASE 2.47.1
---------------------------------------------------------

- Proxy information is now written to the debug window.


BUG FIXES IN RELEASE 2.47.1
---------------------------------------------------------

- Javascritps are not overridden in all required frames 
after opening a page navigation template.


NEW IN RELEASE 2.47.0
---------------------------------------------------------

- Improved performance when designing a project in 
WebCrawler mode.

- Content elements selecting more than one web element 
will now extract data from all elements concatenated.


BUG FIXES IN RELEASE 2.47.0
---------------------------------------------------------

- The XPATH ancestor axis is not implemented.

- A delay occurs when editing a content element in some 
projects targeting websites using frames.

- The project start URL does not change after switching 
to navigation mode and then navigating to a specific page.


BUG FIXES IN RELEASE 2.46.3
---------------------------------------------------------

- Error saving extracted data to a database after 
renaming a project.


BUG FIXES IN RELEASE 2.46.2
---------------------------------------------------------

- Visual Web Ripper does not ask for proxy login when 
the software is being registered, and instead throws a 
connection error.


BUG FIXES IN RELEASE 2.46.1
---------------------------------------------------------

- It is not possible to set a drop down design value if 
the value has trailing white spaces.


NEW IN RELEASE 2.46.0
---------------------------------------------------------

- RepeatParent template type. This template type can be 
used to recursive hierarchies of categories on a website.

- Xpath transformation script type. This script can be 
used to transform a selection xpath.

- "Navigate back" template option can be reset to prevent 
Visual Web Ripper from navigating back to the previous 
web page when moving to the parent template.


BUG FIXES IN RELEASE 2.46.0
---------------------------------------------------------

- Some page navigation templates don't work correctly in 
WebCrawler mode.

- A bug in a 3rd party software causes Visual Web Ripper 
to expire. This problem was not solved properly in 
v2.45.15 and v2.45.16.


BUG FIXES IN RELEASE 2.45.16
---------------------------------------------------------

- Link templates don't work properly.


BUG FIXES IN RELEASE 2.45.15
---------------------------------------------------------

- The software cannot start. An error message saying that 
SmartAssembly has expired occurs. This problem is casued 
by a bug in SmartAssembly.


BUG FIXES IN RELEASE 2.45.14
---------------------------------------------------------

- The toolbar button "Keep loading web page until manual 
stop" does not always work.

- The toolbar button "Navigate in browser" does not always 
work correctly.

- Frames that are added and removed dynamically on a 
web page can cause errors in design mode.

- Some flash objects are not removed during page load 
potentially causing the web browser to crash.


BUG FIXES IN RELEASE 2.45.13
---------------------------------------------------------

- The HTML parser used by the WebCrawler collector ignores 
line feeds instead of converting them into white spaces.


BUG FIXES IN RELEASE 2.45.12
---------------------------------------------------------

- Missing dll in installer package causing upgrades from 
very old versions to fail.


BUG FIXES IN RELEASE 2.45.11
---------------------------------------------------------

- Missing MySql data connector dll in installer package.


BUG FIXES IN RELEASE 2.45.10
---------------------------------------------------------

- Visual Web Ripper does not always suppress javascript 
alerts.


BUG FIXES IN RELEASE 2.45.9
---------------------------------------------------------

- An error "Value cannot be null. Parameter name: format" 
occurs when running a project.


NEW IN RELEASE 2.45.8
---------------------------------------------------------

- Link transformation can now be applied to start URLs.


BUG FIXES IN RELEASE 2.45.8
---------------------------------------------------------

- Visual Web Ripper connot download a file if the file 
URL redirects.

- Drop downs with only text options are not set correctly.

- Some websites with a very rare layout corrupts the 
Visual Web Ripper GUI.


NEW IN RELEASE 2.45.7
---------------------------------------------------------

- The last found page area is now carried through optional 
templates.

- New template option "Click on link to get URL for new 
browser" can be used to click on a link to get the URL 
for a new browser.


BUG FIXES IN RELEASE 2.45.7
---------------------------------------------------------

- The correct frame is not set in the editor for content 
elements.


BUG FIXES IN RELEASE 2.45.6
---------------------------------------------------------

- Potential licensing issues.


BUG FIXES IN RELEASE 2.45.5
---------------------------------------------------------

- An error occurs if the main table name is different 
from the project name.


NEW IN RELEASE 2.45.4
---------------------------------------------------------

- New project option "Remove Flash".


BUG FIXES IN RELEASE 2.45.3
---------------------------------------------------------

- An error may occur when using template names that are 
invalid database object names (this bug was not fixed 
properly in 2.45.2).


BUG FIXES IN RELEASE 2.45.2
---------------------------------------------------------

- An error may occur when using template names that are 
invalid database object names.


BUG FIXES IN RELEASE 2.45.1
---------------------------------------------------------

- An error somtimes occur when editing a content or 
template element.


NEW IN RELEASE 2.45.0
---------------------------------------------------------

- Support for nested frame sets and nested iframes.

- XML output format has changed slightly.


BUG FIXES IN RELEASE 2.45.0
---------------------------------------------------------

- AJAX actions may not complete successfully.

- Links using "javascript:;" as dummy link don't fire 
the onclick event correctly.

- A clicked element disappear when a selection returns 
no elements, making it difficult to adjust a selection.

- Errro saving output in XML format.


BUG FIXES IN RELEASE 2.44.2
---------------------------------------------------------

- <li> HTML tags don't convert properly into line breaks 
when using the line break content option.


NEW IN RELEASE 2.44.1
---------------------------------------------------------

- New content option "Download Without Session Info" can 
be used to download files without sending session info to 
the web server.


NEW IN RELEASE 2.44.0
---------------------------------------------------------

- Internal data structures have changes to allow varying 
number of data columns. Data extracted with previous 
versions of Visual Web Ripper CANNOT be loaded with this 
version of the software, so you need to re-extract all 
data after upgrading to this version.


BUG FIXES IN RELEASE 2.43.4
---------------------------------------------------------

- Some help buttons are positioned incorrectly.


BUG FIXES IN RELEASE 2.43.3
---------------------------------------------------------

- Dialog buttons are sometimes positioned incorrectly.


NEW IN RELEASE 2.43.2
---------------------------------------------------------

- Projects can be set to expire at a specified date.


BUG FIXES IN RELEASE 2.43.2
---------------------------------------------------------

- Help file updates.


BUG FIXES IN RELEASE 2.43.1
---------------------------------------------------------

- Project browser options are not available.

- AJAX actions sometimes cause Visual Web Ripper to crash.


NEW IN RELEASE 2.43.0
---------------------------------------------------------

- Proxies configured in Visual Web Ripper now works in 
WebBrowser and IE collector mode. However, proxy 
authentication is not supported in WebBrowser and IE mode.

- New option to set the number of page loads before 
switching to the next proxy.

- New project option "Page load delay" can be used to add 
a small delay after a page is loaded. If no custom page 
load delay is specified, a one second delay is 
automatically added if the target website contains Flash. 


BUG FIXES IN RELEASE 2.43.0
---------------------------------------------------------

- Data output from projects containing alternative 
content and templates is not always correct.

- It is difficult to design projects for websites that 
are using a timer to partly refresh web pages.


BUG FIXES IN RELEASE 2.42.2
---------------------------------------------------------

- The WebCrawler collector can end up in an infinite loop 
when processing page navigations if the target website 
stops responding.

- Links on startup page don't work.

- Help file updates.


BUG FIXES IN RELEASE 2.42.1
---------------------------------------------------------

- Potential licensing issue.


NEW IN RELEASE 2.42.0
---------------------------------------------------------

- Internal data structures have been optimized to 
reduce the memory usage required to hold cached data. 
Data extracted with previous versions of Visual Web Ripper 
CANNOT be loaded with this version of the software, so you 
need to re-extract all data after upgrading to this 
version.


BUG FIXES IN RELEASE 2.41.5
---------------------------------------------------------

- Nested page area templates can cause Visual Web Ripper 
to crash.


BUG FIXES IN RELEASE 2.41.4
---------------------------------------------------------

- Visual Web Ripper always return a status message that 
not all data was collected after running a project, even 
when no error occured and all data was collected 
successfully.


BUG FIXES IN RELEASE 2.41.3
---------------------------------------------------------

- CSV output headers are always converted to upper casing.


BUG FIXES IN RELEASE 2.41.2
---------------------------------------------------------

- CSV output files are named slightly incorrectly.


NEW IN RELEASE 2.41.1
---------------------------------------------------------

- Some performance optimization in the designer when 
selecting long HTML fields.


NEW IN RELEASE 2.41.0
---------------------------------------------------------

- New regex command line_breaks replaces some common 
html tags with line breaks. This command must be called 
before strip_html to work correctly.


BUG FIXES IN RELEASE 2.41.0
---------------------------------------------------------

- The "Wait is optional" option does not work for 
FormSubmit templates.

- Resetting the template option "Save template" has no 
affect when flattening data.

- Converting existing data does not execute 
post-processing scripts.

- The "Required template" option sometimes shows as 
reset, even when it is actually set.


NEW IN RELEASE 2.40.5
---------------------------------------------------------

- New template option "Exclude template" can be used to 
exclude a single template from the data output. 
For example, this can be used to exclude page navigation 
tables from data output without having to "flatten data".


BUG FIXES IN RELEASE 2.40.5
---------------------------------------------------------

- The "Make line breaks" option does not generate double 
line breaks.


BUG FIXES IN RELEASE 2.40.4
---------------------------------------------------------

- An error may occur when executing scripts 
(error loading Microsoft.mshtml.dll).

- Unable to stop 2nd processing browser.


BUG FIXES IN RELEASE 2.40.3
---------------------------------------------------------

- A missing assembly causes an error on some systems.


BUG FIXES IN RELEASE 2.40.2
---------------------------------------------------------

- The editor does not detect mouse events on some systems, 
making it impossible to design projects.


BUG FIXES IN RELEASE 2.40.1
---------------------------------------------------------

- Opening a 2nd processing browser in InternetExplorer 
mode causes Visual Web Ripper to hang (work extremely slow).


NEW IN RELEASE 2.40.0
---------------------------------------------------------

- Many internal structural changes to set up the software 
for future enhancements.

- The scheduling folder is now obsolete. Projects placed 
in the scheduling folder will be ignored. Projects must 
now be actively scheduled on a computer. Current scheduled 
projects must be re-scheduled.

- The scheduler can now run projects with seconds intervals.

- Visual Web Ripper can now be used by multiple users on 
the same computer. Each user must have a separate license.

- The API assemblies are simplified and only two assembly 
references are usually required.

- New project option "Hide selection styles" hides all 
Visual Web Ripper styles in the browser. Some Web sites 
may function incorrectly when custom styles are applied 
(this is very rare).


BUG FIXES IN RELEASE 2.40.0
---------------------------------------------------------

- Visual Web Ripper always replaces data in MySQL even 
when the option "Add to existing data" is set to true.


BUG FIXES IN RELEASE 2.35.10
---------------------------------------------------------

- The script database utility class throws an error for 
MySql and OleDb.

- Unassigned selection templates interfere with new 
selections.


NEW IN RELEASE 2.35.9
---------------------------------------------------------

- New template option "Recursive" can be used on link 
templates to open the same template recursively as long 
as the template selection exists.

- A memory leak may occur in the browser control when 
setting browser behaviour in project options. The memory 
leak has not been fixed, but the browser behaviour options 
are now turned off by default.


NEW IN RELEASE 2.35.8
---------------------------------------------------------

- Help file updates.

- The "Delay after action" can now be set on the start 
template in project options.


NEW IN RELEASE 2.35.7
---------------------------------------------------------

- New XPATH attribute @tag-text will return the inner 
text of a HTML element excluding the inner text of child 
elements.

- Custom XPATH functions now get the current HTML element 
in the function arguments.


BUG FIXES IN RELEASE 2.35.6
---------------------------------------------------------

- The template option "New browser" does not work 
properly in InternetExplorer mode.

- Javascript overrides are not injected into frame 
documents.


BUG FIXES IN RELEASE 2.35.5
---------------------------------------------------------

- The "Flattening data" option does not always work when 
using alternative templates.


BUG FIXES IN RELEASE 2.35.4
---------------------------------------------------------

- Visual Web Ripper cancels a form template if a 
form field doesn't exist after a previous form field's 
postback. Visual Web Ripper should instead continue with 
the next input value combination.


NEW IN RELEASE 2.35.3
---------------------------------------------------------

- New project option "Reduce memory usage" can be sued to 
reduce memory usage by the WebBRowser collector.


NEW IN RELEASE 2.35.2
---------------------------------------------------------

- New content option "Empty duplicate check" can be used 
to specify if empty values are considered equal in a 
duplicate check.


BUG FIXES IN RELEASE 2.35.2
---------------------------------------------------------

- Form submits that open a new Window causes an error 
in Visual Web Ripper. 


NEW IN RELEASE 2.35.1
---------------------------------------------------------

- New template/content option "Pause when missing". This 
option causes Visual Web Ripper to pause if a required 
element is missing when the processing browser is visible. 
This allows manual interaction with the web browser 
before continuing and can be used in scenarios such as 
when a CAPCHA page appear.


NEW IN RELEASE 2.35.0
---------------------------------------------------------

- New poject options to change web browser behaviour. 
These options can be used to increase data extraction 
performce and stabillity in WebBrowser mode.


BUG FIXES IN RELEASE 2.35.0
---------------------------------------------------------

- Visual Web Ripper may crash when running in WebBrowser 
mode while extracting data from some websites containing 
Flash object.


NEW IN RELEASE 2.34.25
---------------------------------------------------------

- New option "Dealy after action" can be used to wait for 
a certain number of milliseconds after an action, such as 
a click on a link.


BUG FIXES IN RELEASE 2.34.24
---------------------------------------------------------

- The content option "Redirect link" does not redirect 
on meta refresh tags. A new option "Redirect on meta 
refresh" is now available in the More options tab.


BUG FIXES IN RELEASE 2.34.23
---------------------------------------------------------

- Visual Web Ripper does not move back after completing a 
page navigation template in WebBrowser mode. This bug can 
seriously interupt normal processing in many projects.


BUG FIXES IN RELEASE 2.34.22
---------------------------------------------------------

- Projects with optional form templates sometimes 
generate incorrect data output.


BUG FIXES IN RELEASE 2.34.21
---------------------------------------------------------

- Setting the "Flatten data" option sometimes result in 
empty data output.


BUG FIXES IN RELEASE 2.34.20
---------------------------------------------------------

- Page area templates that are not defined as a list can 
sometimes cause errors in output data.


BUG FIXES IN RELEASE 2.34.19
---------------------------------------------------------

- Mutiple page navigation templates sometimes result in 
incorrect data output.

- The scheduler email notification always indicates an 
error may have occured even when no errors occured.

- If the browser zoom level changes there is no way to 
change it back to default (CTRL +/- can now be used to 
change zoom level).


BUG FIXES IN RELEASE 2.34.18
---------------------------------------------------------

- The path optimizer generates incorrect paths in some 
rare scenarious.


BUG FIXES IN RELEASE 2.34.17
---------------------------------------------------------

- The change in 2.34.16 has been reverted since it 
casued problems in many other scenarious.


BUG FIXES IN RELEASE 2.34.16
---------------------------------------------------------

- The path optimizer generates incorrect paths in some 
rare scenarious.


BUG FIXES IN RELEASE 2.34.15
---------------------------------------------------------

- The Visual Web Ripper online updater downloads a wrong 
version of MySQL .NET connector.


BUG FIXES IN RELEASE 2.34.14
---------------------------------------------------------

- Visual Web Ripper fails to create new tables in MySQL 
if the tables already existed, but was later deleted.


BUG FIXES IN RELEASE 2.34.13
---------------------------------------------------------

- XPATHs functions with a non-existing XPATH as argument 
throws an error, but should just result in an empty 
selection.

- Visual Web Ripper now uses the latest version of 
MySql .NET connector (v6.2.2)

- Visual Web Ripper fails to create new tables in MySQL 
if the tables already existed, but was later deleted.


BUG FIXES IN RELEASE 2.34.12
---------------------------------------------------------

- Duplicate actions are not always recognised correctly 
in WebCrawler mode.


BUG FIXES IN RELEASE 2.34.11
---------------------------------------------------------

- The post-processing database helper API does not save 
text data in SQL Server in the correct format.


BUG FIXES IN RELEASE 2.34.10
---------------------------------------------------------

- Error setting OleDb input data source.


BUG FIXES IN RELEASE 2.34.9
---------------------------------------------------------

- Error dialog with no content pops up when compiling 
content scripts in the editor.


BUG FIXES IN RELEASE 2.34.8
---------------------------------------------------------

- If a scheduled project is terminated while running, 
the project status stays as running and the project 
cannot be edited.


BUG FIXES IN RELEASE 2.34.7
---------------------------------------------------------

- Visual Web Ripper will sometimes generate incorrect 
output data when flattening data if some data is missing.


BUG FIXES IN RELEASE 2.34.6
---------------------------------------------------------

- Several errors in the More options Window.


BUG FIXES IN RELEASE 2.34.5
---------------------------------------------------------

- Unable to select a specific design link if the link 
template is a sub-template of a page area template.

- custom Javascript overrides are not injected into 
web pages if default Javascript overrides are not injected.


BUG FIXES IN RELEASE 2.34.4
---------------------------------------------------------

- Error saving data to databases when two content 
elements in different templates have the same name. This 
error only occurs in some rare circumstances.


BUG FIXES IN RELEASE 2.34.3
---------------------------------------------------------

- Some cookies cause errors in WebCrawler mode.


NEW IN RELEASE 2.34.2
---------------------------------------------------------

- New option "Redirect on meta refresh" can be used to 
change default behaviour when the web browser encounters 
a refresh meta tag.


BUG FIXES IN RELEASE 2.34.1
---------------------------------------------------------

- Wrong page numbers when Using navigation sets in 
WebBrowser mode (combination of page area and next navigation).


NEW IN RELEASE 2.34.0
---------------------------------------------------------

- New data output options "Replace existing data" and 
"Add to existing data".

- Some options moved from the project options Window to 
the destination data source options Window.


BUG FIXES IN RELEASE 2.34.0
---------------------------------------------------------

- Unable to select suitable wait elements for form fields 
with AJAX actions.

- Selecting a template as an AJAX wait element does not 
always work.

- The content script type does not work correctly.


NEW IN RELEASE 2.33.18
---------------------------------------------------------

- New page attribute "Timestamp".


BUG FIXES IN RELEASE 2.33.17
---------------------------------------------------------

- Page numbers are incorrectly saved to output when 
flattening data in WebCrawler mode.


BUG FIXES IN RELEASE 2.33.16
---------------------------------------------------------

- Error submitting forms where some form fields have 
less values than a specified start index.

- The Copy/Move template Window doers not always populate 
parent template drop down.


NEW IN RELEASE 2.33.15
---------------------------------------------------------

- Minor WebCrawler parser update.


NEW IN RELEASE 2.33.14
---------------------------------------------------------

- Improvements to the "Make line breaks" option.


NEW IN RELEASE 2.33.13
---------------------------------------------------------

- Visual Web Ripper no longer opens up in a dialog style 
Window, which was causing some problems in 3rd party 
appliacations.


BUG FIXES IN RELEASE 2.33.12
---------------------------------------------------------

- Visual Web Ripper sometimes fail to load a webpage if 
the "Partial page load" option has been set.

- An error sometimes occur when selecting an empty input 
box.


BUG FIXES IN RELEASE 2.33.11
---------------------------------------------------------

- CSV output sometime contains an empty column with 
no values.


NEW IN RELEASE 2.33.10
---------------------------------------------------------

- New form field option "Design time value" can be used 
to easily set the input value used at design time.


BUG FIXES IN RELEASE 2.33.10
---------------------------------------------------------

- When extracting text from a link template, the text is 
also incorrectly saved for any following page navigation 
template.


BUG FIXES IN RELEASE 2.33.9
---------------------------------------------------------

- Optional form fields don't empty the output data 
entry when the form field is not found.


NEW IN RELEASE 2.33.8
---------------------------------------------------------

- New Capture type option "Siblings" can be used to 
include a specified number of HTML element siblings in 
HTML content.

- Events can now be specified for all template 
and form field actions.


BUG FIXES IN RELEASE 2.33.8
---------------------------------------------------------

- The web browser cookie is not always set correctly 
when downloading files in WebBrowser mode. This can cause 
issues especially with CAPTCHA images.


NEW IN RELEASE 2.33.7
---------------------------------------------------------

- New project option "Partial page load for entire project"
applies the "Partial page load" option to all templates in 
the project.


NEW IN RELEASE 2.33.6
---------------------------------------------------------

- New project option "Interactive document timeout".


NEW IN RELEASE 2.33.5
---------------------------------------------------------

- Minor user interface updates.


NEW IN RELEASE 2.33.4
---------------------------------------------------------

- User interface updates.

- Help file updates.


BUG FIXES IN RELEASE 2.33.3
---------------------------------------------------------

- Redirect templates don't always work correctly. 


BUG FIXES IN RELEASE 2.33.2
---------------------------------------------------------

- Setting the option "New web browser" opens a new web 
browser, but doesn't close the browser window again when 
running in debug mode. 


BUG FIXES IN RELEASE 2.33.1
---------------------------------------------------------

- The duplicate action "CancelDataTable" does not cancel 
page navigations. 


BUG FIXES IN RELEASE 2.33.0
---------------------------------------------------------

- Visual Web Ripper now locates frames by name rather 
than index. This solves some issues related to frames 
being created dynamically. Frame index is still used when 
a frame has no name or ID.


BUG FIXES IN RELEASE 2.32.4
---------------------------------------------------------

- File downloads do not redirect when required.


BUG FIXES IN RELEASE 2.32.3
---------------------------------------------------------

- Visual Web Ripper freezes in WebCrawler mode.


BUG FIXES IN RELEASE 2.32.2
---------------------------------------------------------

- Using an OleDb destination data source causes an error 
if the database tables already exist.


NEW IN RELEASE 2.32.1
---------------------------------------------------------

- New duplicate data option "Minimum CancelDataRow checks".


NEW IN RELEASE 2.32.0
---------------------------------------------------------

- New features for detecting duplicate data. Duplicate 
reference data is now saved to disk, so data already 
extracted in previous project runs can be ignored. When 
Visual Web Ripper detects duplicate data it can cancel
the current data row or it can cancel the entire data 
table. This behaviour can be fixed, or a special script 
can be used to decide if Visual Web Ripper should be 
cancelling the current data row or the data table.

- A condition script can now be set to cancel an element, 
a data row or an entire data table. Previously, a condition 
script could be set to cancel a template, but that 
description did not always match what actually happened.


NEW IN RELEASE 2.31.14
---------------------------------------------------------

- The visual editor now styles a maximum of 500 elements 
to increase performance for very large web pages.


BUG FIXES IN RELEASE 2.31.13
---------------------------------------------------------

- If scheduling is turned from on to off in a project and 
the project exists in the Schedule folder, the project is 
deleted instead of the scheduled version of the project.


BUG FIXES IN RELEASE 2.31.12
---------------------------------------------------------

- Visual Web Ripper does not add correct key columns to 
flat data output if some templates has been set to not 
flatten data.


NEW IN RELEASE 2.31.11
---------------------------------------------------------

- New filter "Must contain column header" can be used to 
select a table column with a specified header text. This 
is useful when the number of table columns varies.


BUG FIXES IN RELEASE 2.31.11
---------------------------------------------------------

- It is not possible to set a design value for "Select" 
form fields.


BUG FIXES IN RELEASE 2.31.10
---------------------------------------------------------

- Potential memory leak when using "Continuous page area" 
templates in WebCrawler mode.

- The template option "Extract text" does not work 
correctly.


NEW IN RELEASE 2.31.9
---------------------------------------------------------

- Output folder for files and images can now be specified.

- Output folders can now be specified in project 
preferences making it easier to set custom output folders 
when saving to a database.


BUG FIXES IN RELEASE 2.31.9
---------------------------------------------------------

- The option "Save file URL" does not work correctly.


BUG FIXES IN RELEASE 2.31.8
---------------------------------------------------------

- Xpath wildcards don't always work.

- Incorrect HTML syntax resulting in empty tag names 
causes xpath errors.


BUG FIXES IN RELEASE 2.31.7
---------------------------------------------------------

- Saving data can sometimes cause an error if template 
names contain blank spaces.

- Saving data to flat format can sometimes cause an error.

-The script content type has no associated help files.


NEW IN RELEASE 2.31.6
---------------------------------------------------------

- New content type "Script" can be used to execute a 
script anywhere within a template.


BUG FIXES IN RELEASE 2.31.6
---------------------------------------------------------

- When cancelling a content or template in the editor, 
the name and type don't change back to the original values.

- An error sometimes occur when navigating in 
InternetExplorer mode.

- Visual Web Ripper sometimes wait forever for pages to 
load.


BUG FIXES IN RELEASE 2.31.5
---------------------------------------------------------

- Upgraded projects don't work correctly.


NEW IN RELEASE 2.31.4
---------------------------------------------------------

- New option "Form submit links" uses form submits when 
following a links. only applicable in WebCrawler mode.


BUG FIXES IN RELEASE 2.31.4
---------------------------------------------------------

- Cookies are not set when submitting forms in WebCrawler 
mode.

- WebCrawler HTML parser updates.


BUG FIXES IN RELEASE 2.31.3
---------------------------------------------------------

- The online updater does not install the new script 
editor correctly causing numerous errors.


BUG FIXES IN RELEASE 2.31.2
---------------------------------------------------------

- Extracting link text from link templates does not always 
work in WebBrowser mode.

- Several issues adding assembly references in the new 
script editor.


BUG FIXES IN RELEASE 2.31.1
---------------------------------------------------------

- Non-repeating page area templates are processed even 
when the selection does not exist.


NEW IN RELEASE 2.31.1
---------------------------------------------------------

- Improved script editor.


NEW IN RELEASE 2.31.0
---------------------------------------------------------

- Primary keys, page numbers and start URL are now 
excluded from data output by default when flattening data.

- Form field values are no longer extracted by default. 
Form field text is still extracted by default.

- File and image URLs are no longer extracted by default 
when downloading files, and the file path column is now 
named the same as the content name.

New option "Sort order" can be used to order output data 
columns.


NEW IN RELEASE 2.30.11
---------------------------------------------------------

- New form field option "Optional". If a form field is 
optional, the form is submitted even if the form field 
is not found.


NEW IN RELEASE 2.30.10
---------------------------------------------------------

- New list feature "Skip last row count" can be used to 
skip a number of items at the bottom of a list. This 
option is similar to the "Start index" option, but works 
at the bottom of a list.


BUG FIXES IN RELEASE 2.30.10
---------------------------------------------------------

- All values in a drop down box are cancelled if the 
drop down box fails to fire an event. Visual web Ripper 
should move to the next value in the drop down box.


BUG FIXES IN RELEASE 2.30.9
---------------------------------------------------------

- Xpath preceding-sibling axis is not supported.

- Xpath count function is not supported.


NEW IN RELEASE 2.30.8
---------------------------------------------------------

- New form field option "Always fire events" fires 
form field events even when the form field value has not 
changed. 

- The option "Optional wait" is now available for 
form fields. This option has the same effect as the 
corresponding action option.


BUG FIXES IN RELEASE 2.30.7
---------------------------------------------------------

- The web crawler collector does not always redirect 
when required.


BUG FIXES IN RELEASE 2.30.6
---------------------------------------------------------

- The web crawler collector converts relative links on 
secure web sites to unsecure links, causing data extraction 
to fail.


BUG FIXES IN RELEASE 2.30.5
---------------------------------------------------------

- The new script option "Use HTML as regex input" is 
always applied to regex scripts.


NEW IN RELEASE 2.30.4
---------------------------------------------------------

- New script option "Use HTML as regex input". When this 
option is set, the raw HTML of an element is used as 
regex transformation input instead of the extracted 
content.


BUG FIXES IN RELEASE 2.30.3
---------------------------------------------------------

- The script editor sometimes causes the Visual Web Ripper 
application to crash or throw an error.


BUG FIXES IN RELEASE 2.30.2
---------------------------------------------------------

- The "Save template" option is sometimes automatically 
reset.


NEW IN RELEASE 2.30.1
---------------------------------------------------------

- Extracted data from one content element can now be used 
in a regex script for another element in the same 
template. The syntax is {$COLUMN_NAME} where COLUMN_NAME 
is the name of the content element.


NEW IN RELEASE 2.30.0
---------------------------------------------------------

- The expand and limit toolbar buttons now work on lists 
created using the context menu list feature.

- The "Partial page load" option can now be set on 
start URLs.

- The "Partial page load" timeout now starts from when 
a webpage enters "interactive" mode instead of from 
start of page load.

- Licensing changes. These changes apply to new customers 
only.


BUG FIXES IN RELEASE 2.30.0
---------------------------------------------------------

- Text filters containing the character "'" does not work 
properly.


BUG FIXES IN RELEASE 2.29.5
---------------------------------------------------------

- Help file update.


NEW IN RELEASE 2.29.4
---------------------------------------------------------

- Excluded values can now be specified for form select 
fields.


BUG FIXES IN RELEASE 2.29.4
---------------------------------------------------------

- The browser context menu does not work when the website 
has disabled the context menu.

- A page area template cannot be marked as optional.

- A missing required element does not always cause the 
current data row to be deleted.

- The visual designer does not always use the input 
data row set as design row.

The designer sometimes selects form field values that 
are not within the specified range.


NEW IN RELEASE 2.29.3
---------------------------------------------------------

- Content transformation is now always available in the 
"more" options tab. 


NEW IN RELEASE 2.29.2
---------------------------------------------------------

- Visual Web Ripper can now handle captcha forms. A window 
will appear when a captcha entry is required. The window 
will display the capcha image and a user must then 
manually enter the captcha code in order for 
Visual Web Ripper to proceed.

- new toolbar button "No page loads" allows projects to 
be edited without loading any web pages.


BUG FIXES IN RELEASE 2.29.1
---------------------------------------------------------

- The editor throws an error when moving back to a page 
area template and the the page area template is the first 
template in a project.

- The WebCrawler XPath parser does not decode some HTML 
characters correctly.


NEW IN RELEASE 2.29.0
---------------------------------------------------------

- The scheduler now uses the RunProject.exe utility to 
run projects. This means projects run in thier own process 
and can run concurrently.

- The RunProject utility now uses the email settings 
specified in the scheduler window. The email settings 
can be configured without turning on scheduling, allowing 
the use of custom schedulers while still taking advantage 
of the standard emailing features.


BUG FIXES IN RELEASE 2.28.11
---------------------------------------------------------

- The data source destination option "Clear output folder" 
incorrectly takes effect even when a database data source 
is selected.


BUG FIXES IN RELEASE 2.28.10
---------------------------------------------------------

- The online updater sometimes fail without displaying 
an error message.


BUG FIXES IN RELEASE 2.28.9
---------------------------------------------------------

- Some links opening a new named window don't work 
correctly in Visual Web Ripper.

- Some form fields are not set correctly in the designer.


BUG FIXES IN RELEASE 2.28.8
---------------------------------------------------------

- Sometimes old selections are not cleared when opening 
a template.


BUG FIXES IN RELEASE 2.28.7
---------------------------------------------------------

- The WebCrawler collector is sometimes failing when 
trying to set cookies.


BUG FIXES IN RELEASE 2.28.6
---------------------------------------------------------

- The toolbar button "Continue loading until manual stop" 
does not work.


BUG FIXES IN RELEASE 2.28.5
---------------------------------------------------------

- An incorrect data row is passed to scripts related to 
navigation templates.


NEW IN RELEASE 2.28.4
---------------------------------------------------------

- New project option "Inject javascript before page load" 
can be used to turn off injection of standard 
Visual Web Ripper javascripts. Some web pages cannot load 
properly with the injected javascripts.


NEW IN RELEASE 2.28.3
---------------------------------------------------------

- New form template feature "Download file on submit" can 
be used to download a file as a result of a form submit. 
This feature has no effect in WebBrowser mode.


BUG FIXES IN RELEASE 2.28.3
---------------------------------------------------------

- Cookies are not always set correctly in WebCrawler mode.


NEW IN RELEASE 2.28.2
---------------------------------------------------------

- New content option "Strip invalid XML" removes invalid 
XML characters from extracted content.


BUG FIXES IN RELEASE 2.28.1
---------------------------------------------------------

- The project option "Truncate existing database tables 
before saving data to a database" has no effect. Tables 
are always being truncated.

- Primary keys are not always generated correctly which 
can cause primary key violations when inserting data 
into database tables.

- The option "Data row cache" has no effect in WebCrawler 
mode.

- Data conversion error messages are not always displayed 
in the GUI.


NEW IN RELEASE 2.28.0
---------------------------------------------------------

- New toolbar button "Load webpage until manual stop" 
will keep loading a webpage until the stop button is 
clicked. This allows loading of webpages that reloads
after a time delay.

- The WebCrawler HTML parser no longer converts empty HTML 
tags to XHTML. This should make it easier to make content 
transformations, but it may break some existing 
transformations.


NEW IN RELEASE 2.27.6
---------------------------------------------------------

- New condition option "Cancel entire template (keep data 
row)" can be used to cancel a template but keep data that 
has already been extracted for the template.


BUG FIXES IN RELEASE 2.27.5
---------------------------------------------------------

- Not all input data rows are processed.


BUG FIXES IN RELEASE 2.27.4
---------------------------------------------------------

- Visual Web Ripper is unable to navigate links with 
certain onClick and HREF combinations.


BUG FIXES IN RELEASE 2.27.3
---------------------------------------------------------

- The new option "Do not flatten template" sometimes 
causes an error when viewing data.


NEW IN RELEASE 2.27.2
---------------------------------------------------------

- New window to monitor element values. This can be used 
to watch how element values change during AJAX actions.

- New template option "Do not flatten template" can be 
used to make sure specific template data is saved in 
a separate table even when the flatten data option is 
set to true.


NEW IN RELEASE 2.27.1
---------------------------------------------------------

- Rarely used options are now displayed in a separate 
option panel.


NEW IN RELEASE 2.27.0
---------------------------------------------------------

- New template and content option "Search all frames" 
will search for template or content xpaths in all 
frames, except the main document frame.


BUG FIXES IN RELEASE 2.27.0
---------------------------------------------------------

- Page area templates using row span don't always display 
correctly in the editor.


BUG FIXES IN RELEASE 2.26.19
---------------------------------------------------------

- Error running file transformation scritps in C# and 
VB.NET.


NEW IN RELEASE 2.26.18
---------------------------------------------------------

- File name transformation script can be used to rename 
file and image content.

- Updated introduction video.


NEW IN RELEASE 2.26.17
---------------------------------------------------------

- The data project methods RowCount and ChildTableRows 
now remove deleted rows from data tables before 
returning.


NEW IN RELEASE 2.26.16
---------------------------------------------------------

- Dupplicate checks now work across a whole data table.

- New Utility class "ScriptUtility" can be used in 
scripts.


BUG FIXES IN RELEASE 2.26.15
---------------------------------------------------------

- Minor corrections to the WebCrawler HTML parser.


BUG FIXES IN RELEASE 2.26.14
---------------------------------------------------------

- Visual Web Ripper will sometimes remove the first data 
column from data output if the project option 
"Include start URL in data output" is not selected.


BUG FIXES IN RELEASE 2.26.13
---------------------------------------------------------

- Software activation does not work correctly for some 
non-english languages.


BUG FIXES IN RELEASE 2.26.12
---------------------------------------------------------

- Visual Web Ripper is not set to save start URL by 
default.

- Output folder is not reset to default folder when 
switching from file output to database output.


BUG FIXES IN RELEASE 2.26.11
---------------------------------------------------------

- Minor bug fixes.


NEW IN RELEASE 2.26.10
---------------------------------------------------------

- Visual Web Ripper can now download and update the 
software automatically. You no longer have to uninstall 
your old version and then download and install the new 
version


NEW IN RELEASE 2.26.9
---------------------------------------------------------

- New AJAX option "Stay in page area after AJAX call".


BUG FIXES IN RELEASE 2.26.9
---------------------------------------------------------

- Page navigation and back templates do not pick up a 
default wait element if no wait element is specified.


NEW IN RELEASE 2.26.8
---------------------------------------------------------

- New element attribute "position" returns the position 
an HTML tag.


BUG FIXES IN RELEASE 2.26.7
---------------------------------------------------------

- Visual Web Ripper is crashing when upgrading a project.


BUG FIXES IN RELEASE 2.26.6
---------------------------------------------------------

- Syntax errors in default wait script.

- Help file updates.


BUG FIXES IN RELEASE 2.26.5
---------------------------------------------------------

- Unable to save a new project.


NEW IN RELEASE 2.26.4
---------------------------------------------------------

- If a project needs to be upgraded, then this will 
automatically occur when the project is run.


BUG FIXES IN RELEASE 2.26.4
---------------------------------------------------------

- The flatten data option sometimes does not flatten the 
data properly.


BUG FIXES IN RELEASE 2.26.3
---------------------------------------------------------

- Not all required parameters were parsed to condition 
scrtipts.

- Sometimes error windows pop up when using the script 
editor.


NEW IN RELEASE 2.26.2
---------------------------------------------------------

- CTRL can now be used to select elements in the browser 
instead of using the left mouse button. This can be used 
to prevent javascripts from executing when clicking on 
elements in the browser.

- SHIFT+ALT should now be used to activate the browser 
context menu in cases where the website has disabled the 
context menu.


BUG FIXES IN RELEASE 2.26.2
---------------------------------------------------------

- The comment part of a form input value would sometimes 
be removed.


NEW IN RELEASE 2.26.1
---------------------------------------------------------

- Input data transformation scripts can be used to 
transform form input values or generate new form input 
values.

- CTRL+ALT can be used to activate the browser context 
menu in cases where the website has disabled the context 
menu.


BUG FIXES IN RELEASE 2.26.1
---------------------------------------------------------

- Some OnClick events don't fire correctly.


NEW IN RELEASE 2.26.0
---------------------------------------------------------

- New improved script editor with intellisence.


BUG FIXES IN RELEASE 2.26.0
---------------------------------------------------------

- The flatten data option sometimes cause an error.


BUG FIXES IN RELEASE 2.25.6
---------------------------------------------------------

- Incorrect software activation.


BUG FIXES IN RELEASE 2.25.5
---------------------------------------------------------

- Software activation does not work correctly for some 
non-english languages.


BUG FIXES IN RELEASE 2.25.4
---------------------------------------------------------

- The following error sometimes occur when running a 
project "Access denied to file ...".


NEW IN RELEASE 2.25.3
---------------------------------------------------------

- The browser option "Show selection borders" now only 
colors borders and the main selected element. Child 
elements are not colored which makes this selection mode 
much faster.


BUG FIXES IN RELEASE 2.25.2
---------------------------------------------------------

- Error saving extracted data to XML.


BUG FIXES IN RELEASE 2.25.1
---------------------------------------------------------

- Switching between browser and web crawler mode causes a 
memory leak resulting in an "Out of memory" error when 
extracting data from large websites.


NEW IN RELEASE 2.25.0
---------------------------------------------------------

- New template option "Cache" is now vailable for list 
templates and form templates. The cache option specifies 
the number of elements to process before writing data to 
the data destination.

- New project option "Cache". The cache option specifies 
the number of input data rows or start URLs to process 
before writing data to the data destination.


BUG FIXES IN RELEASE 2.25.0
---------------------------------------------------------

- The following error may occur when extracting page 
attributes or fixed values: "Unexpected error: Index was 
out of range. Must be non-negative and less than the size 
of the collection. Parameter name: index".


BUG FIXES IN RELEASE 2.24.2
---------------------------------------------------------

- The scheduler window always show the scheduler interval 
as 1 no matter what value has actually been saved.


BUG FIXES IN RELEASE 2.24.1
---------------------------------------------------------

- A few users are encountering the error "Object 
synchronization method was called from an unsynchronized 
block of code".


NEW IN RELEASE 2.24.0
---------------------------------------------------------

- The "Save content" option now works slightly 
differently. If this option is unticked data will still 
be extracted and stored in memory, but it will not we 
saved to the destination data source. This allows data 
to be available for scripting without having to save 
the data to the destination data source.


BUG FIXES IN RELEASE 2.23.3
---------------------------------------------------------

- The new post-processing script feature did not work 
properly.


BUG FIXES IN RELEASE 2.23.2
---------------------------------------------------------

- Visual Web Ripper does not change the start URL when 
using the Visual Web Ripper browser to navigate to the 
start URL.


BUG FIXES IN RELEASE 2.23.1
---------------------------------------------------------

- Help file updates.


NEW IN RELEASE 2.23.0
---------------------------------------------------------

- Custom xpath functions.

- Post-processing scripts.

- Data can now be saved to a destination data source 
between each input data entry or start URL.


BUG FIXES IN RELEASE 2.23.0
---------------------------------------------------------

- Next page navigation does not work correctly in 
WebCrawler mode.


BUG FIXES IN RELEASE 2.22.1
---------------------------------------------------------

- Visual Web Ripper was relying on functionality in 
.NET 2 SP2, and would crash if none of the following 
framework versions were available 3.5 SP1, 3.0 SP2, 2.0 SP2.


BUG FIXES IN RELEASE 2.22.0
---------------------------------------------------------

- Visual Web Ripper can now extract new data to a database 
without having to truncate the data tables to avoid 
primary key violations.


BUG FIXES IN RELEASE 2.22.0
---------------------------------------------------------

- Visual Web Ripper sometimes stop execution because 
the software has not been properly activated.


BUG FIXES IN RELEASE 2.21.12
---------------------------------------------------------

- An error sometimes appear when switching to web crawler 
mode in the visual designer.

- The web crawler collector sometimes does not extract 
any data when a HTML document starts with <!DOCTYPE. 

- Documents starting with <!DOCTYPE sometimes get parsed 
incorrectly by the web crawler parser.


BUG FIXES IN RELEASE 2.21.11
---------------------------------------------------------

- Selected elements loose visual styling in the browser 
when using content transformation.

- Elements with a href attribute are not always 
recognised as a possible link element.

- Minor corrections to the web crawler HTML parser.


BUG FIXES IN RELEASE 2.21.10
---------------------------------------------------------

- Minor help file corrections.


NEW IN RELEASE 2.21.9
---------------------------------------------------------

- Custom javascripts can now be added in project 
preferences. These javascritps will override existing 
javascritps on a webpage.


NEW IN RELEASE 2.21.8
---------------------------------------------------------

- New destination data source option 
"Use default output folder" will force Visual Web Ripper 
to write all data output to the default Visual Web Ripper 
data output folder.

- Selecting an element in the tree view will now longer 
automatically select the corresponding element in the 
browser. A new tree view context menu allows you to make 
this selection.


BUG FIXES IN RELEASE 2.21.8
---------------------------------------------------------

- A link area page navigation template sometimes skip pages 
when combined with a single link page navigation 
template.


BUG FIXES IN RELEASE 2.21.7
---------------------------------------------------------

- Content and link transformation scripts using old 
method signature syntax would fail.


BUG FIXES IN RELEASE 2.21.6
---------------------------------------------------------

- Visual Web Ripper sometimes try to process a popup where 
there are no popup. This causes problems on some websites.


BUG FIXES IN RELEASE 2.21.5
---------------------------------------------------------

- The new script argument SharedDatabase fails when used 
with multiple web crawler threads.


BUG FIXES IN RELEASE 2.21.4
---------------------------------------------------------

- An error occurs when executing a script.


BUG FIXES IN RELEASE 2.21.3
---------------------------------------------------------

- Some images are missing in the help files.


BUG FIXES IN RELEASE 2.21.2
---------------------------------------------------------

- Some characters in template and content names cause 
errors when saving data to databases or Excel.

- Content transformation does not work on form fields in 
URL form templates.

- Select boxes don't always work correctly for form fields 
in URL form templates.


BUG FIXES IN RELEASE 2.21.1
---------------------------------------------------------

- Form template name is not saved when adding a form field 
content element.

- The web crawler parser is unable to parse HTML pages 
where the body tag contains other body tags.


NEW IN RELEASE 2.21.0
---------------------------------------------------------

- Condition scritps can now be used to cancel elements or 
entire templates when certain conditions are met.

- Condition options are now called filters.

- A database connection can now be defined for use in 
scripts.

- If SQL Server is chosen as destination data source and 
the sQL Server is version 2005 or higher, then text columns 
will be defined as nvarchar(max) instead of ntext.

- A manual list of start URLs can now be combined with an 
input data source. All data rows in the input data source 
will be cycled for each start URL.


NEW IN RELEASE 2.20.0
---------------------------------------------------------

- New option "Duplicate check" can be set on content 
elements to automatically remove duplicates.

- The data output folder can now be specified when configuring 
a destination data source.

- New option "Add time stamp to data output file".

- New option "Clear data output folder before extracting 
new data"


NEW IN RELEASE 2.19.8
---------------------------------------------------------

- New project option "Page load delay" can be used to set 
a default delay between page loads.

- MySql connector updated to the latest version.


BUG FIXES IN RELEASE 2.19.7
---------------------------------------------------------

- Some incorrect meta tag syntax may cause an error in 
Visual Web Ripper.

- If Visual Web Ripper cannot navigate to one link in a link 
template it may skip other links in the template.


BUG FIXES IN RELEASE 2.19.6
---------------------------------------------------------

- Javascripts are not always executed on the right frame 
when extracting data from a website containing frames.


BUG FIXES IN RELEASE 2.19.5
---------------------------------------------------------

- Some options cannot be set (this is a critical bug 
preventing normal operation of Visual Web Ripper).


BUG FIXES IN RELEASE 2.19.4
---------------------------------------------------------

- Help text corrections.


BUG FIXES IN RELEASE 2.19.3
---------------------------------------------------------

- "A Cryptographic error occurred" appears after upgrading 
to version 2.19.2.


BUG FIXES IN RELEASE 2.19.2
---------------------------------------------------------

- Visual Web Ripper does not always recognise a valid 
license key.

- Visual Web Ripper runs in 64bit mode on 64bit Windows 
causing some issues with flash.


BUG FIXES IN RELEASE 2.19.1
---------------------------------------------------------

- Webpages with a http-equiv refresh meta tag does not 
redirect when using the web browser collector.


NEW IN RELEASE 2.19.0
---------------------------------------------------------

- New template option "Disabled" can be used to exclude a 
template from processing. This can be useful for debugging 
purposes.


BUG FIXES IN RELEASE 2.19.0
---------------------------------------------------------

- Row span does not work if combined with a text condition.

- The "Save content" option does not reset when switching 
between content and template view.

- The attribute condition includes an incorrect style 
attribute. 


BUG FIXES IN RELEASE 2.18.0
---------------------------------------------------------

- Visual Web Ripper crashes when extracting data from 
websites with a large number navigation pages.

- Column names do not retain proper case in output data.

- Content, template and project names containing certain 
characters cause errors when saving data to a database.

- Webpage elements sometimes get marked as selected without 
being selected when switching between content and template 
view in a page area template.

- When editing a template and choosing "Select nearest link" 
from the visual editor's context menu, the template type 
automatically switches to Link, which is not always 
appropriate.

- A link template does not click on an element unless 
the element is a link tag or has an onclick property.


NEW IN RELEASE 2.17.10
---------------------------------------------------------

- When using an input data source, the data row used in 
design mode can now be specified in the "View Data" window.


NEW IN RELEASE 2.17.9
---------------------------------------------------------

- New FormField action option "Action on edit in design mode" 
allows you to specify if a form field should fire the 
onChange event when being edited in the designer.


BUG FIXES IN RELEASE 2.17.9
---------------------------------------------------------

- The direct form URL feature did not work correctly.


NEW IN RELEASE 2.17.8
---------------------------------------------------------

- When drop down boxes are extracted as text elements, 
both value and text are extracted. Select options are 
separated by line break, and value and text are separated 
by the character '|'.


BUG FIXES IN RELEASE 2.17.8
---------------------------------------------------------

- Opening a "Next page link" page navigation template in 
the visual editor should now always work correctly.

- The "Make line breaks" option did not work with P tags 
containing attributes.

- An input data source linked directly to a form template 
did not work correctly.


BUG FIXES IN RELEASE 2.17.7
---------------------------------------------------------

- Version 2.17.5 introduced a bug making it very 
difficult to set a value for input form elements.


NEW IN RELEASE 2.17.6
---------------------------------------------------------

- New page navigation type "Continuing link area" can be 
used when there is no "Next page" link and when the page 
navigation moves forward automatically when selecting 
pages in the nevigation. Google search is an example of 
such a navigation style, although Google search does 
have a next page link, which should be used when 
extracting data from Google search.

- CSV input data values can now be separated by comma, tab 
or semicolon.


BUG FIXES IN RELEASE 2.17.6
---------------------------------------------------------

- Some issues related to CSV input data files when used as 
lookup data sources.


BUG FIXES IN RELEASE 2.17.5
---------------------------------------------------------

- The debug window now shows a maximum of 200 lines of 
text. Projects extracting large amount of data could write 
so much debug information that the system would run out 
of memory.

- Repeated selections were not always optimized properly.


NEW IN RELEASE 2.17.4
---------------------------------------------------------

- Regex transformations can now replace with special 
characters "\r\n", "\n" and "\t".

- New regex transformation actions html_decode and trim.

- New capture type option "Make line breaks". This feature 
is available for text content type only and replaces P and 
BR tags with standard Windows line breaks.


NEW IN RELEASE 2.17.3
---------------------------------------------------------

- Visual Web Ripper no longer clears a current selection 
when switching between content and template view.

- The Create List context menu can now be selected in 
content view. Visual Web Ripper will automatically switch 
to template view when the menu item is selected.

- The "Save Point" option now works in web crawler mode, 
but only if the number of web crawler worker threads are 
set to 0.


BUG FIXES IN RELEASE 2.17.3
---------------------------------------------------------

- Text conditions containing the character ' would fail.


BUG FIXES IN RELEASE 2.17.2
---------------------------------------------------------

- Visual Web Ripper did not use appropriate proxy and cookie 
information when downloading files and images.

- Some minor issues related to the new "Create List" context 
menu.

- Character encoding was not set correctly for all websites 
when using the web crawler collector.


NEW IN RELEASE 2.17.1
---------------------------------------------------------

- A new regex content transformation operator "decode" can 
be used to URL decode content.


BUG FIXES IN RELEASE 2.17.1
---------------------------------------------------------

- Proper error messages are now displayed in the debug 
window when an eror occurs during download of files and 
images.


NEW IN RELEASE 2.17.0
---------------------------------------------------------

- A link linking directly to an image can now be specified 
as image content type.

- A list of selected elements can now be created by 
selecting one element, then hovering over another element and 
selecting create list from the context menu.

- Visual Web Ripper should now run as a 32 bit process on 
64 bit Windows. This should eliminate some potential 
issues on 64 bit Windows. This is a temporary solution that 
will be in place until we have a proper 64 bit testing 
environment for Visual Web Ripper.


BUG FIXES IN RELEASE 2.17.0
---------------------------------------------------------

- Content transformation was not activated for file and 
image content type if the content was empty.

- The web browser collector did not always navigate back 
to the right webpage when a template contained a 
page navigation template.


NEW IN RELEASE 2.16.8
---------------------------------------------------------

- A back template can now use browser history to move back 
if a back link does not exist.


BUG FIXES IN RELEASE 2.16.8
---------------------------------------------------------

- Start index and count properties would sometimes not 
work for flow repeat.


NEW IN RELEASE 2.16.7
---------------------------------------------------------

- New action option "Wait for interactive page load only". 
If this option is checked, then Visual Web Ripper will only 
wait until a webpage becomes interactive. This option 
is only useful for webpages that never loads completely 
(most likely because of javascript errors).


BUG FIXES IN RELEASE 2.16.7
---------------------------------------------------------

- A back template was incorrectly activated when skipping
a template.


BUG FIXES IN RELEASE 2.16.6
---------------------------------------------------------

- The context menus "Keep in Selection" and "Remove from 
Selection" were not always available when they should be.


NEW IN RELEASE 2.16.5
---------------------------------------------------------

- More HTML information in the visual designer context 
menu.


BUG FIXES IN RELEASE 2.16.5
---------------------------------------------------------

- Visual Web Ripper did not properly check for new 
releases.

- Startup page links did not work correctly.


BUG FIXES IN RELEASE 2.16.4
---------------------------------------------------------

- Switching to web crawler view in the visual designer 
could sometimes cause an error.


NEW IN RELEASE 2.16.3
---------------------------------------------------------

- Content transformation on file URLs now occurs before 
the files are downloaded. This allows you to modify the 
URL where a file should be downloaded from.

- New project option to save extracted files with their 
original file names. Notice: this can cause extracted 
files to be overwritten, so this option is turned off by 
default.


BUG FIXES IN RELEASE 2.16.2
---------------------------------------------------------

- Shift + left click did not work correctly to add new 
content or templates.


NEW IN RELEASE 2.16.1
---------------------------------------------------------

- The browser context menu in the visual designer now have 
menus to select parent and child elements of the currnet 
element.

- The Capture window now shows both value and text 
properties of select options.


BUG FIXES IN RELEASE 2.16.1
---------------------------------------------------------

- AJAX wait elements did not always work correctly for 
page navigation templates.

- Repeated selections that had been expanded would 
sometimes reset and lose the expansion.

- Selection paths are now updated before a content or 
template is saved, so a click on the Ok button in the 
options window is no longer required before a save.


NEW IN RELEASE 2.16.0
---------------------------------------------------------

- New "Back" template can be used to specify how to 
navigate back to the previous template.

- Scripting methods are now provided with information about 
current extracted data and the current project.

- Assembly references can be added to a project and are 
available to all scripts in the project.
- Many more debugging features.

- Template and content positions can now be moved up and 
down.

- A new web browser can now be opened to process link 
templates. This option applies to the web browser and 
Internet Explorer collectors only



BUG FIXES IN RELEASE 2.16.0
---------------------------------------------------------

- Onchange events did not always fire correctly.

- The row span feature did not always work correctly.


BUG FIXES IN RELEASE 2.15.6
---------------------------------------------------------

- The flatten data option for XLS and CSV output did not 
always work correctly.


NEW IN RELEASE 2.15.5
---------------------------------------------------------

- An error would occur if the licensing screen was closed 
without entering a license key.


NEW IN RELEASE 2.15.4
---------------------------------------------------------

- Visual Web Ripper new checks for new releases online at 
startup.


BUG FIXES IN RELEASE 2.15.3
---------------------------------------------------------

- The web crawler collector would sometimes save 
navigation data incorrectly causeing an error when trying 
to view extracted data.


NEW IN RELEASE 2.15.2
---------------------------------------------------------

- New page attributes "Head" and "HTML" extract the Head 
HTML and all HTML.


BUG FIXES IN RELEASE 2.15.1
---------------------------------------------------------

- The web crawler collector did not handle all forms 
of new windows correctly.


BUG FIXES IN RELEASE 2.15.0
---------------------------------------------------------

- The row span option was not working correctly.


BUG FIXES IN RELEASE 2.14.11
---------------------------------------------------------

- A recent optimization caused the input data source to 
work incorrectly when used for form fields.


NEW IN RELEASE 2.14.10
---------------------------------------------------------

- New feature to save all select options to a file.


BUG FIXES IN RELEASE 2.14.10
---------------------------------------------------------

- The view browser feature did not display progress 
correctly for all templates.

- The page load value was incorrect for the web browser 
collector.


NEW IN RELEASE 2.14.9
---------------------------------------------------------

- Some optimization to the web crawler collector.


BUG FIXES IN RELEASE 2.14.8
---------------------------------------------------------

- The Select Link Element context menu did not always 
work correctly.

- Next Page Navigation templates did not always work 
correctly when the next page link was an image.


NEW IN RELEASE 2.14.7
---------------------------------------------------------

- Configuration can now be set for CSV input data sources.

- The web crawler collector can now process start URLs 
in multiple threads.

- Flattern data now tries to save data into a single file 
or workbook.


NEW IN RELEASE 2.14.6
---------------------------------------------------------

- Some optimizations related to page area templates.


BUG FIXES IN RELEASE 2.14.6
---------------------------------------------------------

- The xpath method last() returned the last position + 1 
instead of the last position. All projects using the 
last() method must be modified to match this change.

- Some attribute conditions would work different in 
web crawler and web browser mode.


BUG FIXES IN RELEASE 2.14.5
---------------------------------------------------------

- Waiting for elements to load could sometimes cause an 
error.


BUG FIXES IN RELEASE 2.14.4
---------------------------------------------------------

- An installer error would occur on Windows Vista.


BUG FIXES IN RELEASE 2.14.3
---------------------------------------------------------

- Fixed a minor issues with new dialog boxes.


NEW IN RELEASE 2.14.2
---------------------------------------------------------

- Visual Web Ripper now asks for confirmation before 
automatically changing a repeated link element selection.


BUG FIXES IN RELEASE 2.14.1
---------------------------------------------------------

- Fixed some minor issues related to element selection.


NEW IN RELEASE 2.14.0
---------------------------------------------------------

- Visual Web Ripper now has two versions of the web 
browser collector. The Internet Explorer data collector 
is slow, but reliable. The web browser data collector is 
faster, but may become unstable on some websites with 
flash objects unless the project properly waits for flash 
objects to completely load.

- Visual Web Ripper will now automatically look for the 
nearest link or form submit element when creating a link 
or form submit template.


BUG FIXES IN RELEASE 2.13.8
---------------------------------------------------------

- The flattern data option works slightly different, and 
will now work on all extracted data.

- The option "Wait for element" did not work correctly 
unless a wait script was specified.

- Ajax wait elements did not work correctly if the elements 
were template elements with no inner text.

- Incorrect parsing of HTML in the web crawler collector.


BUG FIXES IN RELEASE 2.13.7
---------------------------------------------------------

- Frameset could sometimes cause errors in the web browser 
collector.


BUG FIXES IN RELEASE 2.13.6
---------------------------------------------------------

- Popup windows were not always handled correctly in the 
visual editor and web browser collector.

- A frame redirect now uses the frame's document URL 
instead of the src attribute. This only applies to the web 
browser collector.

- The "Visit each page only once" option did not work 
correctly in the web browser collector.


NEW IN RELEASE 2.13.5
---------------------------------------------------------

- Regex scripts now ignores case and line breaks. This 
makes it easier to transform HTML content.

- Regex scripts now support replace and multiple groups.

- Regex scripts can now contain multiple regex operations.


BUG FIXES IN RELEASE 2.13.4
---------------------------------------------------------

- The web browser collector now cancels immediately when 
the cancel button is clicked.

- Selection path syntax errors are now displayed in the 
visual editor, rather than just an empty selection.


BUG FIXES IN RELEASE 2.13.3
---------------------------------------------------------

- Selection templates did not work correctly in all 
situation.

- Missing help file for selection template options.


NEW IN RELEASE 2.13.2
---------------------------------------------------------

- New template type "Selection" can be used to add or 
remove elements from a template with a repeated selection.

- The selection xpath now supports union and exclusion 
operators.


BUG FIXES IN RELEASE 2.13.2
---------------------------------------------------------

- Ajax actions without a wait element did not work 
correctly.


BUG FIXES IN RELEASE 2.13.1
---------------------------------------------------------

- Some issues related to opening new browser windows.

- Some issues related to older projects using the old fast 
browsing options.

- Javascript errors can now be turned off in the visual 
editor


NEW IN RELEASE 2.13.0
---------------------------------------------------------

- The web browser collector now uses a true instance of 
Internet Explorer, which has greatly increased the 
reliabillity of the collector on all websites.

- The web browser collector now has a debug mode that 
shows the web browser while data is being extracted. 
Actions and extracted content is also being maked in the 
web browser while data is being extracted.


BUG FIXES IN RELEASE 2.12.7
---------------------------------------------------------

- HTML objects, such as flash videos, could sometimes 
cause the browser collector to become unstable over time 
and eventually crash. All HTML object elements are now 
removed from web pages.


NEW IN RELEASE 2.12.6
---------------------------------------------------------

- AJAX actions can now wait for elements deeper down the 
project hierarchy.

- New element option "Wait for element" will wait for the 
element to load. This simple wait condition could only be 
accomplished with a wait script in earlier versions.


BUG FIXES IN RELEASE 2.12.6
---------------------------------------------------------

- The form template options tab would sometimes show the 
redirect template options.

- The visual editor would not properly wait for wait 
element.


NEW IN RELEASE 2.12.5
---------------------------------------------------------

- The visual editor now shows a webpage while the webpage 
is being loaded.


BUG FIXES IN RELEASE 2.12.4
---------------------------------------------------------

- Form wait elements would not always work correctly.

- Trial version did not work.


NEW IN RELEASE 2.12.3
---------------------------------------------------------

- The link template option has been removed.

- Trailing spaces are now removed from select box text 
values.


BUG FIXES IN RELEASE 2.12.3
---------------------------------------------------------

- Link type content elements starting with javascript
could potentially cause a problem.


BUG FIXES IN RELEASE 2.12.2
---------------------------------------------------------

- Image file format should now be determined correctly on 
all image links.


BUG FIXES IN RELEASE 2.12.1
---------------------------------------------------------

- The visual editor would always ask to upgrade a project, 
even if the project did not need an upgrade.

- Some encoding issues have been fixed in the web crawler 
collector.


NEW IN RELEASE 2.12.0
---------------------------------------------------------

- New template action "AJAX with full page load" covers 
scenarious where a link activates an AJAX call that waits 
for a while and then loads a new page.


BUG FIXES IN RELEASE 2.12.0
---------------------------------------------------------

- Some web sites using frames were not loaded correctly.


NEW IN RELEASE 2.11.1
---------------------------------------------------------

- Some added and updated documentation.


NEW IN RELEASE 2.11.0
---------------------------------------------------------

- Improved navigation performance in the visual editor.

- Improved performace of the web browser collector.


BUG FIXES IN RELEASE 2.10.3
---------------------------------------------------------

- Cookies are not set correctly when using the web crawler 
collector.

- The scheduler are now sending out email notifications 
correctly


BUG FIXES IN RELEASE 2.10.2
---------------------------------------------------------

- A page navigation template now waits for an AJAX element 
to load in the visual designer.

- A "Next Page" page navigation template now stops if the 
next page element is hidden.


NEW IN RELEASE 2.10.1
---------------------------------------------------------

- A page navigation template can now be opened in the 
visual editor. This will open the next page in the 
navigation, or any selected page.


BUG FIXES IN RELEASE 2.10.1
---------------------------------------------------------

- The scheduler did not work correctly.


NEW IN RELEASE 2.10.0
---------------------------------------------------------

- Content and link transformation now supports regex.

- New xpath method ismatch matches against a regular 
expresion.

- Single element page navigation templates can now be set 
to visit each page only once.


BUG FIXES IN RELEASE 2.10.0
---------------------------------------------------------

- The repeated selection count property counted one too 
many elements.

- Optimization did not work correctly for parent flow 
repeat.

- Elements firing an event and placed in a particular 
frame would lose the frame information when edited.

- A project would sometimes behave incorrectly when 
running the project multiple times from the visual editor.


BUG FIXES IN RELEASE 2.9.5
---------------------------------------------------------

- Selection optimization did not always work correctly.

- Textarea and password form fields did not work correctly.


BUG FIXES IN RELEASE 2.9.4
---------------------------------------------------------

- The selection options "Keep element types in selection" 
and "Remove element types from selection" did not always 
work correctly.

- Switching from web browser to web crawler collector did 
not work correctly.


BUG FIXES IN RELEASE 2.9.3
---------------------------------------------------------

- Selection optimization did not work correctly.
- The web crawler collector did not extract page meta tags 
correctly.
- The internal HTML parser could sometimes throw an error.


BUG FIXES IN RELEASE 2.9.2
---------------------------------------------------------

- The "file" content option did not work properly.
- The internal xpath parser has been changed slightly.


NEW IN RELEASE 2.9.1
---------------------------------------------------------

- Condition elements are now colored in the visual editor.
- Page navigation templates of type "link area" and 
"next page link" can now be combined.


BUG FIXES IN RELEASE 2.9.1
---------------------------------------------------------

- Incorrect character encoding when submitting forms 
using the web crawler collector, and as a result some 
characters would appear as ???.


NEW IN RELEASE 2.9.0
---------------------------------------------------------

- The visual editor's context menu now includes options to 
include or exclude elements from a repeated selection 
based on thier class attribute.

- Attribute and text conditions are now set in different 
fields.

- AJAX wait scripts now also get an extra parameter 
specifying if the wait is optional.


BUG FIXES IN RELEASE 2.9.0
---------------------------------------------------------

- Several bug fixes related to page navigation templates.

- Setting the "Include attribute" option to "class" did 
not work correctly.


BUG FIXES IN RELEASE 2.8.2
---------------------------------------------------------

- Several bug fixes related to page navigation templates 
of link area type.


BUG FIXES IN RELEASE 2.8.1
---------------------------------------------------------

- Missing required elements are now logged at log level 1.

- When submitting a form, the visual editor will now only 
use drop down values that are part of the selected set of 
values.


NEW IN RELEASE 2.8.0
---------------------------------------------------------

- The output data structure has changed slightly to 
shorten table names.

- Skipped templates will now generate dummy data entries 
to ensure a consistent data output structure.

- Template names must now be unique within a project.


BUG FIXES IN RELEASE 2.7.2
---------------------------------------------------------

- Error when using the visual editor in navigation mode.


NEW IN RELEASE 2.7.1
---------------------------------------------------------

- A CSV file can now be used as input data source.

- Visual Web Ripper now displays a warning if the 
collector has missed required elements or if a page 
timeout has occured.

- A project will now be run for each row of data in the 
global data source, even if multiple starting URLs 
are not specified.


BUG FIXES IN RELEASE 2.7.1
---------------------------------------------------------

- Form fields could not be set to use a global data field.

- Javascript alert boxes are now properly blocked by the 
web browser collector.


NEW IN RELEASE 2.7.0
---------------------------------------------------------

- The toolbar now has a drop down where the active frame 
can be selected.

- AJAX wait scripts should now accept an IHTMLElement as 
argument instead of a HtmlElement. Existing scripts using 
a HtmlElement argument will get receive a null value.


BUG FIXES IN RELEASE 2.7.0
---------------------------------------------------------

- Frame redirects could sometimes cause an error in the 
visual editor.

- Fixed a minor styling issue in the visual editor.

- SSL starting URLs were not set correctly.

- Checkbox values should now be set correctly in the visual 
editor.


NEW IN RELEASE 2.6.11
---------------------------------------------------------

- Visual Web Ripper can now fire the onkeyup event on 
text boxes.


NEW IN RELEASE 2.6.10
---------------------------------------------------------

- A separate input data source can now be set for a form 
submit template.


BUG FIXES IN RELEASE 2.6.10
---------------------------------------------------------

- Changes to the internal HTML parser to avoid some HTML 
form issues.

- Forms were not always submitted correctly in the editor 
when in web crawler mode.

- The NOT operator was not recognised by the internal 
xpath parser.


NEW IN RELEASE 2.6.9
---------------------------------------------------------

- Several string functions added to the internal xpath 
parser (contains, substring, StartsWith, replace, remove, 
trim, length).

- Additional logging added to the web browser collector.

- The web browser collector will now try to recover from 
some webpage timeouts.


BUG FIXES IN RELEASE 2.6.9
---------------------------------------------------------

- The internal xpath parser did not recognise the != 
operator.


NEW IN RELEASE 2.6.8
---------------------------------------------------------

- A default cookie can now be set for the web crawler 
collector.


BUG FIXES IN RELEASE 2.6.8
---------------------------------------------------------

- A display issue on the processing status screen could 
cause errors.


NEW IN RELEASE 2.6.7
---------------------------------------------------------

- Three new repeat options. Vertical repeat is designed to 
repeat across rows in a table. Horizontal repeat is 
designed to repeat across cells in a table. Free repeat 
works as repeat in previous versions.

- A condition path no longer has to be a sub-path of the 
selected element.

- A condition attribute now applies to the condition path 
if a condition path is entered. The condition attribute 
applies to the selected alement if no condition path is 
entered.


BUG FIXES IN RELEASE 2.6.7
---------------------------------------------------------

- The condition sub-path option did not work correct.

- The repeat start index and count did not work correctly.


BUG FIXES IN RELEASE 2.6.6
---------------------------------------------------------

- Page navigation templates of link area type did not 
work correctly.


BUG FIXES IN RELEASE 2.6.5
---------------------------------------------------------

- Visual Web Ripper now fires both onchange and onclick 
events for Select boxes.

- The entered start URL is now used as start URL, instead 
of the resulting URL, which could be different in case of 
redirects.

- The internal HTML parser should now handle table 
headers correctly.

- Cookies should now be set correctly when using the 
editor in web crawler mode.

- The page load timeout project option now applies to both 
the web browser and web crawler collector


BUG FIXES IN RELEASE 2.6.4
---------------------------------------------------------

- Fixed some issues when having templates within page 
area templates.


BUG FIXES IN RELEASE 2.6.3
---------------------------------------------------------

- Fixed an issue with the internal HTML parser, which 
would sometimes return an empty page if the page had some 
particular incorrect HTML syntax.


NEW IN RELEASE 2.6.2
---------------------------------------------------------

- A list of anonymous proxy servers can now be added for 
use with the web crawler collector.


BUG FIXES IN RELEASE 2.6.2
---------------------------------------------------------

- A few fixes related to cascading AJAX drop down boxes 
in design mode.


BUG FIXES IN RELEASE 2.6.1
---------------------------------------------------------

- The selection path of elements within a page area 
template would not get optimized correctly.

- A page navigation template could in care cases cause 
an infinite loop.


NEW IN RELEASE 2.6.0
---------------------------------------------------------

- Visual Web Ripper now uses proper XPath as selection 
paths. Older projects must be upgraded to use the new 
selection path syntax.

- The Visual Web Ripper HTML parser has been improved to 
better handle invalid HTML syntax.


BUG FIXES IN RELEASE 2.6.0
---------------------------------------------------------

- Several fixes related to lookup data sources.


NEW IN RELEASE 2.5.11
---------------------------------------------------------

- The Visual Web Ripper HTML parser usded for the fast 
web crawler collector has been modified slightly. This may 
require some projects using this collector to be adjusted 
slightly.


BUG FIXES IN RELEASE 2.5.11
---------------------------------------------------------

- The flatten data feature did not work correctly for all 
projects.

- The frame redirect did not work correctly for all 
web sites.

- The Visual Web Ripper editor sometimes showed a green 
element status in web crawler mode, even when the web 
crawler was unable to locate the element.


NEW IN RELEASE 2.5.10
---------------------------------------------------------

- The Visual Web Ripper editor can now show web pages in 
web browser or web crawler mode. This makes it much easier 
to create a project for use with the web crawler collector 
when the target website contains poorly formatted HTML.


NEW IN RELEASE 2.5.9
---------------------------------------------------------

- A new template type "Redirect" can be used to redirect to 
a fixed URL or to a particular frame on a webpage.


BUG FIXES IN RELEASE 2.5.9
---------------------------------------------------------

- The flatten data feature did not work correctly for all 
projects.


NEW IN RELEASE 2.5.8
---------------------------------------------------------

- The fast web crawler collector can now login and 
maintain state information between web pages.


BUG FIXES IN RELEASE 2.5.8
---------------------------------------------------------

- The web browser collector would sometimes be unable to 
extract data from a page area template if the web page 
contained severe syntax errors.


NEW IN RELEASE 2.5.7
---------------------------------------------------------

- Link transformation scripts can now be used to transform 
links when using the web crawler collector.


NEW IN RELEASE 2.5.6
---------------------------------------------------------

- The number of web crawler worker threads can now be set 
in the project preferences screen.


BUG FIXES IN RELEASE 2.5.6
---------------------------------------------------------

- Some URLs would be constructed incorrectly causing an 
error when using the web crawler collector.


NEW IN IN RELEASE 2.5.5
---------------------------------------------------------

- The AJAX options tab has been renamed to Action, and 
now allows you to set wait conditions for full page loads. 
This can be useful when an AJAX call is triggered 
immediately after a page has loaded.

- Visual Web Ripper can now load URLs with combinations of 
different URL parameter values. This works like submitting 
a normal form, but a form is never actually submitted. 
Instead the form field values are put directly on the URL 
and the page is loaded. This increases performance and 
makes it possible to avoid forms that are difficult to 
submit automatically. This does not work for forms posting 
values to the website (using the POST method).


BUG FIXES IN RELEASE 2.5.4
---------------------------------------------------------

- Form fields with a list of fixed values would only use 
the first value when submitting forms.

- Visual Web Ripper would sometimes throw an error when 
a license key was entered.


BUG FIXES IN RELEASE 2.5.3
---------------------------------------------------------

- Empty tables would sometimes be added when using page 
navigation templates.

- A full page load incorrectly marked as an AJAX call 
would sometimes cause an error.


BUG FIXES IN RELEASE 2.5.2
---------------------------------------------------------

- Several fixes related to submitting forms automatically.

- Link type templates will now look for a refresh meta tag 
and redirect if appropriate when opened.


NEW IN RELEASE 2.5.1
---------------------------------------------------------

- Link type content will now try to extract links obscured 
by javascript.


NEW IN RELEASE 2.5.0
---------------------------------------------------------

- Wait conditions can now be scripted for all elements. 
This is useful when AJAX causes elements to load delayed.

- Visual Web Ripper can now handle cascading AJAX drop 
down boxes.

- MySQL is now supported as input or destination data 
source.

- Data output files are now named according to the project 
name instead of the generic name collected_data.


BUG FIXES IN RELEASE 2.5.0
---------------------------------------------------------

- A form field that triggers a full postback would cause 
an error when saving the content element in the designer.

- Form field count would count one element too much.

- Several issues related to form field AJAX events have 
been fixed.

- The CSV data destination option could not be set.

- The URL used when opening a template was not always 
correct


NEW IN RELEASE 2.4.0
---------------------------------------------------------

- The expand and limit selection buttons will now continue 
to expand or limit a repeated selection until the number 
of selected elements has changed. Before, you would 
sometimes have to press the buttons repeatedly to get the 
desired effect.

- AJAX wait conditions can now be scripted.

- The System.Web.dll is now loaded into the script 
processor by default.


BUG FIXES IN RELEASE 2.4.0
---------------------------------------------------------

- Extracted data could not be viewed when certain data 
entries were missing.

- MailTo links are now correctly recognised as emails.

- The characters // would cause a problem when used in a 
condition string.


NEW IN RELEASE 2.3.7
---------------------------------------------------------

- A link type content with redirect now looks for both 
the redirect response code and the refresh meta tag, when 
extracting the final URL.


NEW IN RELEASE 2.3.7
---------------------------------------------------------

- A page area template can now be set to wait until loaded. 
This is in case a webpage area is loaded delayed with AJAX.


BUG FIXES IN RELEASE 2.3.7
---------------------------------------------------------

- Several issues related to AJAX page navigation have been 
fixed.

- Non-existing repeated page area elements would cause an 
error in the data viewer. Data would still be extracted 
and saved correctly.


NEW IN RELEASE 2.3.6
---------------------------------------------------------

- Custom content transformation scripts can be added in 
C# or VB.NET.


NEW IN IN RELEASE 2.3.5
---------------------------------------------------------

- It is now possible to post-process before or after data 
has been saved to the selected destination data source.

- A new window is available that shows the tree view of 
how the web crawler sees a webpage. This can be used to 
find inconsistencies between how the web browser and the 
web crawler read a webpage when the webpage contains 
invalid HTML.


BUG FIXES IN RELEASE 2.3.5
---------------------------------------------------------

- Non-repeating, Non-existing page area templates would 
cause data extraction to skip elements and save incorrect 
data.

- The web crawler data collector would not work if a URL 
contained the character '/' in the query strings.


BUG FIXES IN RELEASE 2.3.4
---------------------------------------------------------

- A few bug fixes related to the input data source 
functionality.


BUG FIXES IN RELEASE 2.3.3
---------------------------------------------------------

- When running a project the progress bar would sometimes 
start before actually running the project.

- After running a project once, an error would occur if the
next run processed more pages than the first run.

- Inner HTML content type was not extracted correctly using 
the web crawler collector.


NEW IN RELEASE 2.3.2
---------------------------------------------------------

- A list of starting URLs can now be entered on the 
project preferences screen.

- When retrieving the starting URLs from a database, the 
url column name can now be set, and does not have to be 
named URL"

- The input data source can now be a SQL Server database 
or any other database supporting OleDb


- The default locatio All output data, projects and 
post-processors are now saved to


BUG FIXES IN RELEASE 2.3.2
---------------------------------------------------------

- Visual Web Ripper can now run on Windows Vista with 
User Access Control turned on without having to run as
administrator

- Several bug fixes related to the input data source 
functionality.
